2006-12-12 09:00  castaglia

	* NEWS, contrib/dist/rpm/proftpd.spec, include/version.h: 
	Preparing for 1.3.1rc1 release.

2006-12-12 08:52  castaglia

	* RELEASE_NOTES: 
	Finish polishing up these release notes.

2006-12-12 08:34  castaglia

	* NEWS, src/ctrls.c: 
	Bug#2867 - Local authorized user buffer overflow in Controls
	request handling.

2006-12-11 15:11  castaglia

	* src/var.c: 
	Handle the case where the retrieved variable is NULL.

2006-12-11 14:42  castaglia

	* modules/mod_ls.c: 
	More pedantic checks for NULL pointers.

2006-12-11 14:40  castaglia

	* contrib/mod_sql.c: 
	Use pr_log_debug() to handle cases where the database-specific SQL
	backend module is chosen, as a SQLLogFile may not have been opened
	at the time of backend selection.

2006-12-11 13:45  castaglia

	* doc/howto/TLS.html: 
	Add a mod_tls FAQ about linker errors related to libdl.

2006-12-11 12:06  castaglia

	* modules/mod_core.c: 
	More safety checking of possibly NULL return values.

2006-12-11 11:58  castaglia

	* modules/mod_core.c: 
	Move the check for a NULL path earlier, before we actually try to
	use path by calling pr_fsio_fstat() on it.

2006-12-11 11:53  castaglia

	* src/log.c: 
	Handle a possible return value of NULL from localtime(3).

2006-12-11 11:05  castaglia

	* src/fsio.c: 
	Check for NULL return values from strdup(3).

2006-12-11 10:59  castaglia

	* src/dirtree.c: 
	Paranoid checks for NULL pointers, to ensure we don't accidentally
	pass them to library functions (e.g. strstr(3) or substr(3)).

2006-12-11 09:07  castaglia

	* src/trace.c: 
	Off by one.

2006-12-11 09:03  castaglia

	* src/fsio.c, modules/mod_ls.c, modules/mod_site.c: 
	Off by one.

2006-12-11 00:20  castaglia

	* lib/glibc-glob.c: Paranoid null pointer check.  Useful, since we
	do use the ALTDIRFUNC flag.

2006-12-11 00:12  castaglia

	* src/fsio.c: Make sure pr_fs_dircat() doesn't attempt to operate
	on NULL pointers.

2006-12-11 00:02  castaglia

	* modules/mod_log.c: More insurance that a possible NULL value
	isn't passed to a library call, e.g. strftime(3).

2006-12-10 23:59  castaglia

	* modules/mod_log.c: Ensure we don't inadvertently attempt to
	lookup a NULL environment variable name, or copy a NULL environment
	variable value.

2006-12-10 23:55  castaglia

	* src/trace.c: Paranoid check for improper indices into the
	allocated buffer.

2006-12-10 23:52  castaglia

	* src/support.c: Ensure that we don't accidentally go past the end
	of the allocated array.

2006-12-10 23:40  castaglia

	* modules/mod_site.c: Another possible negative array index catch.

2006-12-10 23:37  castaglia

	* modules/mod_ls.c: Catch another possible situation where the
	index used may inadvertently be -1.

2006-12-10 23:21  castaglia

	* src/fsio.c: Pedantically fix some edge cases where an index of -1
	might accidentally be used.

2006-12-07 09:18  castaglia

	* src/main.c: 
	I think that the majority of sites don't use Classes so much, so
	move the log message about connections from unknown classes up a
	few debug log levels.

2006-12-06 16:10  castaglia

	* modules/mod_ls.c: 
	If sorting of directory listings by file name is requested, and NLS
	support is enabled, be sure to use the locale-sensitive strcoll(3)
	function for comparison, rather than strcmp(3).

2006-12-06 10:56  castaglia

	* configure: 
	Updated configure.

2006-12-06 10:55  castaglia

	* config.h.in, configure.in, include/conf.h: 
	NLS support requires checking for the locale.h header, and
	including it if necessary.

2006-12-05 21:15  castaglia

	* doc/howto/DisplayFiles.html: 
	Renamed DisplayFirstChdir to DisplayChdir, and added mention of the
	new DisplayFileTransfer.

2006-12-05 20:29  castaglia

	* include/display.h, src/display.c: 
	Add the ability to display files via filehandles, using
	pr_display_fh(), in addition to displaying files via paths using
	pr_display_file().
	
	Why would we want pr_display_fh()?  Many sites, especially those
	with lots of users, like DisplayLogin, but they also want to chroot
	their users.  The handling of DisplayLogin could be changed to open
	a filehandle prior to the chroot, if necessary, and thus continue
	to display a file whilst allowing chrooted users.  That's the goal,
	anyway.

2006-12-05 20:22  castaglia

	* src/display.c: 
	Use tracing, rather than debug level 10, for logging about
	unresolved variables in Display files.

2006-12-05 20:21  castaglia

	* src/trace.c: 
	Add a default trace channel for logging from the Variables API
	layer.

2006-12-05 20:05  castaglia

	* lib/sstrncpy.c: 
	Include the library support header libsupp.h, at least, since that
	is what its purpose is.

2006-12-05 19:57  castaglia

	* lib/sstrncpy.c: 
	No need to pull in all of proftpd's configuration for sstrncpy().

2006-12-05 13:44  castaglia

	* contrib/mod_wrap2/mod_wrap2.c: 
	More updates to the current APIs.

2006-12-05 12:05  castaglia

	* contrib/: mod_ban.c, mod_wrap2/mod_wrap2.c: 
	Updating mod_ban, mod_wrap2 to use newer module API names and
	macros.

2006-12-05 11:00  castaglia

	* include/log.h: 
	Use GCC pragmas for checking callers of pr_log_writefile() as well.

2006-12-05 10:54  castaglia

	* modules/mod_ls.c: 
	Since the sendline() arguments were giving us such trouble, I
	decided to make use of GCC's attribute pragma to warn about
	printf-like functions, as is done in other places in the proftpd
	code (e.g. the Response API header).

2006-12-05 09:47  castaglia

	* src/support.c: 
	Typo.

2006-12-05 09:44  castaglia

	* src/trace.c: 
	Add 'data' as one of the built-in trace channel names.

2006-12-04 17:07  castaglia

	* contrib/mod_tls.c: 
	Add some comments reminding me why I see gibberish in the debug
	logging, depending on the mod_tls configuration.

2006-12-04 14:33  castaglia

	* contrib/mod_tls.c: 
	Rather than logging when CRLs have not been configured, log when
	CRLs *are* present and being used.

2006-12-04 14:31  castaglia

	* contrib/mod_tls.c: 
	More paranoia.	Also some minor style changes.

2006-12-04 14:16  castaglia

	* contrib/mod_tls.c: 
	Increase the size of the buffer used to log X509 names from the
	client cert to 1KB
	
	If the client certificate cannot be verified because of an invalid
	purpose, log the purposes of the client certificate.

2006-12-04 13:56  castaglia

	* contrib/mod_tls.c: 
	X509_STORE_CTX_init() did not return a value in versions of OpenSSL
	prior to 0.9.7.
	
	Also conditionalize the use of the tls_crypto_device variable as
	per supporting OpenSSL version.

2006-12-04 11:31  castaglia

	* modules/mod_ls.c: 
	Correct one case where sendline() was being called with two format
	parameters but only one argument (led to garbage being sent to
	client in directory listing).  Also, make sure that all callers of
	sendline() use NULL as the last argument, as is proper for any
	variadic function.

2006-12-04 11:27  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2862 - NLST / returns a listing of the current directory.

2006-12-04 11:24  castaglia

	* modules/mod_ls.c: 
	More paranoia.	Make sure that the length returned from readlink()
	isn't too large for our buffers.

2006-12-04 11:11  castaglia

	* src/support.c: 
	More defensive checking of input arguments, in pr_memscrub() and
	sstrcat().

2006-12-04 10:25  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2863 - LIST of nonexistent file causes RST on data channel.  As
	with a similar issue with the NLST command, make sure the data
	channel is opened before closing it, lest the client receive a RST
	on their end of the data channel.

2006-12-04 10:07  castaglia

	* locale/Makefile.in: 
	Be more specific about the language support right now: en_US
	instead of en.

2006-12-01 19:26  castaglia

	* RELEASE_NOTES: 
	More release notes.

2006-12-01 19:17  castaglia

	* doc/contrib/mod_sql.html: 
	Document the SQLOptions directive.

2006-12-01 18:24  castaglia

	* locale/Makefile.in: 
	Don't forget to include the step that actually compiles a .po into
	a machine-readable .mo file.  The .mo file is what will be
	installed into the locale/ directory, and used by the gettext
	library.

2006-12-01 18:13  castaglia

	* modules/mod_lang.c: 
	Call bindtextdomain(3), using the configured LangPath (or
	PR_LOCALE_DIR if not configured), in order to use the translated
	message catalogs for proftpd there.

2006-12-01 17:08  castaglia

	* RELEASE_NOTES: 
	More documentation for the release notes.

2006-12-01 16:06  castaglia

	* configure: 
	Updating configure.

2006-12-01 15:46  castaglia

	* Make.rules.in, Makefile.in, configure.in: 
	Only try to build the locale-related message catalogs etc if the
	--enable-nls configure option is used.

2006-12-01 15:42  castaglia

	* RELEASE_NOTES: 
	Start adding more substance to the release notes, in preparation
	for a release.

2006-12-01 11:33  castaglia

	* locale/Makefile.in: 
	Make errors with creating translation catalogs non-fatal during the
	build process.

2006-12-01 11:29  castaglia

	* locale/: Makefile.in, files.txt: 
	More work on the Makefile for generating the template message
	catalog for translation.

2006-11-30 14:31  castaglia

	* contrib/ftpquota: 
	If opening a quota table for displaying records only, open the
	table in read-only mode, rather than read-append mode.

2006-11-30 10:06  castaglia

	* src/ftpdctl.c: 
	Return a value, since the function definition requires it.

2006-11-29 09:08  castaglia

	* contrib/mod_radius.c: 
	Make sure that the attribute length for UIDs and GIDs does not
	exceed the size of the variable used for holding the UID and GID.

2006-11-28 20:13  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2860 - Failure to check for data length in mod_tls could lead
	to remote buffer overwriting.
	
	(Also add entry for Bug #2858.)

2006-11-28 19:47  castaglia

	* contrib/mod_tls.c: 
	Prevent some possible NULL pointer dereferences by checking for
	tls_pkey before using it.
	
	Use root privileges when checking for the existence of certificate
	and key files, during the config handler runs.	These files are
	opened with root privs later in the module, so the checks for the
	existence should also use root privs.

2006-11-28 19:29  castaglia

	* contrib/mod_radius.c: 
	Fix typo in declaration of static MD5_Update() function.
	
	Also add paranoid check for size of attribute length, in RADIUS
	packet, which exceeds the maximum size of the data type.

2006-11-28 11:37  jwm

	* src/support.c: use the version that was released as part of
	1.3.0a; these integer "overflows" aren't exploitable, so there is
	no prophylactic difference

2006-11-27 06:49  jwm

	* src/support.c: Bug #2858 - CVE-2006-5815: remote code execution
	in ProFTPD

2006-11-17 15:42  jwm

	* src/main.c: - avoid passing a NULL pointer to pr_log_pri() as it
	can causes segfaults   on some platforms.  - make the 'invalid
	CommandBufSize' error message a litle  clearer

2006-10-31 19:12  castaglia

	* lib/glibc-glob.c: 
	Catch a few cases, from code borrowed from glibc, where the return
	value from realloc(3) was not being checked to see if it's NULL
	before using it.

2006-10-31 19:11  castaglia

	* lib/sstrncpy.c, src/support.c, utils/misc.c: 
	Prevent sstrcat() and sstrncpy() from working on buffers if the
	length argument is zero.

2006-10-31 18:36  castaglia

	* modules/mod_ls.c: 
	Since readlink(2) is not guaranteed to NUL-terminate the provided
	buffer, we need to save space for the NUL terminator.

2006-10-31 18:35  castaglia

	* src/netio.c: 
	Require that callers of pr_netio_gets() and pr_netio_telnet_gets()
	specify a non-zero buffer length.

2006-10-31 18:34  castaglia

	* lib/pwgrent.c, modules/mod_auth_file.c: 
	Check if realloc(3) returned NULL or not before blindly assigning
	the return value to our pointer.

2006-10-31 14:49  castaglia

	* src/main.c: 
	Fix an issue where the cmd_buf_size variable, for the size of the
	buffer used for reading FTP commands sent by clients, was not being
	properly set to the size configured via the CommandBufferSize
	directive.

2006-10-30 14:07  castaglia

	* doc/howto/SQL.html: 
	Add an example of using Python to generate an OpenSSL-encoded
	mod_sql password string.

2006-10-25 09:05  castaglia

	* src/ftpdctl.c: 
	Add stub for pr_trace_msg(), so that linking ftpdctl does not fail.

2006-10-24 10:47  castaglia

	* src/event.c: 
	Allocate a larger event pool (ref Bug #2850).

2006-10-24 09:43  castaglia

	* NEWS, src/pool.c: 
	Bug#2850 - Small event pool allocation on 64-bit machine leads to
	segfault on startup.  See the bug report for an excellent analysis
	of the issue.

2006-10-24 09:13  castaglia

	* src/: ctrls.c, event.c: 
	Add tracing of when control action handlers and event handlers are
	registered and unregistered.

2006-10-23 19:40  castaglia

	* contrib/mod_ban.c: 
	Update the mod_ban module to be better behaved as a shared module.

2006-10-23 19:32  castaglia

	* src/trace.c: 
	Be sure to set the trace table pointer to NULL after clearing the
	pool from which it was allocated.

2006-10-23 18:34  castaglia

	* contrib/mod_wrap2/: mod_wrap2.c, mod_wrap2.h.in: 
	Updated mod_wrap2 to be better behaved when compiled as a shared
	module.

2006-10-19 19:18  jwm

	* contrib/mod_ldap.c: add much more extensive debugging output

2006-10-13 08:00  castaglia

	* src/parser.c: 
	Treat a trailing LF as the eol marker; no need to treat any CRs
	before that LF as eol markers.

2006-10-13 07:53  castaglia

	* src/parser.c: 
	Typo.

2006-10-13 07:51  castaglia

	* src/parser.c: 
	If we don't find an end-of-line marker (LF or CRLF) in the line of
	configuration data read in, issue a warning, so that the admin
	knows that any configuration error may be caused by data
	truncation.

2006-10-11 09:47  castaglia

	* doc/modules/mod_facl.html: 
	Add small doc for the mod_facl module.

2006-10-11 09:37  castaglia

	* RELEASE_NOTES, modules/mod_facl.c: 
	Add a runtime directive for disabling mod_facl, if needed.

2006-10-05 11:01  castaglia

	* src/parser.c: 
	Style cleanup.	Sprinkle more "pr_signals_handle()" around within
	the while loops, too.

2006-10-05 10:57  castaglia

	* NEWS, src/parser.c: 
	Bug#2848 - Unable to properly parse config files using
	Windows-style line endings.

2006-10-04 14:06  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2847 - HiddenStores files not properly removed if data transfer
	times out.

2006-09-29 09:41  castaglia

	* RELEASE_NOTES: 
	A little more about UseIPv6, and the command-line options.

2006-09-29 09:38  castaglia

	* NEWS, RELEASE_NOTES, include/netaddr.h, modules/mod_core.c,
	src/bindings.c, src/dirtree.c, src/inet.c, src/main.c,
	src/netacl.c, src/netaddr.c, src/proftpd.8.in: 
	Bug#2817 - Ability to disable IPv6 support at runtime.

2006-09-27 08:58  castaglia

	* src/main.c: 
	Reset the handler for the SIGUSR2 signal (and NOT the SIGHUP
	signal) in the sig_evnt() handler.

2006-09-18 09:55  castaglia

	* configure: 
	Updating configure.

2006-09-18 09:48  castaglia

	* Makefile.in, configure.in, locale/Makefile.in: 
	Renaming the po/ directory to locale/.

2006-09-14 11:02  castaglia

	* NEWS, src/fsio.c: 
	Bug#2842 - Filesystem statcache is not correctly caching return
	value of stat().

2006-09-13 13:49  castaglia

	* configure: 
	Updated configure.

2006-09-13 13:32  castaglia

	* Makefile.in, configure.in: 
	Start of a po/Makefile, for building .po files (localised message
	strings).  Part of the support for RFC2640.

2006-09-11 19:38  castaglia

	* modules/mod_auth.c: 
	If MaxLoginAttempts is exceeded, mention in the generated log
	message that we are refusing the client's connection.

2006-09-11 18:31  castaglia

	* doc/contrib/mod_sql.html: 
	Remove mention of SQLHomedirOnDemand, as that directive is now
	deprecated.

2006-09-11 17:51  castaglia

	* NEWS, RELEASE_NOTES: 
	There is no 'SQLWhereClause' directive.  Oops.

2006-09-11 17:48  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sql.c: 
	Bug#2828 - Support variables in SQL Where directives.

2006-09-11 14:58  castaglia

	* doc/contrib/mod_sql.html: 
	Document the syntax for refering to environment variables in a
	SQLNamedQuery.

2006-09-11 14:52  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sql.c: 
	Bug#2799 - SQLNamedQuery should support environment variables.

2006-09-11 11:42  castaglia

	* doc/contrib/mod_tls.html: 
	Add documentation for the new TLSPassPhraseProvider directive.

2006-09-11 11:33  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_tls.c: 
	Bug#2756 - Support for TLSPassPhraseProvider.

2006-09-11 11:30  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2839 - ProFTPD seems to re-read the file two times in RETR
	command.

2006-09-11 10:58  castaglia

	* configure: 
	Updating configure.

2006-09-11 10:55  castaglia

	* Make.rules.in, Makefile.in, config.h.in, configure.in: 
	Add support for a PR_LOCALE_DIR, which will contain the localised
	string files for different locales.  The location of this directory
	can be set, at compile-time, using the --datadir configure option. 
	Run-time configuration of this path is done using mod_lang's
	LangPath directive.

2006-09-08 18:15  castaglia

	* README.modules, doc/modules/mod_lang.html: 
	Add mostly-done documentation for mod_lang module, and mention
	mod_lang in the README.modules file.  (Note that I still need to
	write README.NLS.)

2006-09-08 17:51  castaglia

	* configure: 
	Updated configure.

2006-09-08 17:48  castaglia

	* RELEASE_NOTES, configure.in, modules/mod_lang.c: 
	Adding mod_lang to the mix, for supporting the LANG command, as
	part of implementing RFC2640.

2006-09-08 09:41  castaglia

	* NEWS, include/dirtree.h, modules/mod_core.c, src/dirtree.c,
	src/main.c: 
	Bug#2837 - Defines improperly persist across daemon restarts.

2006-09-08 08:46  castaglia

	* NEWS, contrib/mod_quotatab.c: 
	Bug#2835 - Group quotas not honored for supplemental group
	membership.

2006-09-07 09:04  castaglia

	* RELEASE_NOTES: 
	Typo.

2006-09-06 20:06  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2825 - SSL/TLS CRLs are not working properly.

2006-09-06 19:56  castaglia

	* contrib/mod_ldap.c: 
	Check for PR_USE_OPENSSL as well as HAVE_OPENSSL.

2006-09-06 19:53  castaglia

	* contrib/mod_sql.c: 
	Correct the checks for HAVE_OPENSSL and PR_USE_OPENSSL in mod_sql.

2006-09-06 19:49  castaglia

	* contrib/mod_radius.c: 
	Make the ordering of OpenSSL header inclusion a little more
	legible.

2006-09-06 19:47  castaglia

	* contrib/mod_radius.c: 
	When proftpd has been compiled to use OpenSSL, then mod_radius has
	no need for using it's own MD5 routines; we can use those from
	OpenSSL instead.

2006-09-06 19:27  castaglia

	* configure: 
	Updated configure.

2006-09-06 19:24  castaglia

	* configure.in: 
	Make sure the USE_OPENSSL macro is set if mod_tls is compiled in.

2006-09-06 18:57  castaglia

	* src/bindings.c: 
	Style changes; no functional change.

2006-09-06 17:30  castaglia

	* NEWS: 
	Added mod_wrap2 to the distro.

2006-09-06 17:23  castaglia

	* README.modules, RELEASE_NOTES: 
	Updating docs for mention of mod_wrap2.  Needs to fleshed out more.

2006-09-06 17:16  castaglia

	* contrib/mod_wrap2/configure: 
	Adding configure script for mod_wrap2.

2006-09-06 17:15  castaglia

	* contrib/: mod_wrap2_file.c, mod_wrap2_sql.c: 
	Adding mod_wrap2 submodules.

2006-09-06 16:11  castaglia

	* contrib/mod_wrap2/: Makefile.in, configure.in, mod_wrap2.c,
	mod_wrap2.h.in: 
	Adding mod_wrap2 to the contrib/ area.

2006-09-06 16:09  castaglia

	* doc/contrib/: index.html, mod_wrap2.html, mod_wrap2_file.html,
	mod_wrap2_sql.html: 
	Adding documentation for the mod_wrap2 et al modules.

2006-09-05 10:04  castaglia

	* include/modules.h: 
	The privdata structure is no longer used.

2006-08-23 19:29  castaglia

	* contrib/mod_sql.c: 
	When determining the backend database module to use, mod_sql was
	using the *first* entry in the list of backends, rather than the
	*last*, as is documented.  Updated the default behavior to properly
	use the last entry (which is the first module loaded).

2006-08-17 09:05  castaglia

	* modules/mod_ls.c: 
	Fix an issue noticed by Daniel, using lftp (but not ftp).
	
	When handling an NLST command on an empty directory, lftp would
	receive a TCP RST from proftpd, rather than the more polite FIN. 
	This would happen because proftpd did a lazy opening of the data
	connection; the connection would be opened only when proftpd, when
	listing the contents of the directory, encountered something to
	list.  In the case of an empty directory, there would be nothing to
	list.  Hence no accept(2) for the client's data connection,
	followed by a close() on the socket.  In the TCP world, this is
	"slamming the connection closed", and hence the client would
	receive a RST -- the initial handshake was not completed before the
	socket was closed.
	
	The fix, then, is trivial: always open the data connection,
	regardless of whether there is data to be sent, when handling NLST
	commands.  (For some reason this issue does not seem to affect the
	LIST command.)

2006-08-16 11:42  jwm

	* contrib/mod_ldap.c: fix debug message format (thanks to mathew
	<meta@pobox.com>)

2006-08-09 08:39  castaglia

	* modules/mod_core.c: 
	Prevent users from misconfiguring their servers silently by trying
	to use something like "<Global ~user>" in their proftpd.conf.

2006-08-04 08:11  castaglia

	* doc/howto/Limit.html: 
	Mention that <Limit LOGIN> does not work as expected within
	<Directory> sections.

2006-08-02 11:26  castaglia

	* NEWS, include/options.h, src/main.c: 
	Bug#2774 - Idle clients exhibit excessive usage of system
	resources.

2006-07-19 19:15  castaglia

	* RELEASE_NOTES, include/fsio.h, modules/mod_core.c, src/fsio.c: 
	At Michael's suggestion, add a UseUTF8 directive, for run-time
	disabling of UTF8 support.

2006-06-29 10:16  castaglia

	* modules/mod_auth_unix.c: 
	Not only was the persistent_passwdf variable never used, neither
	was the _get_ppw_info() function.

2006-06-29 09:00  castaglia

	* Makefile.in: 
	Fix missing dependency of the `install-proftpd' target on the
	$(includedir).	There was a dependency already on
	$(includedir)/proftpd -- but that is not the same.

2006-06-28 09:32  castaglia

	* NEWS, contrib/mod_sql_mysql.c, contrib/mod_sql_postgres.c: 
	Bug#2809 - conf.h should be included before mysql.h in
	mod_sql_mysql.c.  The mod_sql_postgres module was similarly
	updated.

2006-06-28 09:16  castaglia

	* NEWS, modules/mod_auth_file.c: 
	Bug#2803 - mod_auth_file does not properly iterate through
	AuthUserFile entries.  The issue was one of rewinding an already
	open AuthUserFile, every time pr_auth_getpwent() was called.  The
	mod_auth_file module has been restructured to avoid this.  The code
	was also substantially changed, removing a lot of dead code for a
	never-used feature (that of supporting multiple AuthUserFiles
	within the same server context).

2006-06-28 09:10  castaglia

	* NEWS, contrib/mod_wrap.c: 
	Bug#2810 - Incorrect use of assignment instead of comparison in
	mod_wrap.

2006-06-22 13:37  castaglia

	* include/lastlog.h, src/lastlog.c: 
	Oops.  Forgot to check these files in.	They're for Bug #2610.

2006-06-22 12:48  jwm

	* modules/mod_ctrls.c: auth_(uid|gid)2name have become
	pr_auth_(uid|gid)2name

2006-06-22 10:06  castaglia

	* include/proftpd.h, modules/mod_auth_unix.c: 
	There's absolutely no reason for the pwdfname and grpfname
	variables to be visible outside of mod_auth_unix.

2006-06-22 09:08  castaglia

	* modules/mod_auth_pam.c: 
	Explicitly set the size of the authtable array.  Some picky
	compilers apparently don't like array declarations without the
	size.

2006-06-20 09:54  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#2807 - mod_sql processes SQLLog QUIT query twice.

2006-06-16 14:35  castaglia

	* modules/mod_auth_unix.c: 
	Remove unused variables and simplify the code.

2006-06-16 10:02  castaglia

	* contrib/mod_ldap.c: 
	auth_check() -> pr_auth_check()

2006-06-16 10:00  castaglia

	* contrib/mod_sql.c: 
	Style cleanup.

2006-06-15 19:54  castaglia

	* configure: 
	Updating configure.

2006-06-15 19:52  castaglia

	* config.h.in, configure.in, src/main.c: 
	Enhance the -V output to include the CFLAGS, LDFLAGS, and LIBS used
	to compile proftpd.

2006-06-15 19:33  castaglia

	* contrib/mod_site_misc.c: 
	Updating mod_site_misc to handle UTF8-encoded paths.

2006-06-15 19:30  castaglia

	* NEWS: 
	Bug#2626 - "ERROR" macro collision can cause compiler errors on
	HP-UX.

2006-06-15 19:28  castaglia

	* Makefile.in: 
	There is no real need to clean the include/ directory.

2006-06-15 19:22  castaglia

	* contrib/: mod_ban.c, mod_ctrls_admin.c, mod_ifsession.c,
	mod_ldap.c, mod_quotatab.c, mod_radius.c, mod_ratio.c,
	mod_readme.c, mod_rewrite.c, mod_site_misc.c, mod_sql.c,
	mod_sql_mysql.c, mod_sql_postgres.c, mod_tls.c, mod_wrap.c: 
	Updating contrib modules to use PR_ERROR, PR_DECLINED, and
	PR_HANDLED.

2006-06-15 19:10  castaglia

	* contrib/mod_load/mod_load.c.in: 
	Update mod_load to use PR_HANDLED.

2006-06-15 18:40  castaglia

	* modules/: mod_auth.c, mod_auth_file.c, mod_auth_pam.c,
	mod_auth_unix.c, mod_cap.c, mod_core.c, mod_ctrls.c, mod_delay.c,
	mod_dso.c, mod_log.c, mod_ls.c, mod_site.c, mod_xfer.c: 
	Updating the core modules to use the PR_ERROR, PR_DECLINED, and
	PR_HANDLED macros.  Also includes style changes.

2006-06-15 18:11  castaglia

	* doc/mod_sample.c: 
	Updating the sample module to reflect ongoing changes in the core
	code.

2006-06-15 17:53  castaglia

	* modules/mod_auth.c: 
	To enable lastlog support requires --with-lastlog, not
	--enable-lastlog.

2006-06-15 17:48  castaglia

	* include/: compat.h, dirtree.h, modules.h: 
	Start work towards Bug #2626 -- renaming the ERROR macro to
	PR_ERROR, to avoid namespace collisions on some platforms (i.e.
	HP-UX).  The DECLINED and HANDLED macros will be similarly renamed
	to PR_DECLINED and PR_HANDLED.
	
	Compatibility redefines in compat.h will help to make the
	transition transparent (hopefully).

2006-06-15 17:37  castaglia

	* src/main.c: 
	Forgot a few places where SIG_REHASH was renamed to SIG_RESTART.

2006-06-15 17:36  castaglia

	* configure: 
	Updating configure.

2006-06-15 17:36  castaglia

	* include/proftpd.h, src/main.c: 
	Remove all the old "struct rehash" callback stuff.  Replace mention
	of "rehash" with "restart".

2006-06-15 17:32  castaglia

	* include/proftpd.h, src/main.c: 
	Remove the deprecated pr_rehash_register_handler() function.  This
	functionality is now available via the Events API, by registering
	an event handler for the 'core.restart' event.

2006-06-15 17:26  castaglia

	* Make.rules.in, Makefile.in, NEWS, configure.in,
	include/Makefile.in: 
	Bug#2719 - ProFTPD should install its header files into the
	installation location.

2006-06-15 16:00  castaglia

	* include/.cvsignore: 
	Preparing to ignore the generated Makefile that will appear in the
	include/ directory.

2006-06-15 14:40  castaglia

	* configure: 
	Updating configure.

2006-06-15 13:53  castaglia

	* Make.rules.in, NEWS, RELEASE_NOTES, config.h.in, configure.in,
	include/conf.h, modules/mod_auth.c, src/main.c: 
	Bug#2610 - Support for logging to /var/log/lastlog.

2006-06-14 19:39  castaglia

	* src/dirtree.c: 
	Change fixup_globals() so that it operates on the same list as
	given to fixup_servers(), rather than using the global server_list
	variable.  (There are cases where the two lists may not be the
	same.)

2006-06-14 18:54  castaglia

	* include/pool.h, src/pool.c: 
	Removing unused pool code.

2006-06-14 18:43  castaglia

	* doc/contrib/mod_sql.html: 
	Update the mod_sql docs, as per changes for Bug #2784.
	
	Remove the list of deprecated directives from ancient mod_sql
	versions.

2006-06-14 18:39  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sql_mysql.c: 
	Bug#2784 - Ability to specify MySQL Unix domain socket path.

2006-06-14 17:26  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_core.c: 
	Bug#2798 - MDTM should return time in GMT.

2006-06-14 16:50  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sql.c: 
	Bug#2687 - Support for more efficient group table schema.

2006-06-14 16:33  castaglia

	* src/utf8.c: 
	Use "C" as a default local character set, if we cannot determine a
	better one.

2006-06-14 13:42  castaglia

	* src/utf8.c: 
	Add a trace message of the character set to which UTF8 conversion
	will be done.

2006-06-14 10:53  castaglia

	* src/netaddr.c: 
	Use separate log messages for the cases where getaddrinfo(3) and
	getnameinfo(3) fail, to differentiate between syscall errors (in
	which case, log errno) and errors with the functions themselves (in
	which case, use gai_strerror(3)).

2006-06-14 08:10  castaglia

	* NEWS, src/log.c: 
	Bug#2801 - Error compiling proftpd on NetBSD 3.0/sparc64.

2006-06-14 08:04  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2800 - free_proc_title() in developer build tries to free
	strings from pool allocated by mod_tls.

2006-06-13 15:14  castaglia

	* src/scoreboard.c: 
	Silence compiler warning (seen under --enable-devel) by renaming
	variable.

2006-06-12 09:03  castaglia

	* doc/howto/DSO.html: 
	Update example Makefile to include DESTDIR.

2006-06-12 09:02  castaglia

	* contrib/mod_load/Makefile.in: 
	Make sure that mod_load's Makefile honors DESTDIR.  Thanks to Ken
	Zalewski for pointing this out.

2006-06-09 11:29  castaglia

	* doc/contrib/mod_sql.html: 
	Typo.

2006-06-09 10:24  castaglia

	* RELEASE_NOTES: 
	Updating the release notes.

2006-06-09 10:21  castaglia

	* NEWS, contrib/mod_ctrls_admin.c,
	doc/contrib/mod_ctrls_admin.html, include/scoreboard.h,
	modules/mod_core.c, src/scoreboard.c: 
	Bug#2797 - Add ability to force cleaning the scoreboard.

2006-06-08 12:07  castaglia

	* contrib/mod_sql.c: 
	Restore the use of CF_MERGEDOWN_MULTI on SQLLog and SQLShowInfo
	directives, but only when mod_ifsession is in use.

2006-06-08 12:00  castaglia

	* contrib/mod_sql.c: 
	No need to set CF_MERGEDOWN_MULTI on directives that cannot appear
	in <Directory> sections, i.e. SQLLog and SQLShowInfo.

2006-06-08 10:51  castaglia

	* configure: 
	Updating configure.

2006-06-08 10:46  castaglia

	* configure.in: 
	Fixing typo in handling of --enable-devel=profile configure option.

2006-06-07 09:50  castaglia

	* doc/howto/Chroot.html: 
	Bug#1323: DefaultRoot not working with nfs root squash + protected
	directories.

2006-05-26 10:29  castaglia

	* configure: 
	Updated configure script.

2006-05-26 10:20  castaglia

	* modules/mod_core.c: 
	Modify mod_core for handling UTF8 paths, and mark it for i18n.

2006-05-26 10:16  castaglia

	* config.h.in, configure.in, include/fsio.h, modules/mod_ls.c,
	modules/mod_site.c, modules/mod_xfer.c, src/fsio.c, src/main.c,
	src/netio.c: 
	Marking more places in the source for gettext manipulation.  Added
	two new functions, pr_fs_decode_path() and pr_fs_encode_path(),
	which are to be used for encoding to/from UTF8 paths (or not).

2006-05-26 09:59  castaglia

	* src/trace.c: 
	Change the format of the TraceLog: The log entry does not need to
	contain any server information.

2006-05-26 09:43  castaglia

	* src/: table.c, trace.c: 
	Miscellaneous improvements: when dumping a table, include the
	length of the value data (for cases where the value is binary, and
	not a string); when adding new trace channels, make a copy of the
	channel name, as callers will not do so.

2006-05-26 08:35  castaglia

	* NEWS: 
	Correct a bug number.

2006-05-25 10:01  castaglia

	* configure: 
	Updating configure.

2006-05-25 09:55  castaglia

	* Make.rules.in, config.h.in, configure.in, include/conf.h,
	include/dirtree.h, include/utf8.h, modules/mod_auth.c,
	modules/mod_core.c, modules/mod_ls.c, modules/mod_site.c,
	modules/mod_xfer.c, src/data.c, src/help.c, src/main.c, src/utf8.c:
	
	Adding UTF8 encoding/decoding functions.  Marking source, preparing
	it for use with the gettext utilities.
	
	Part of the work towards making the proftpd source i18n/l10n ready.

2006-05-25 08:46  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_log.c: 
	Bug#2793 - LogFormat variable for the ProFTPD version.

2006-05-25 08:44  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_xfer.c: 
	Bug#2775 - Support for DisplayFileTransfer directive.

2006-05-24 08:00  castaglia

	* README.AIX: 
	Updating the AIX notes with remarks about gcc versions which do and
	don't work.

2006-05-23 10:34  castaglia

	* NEWS, modules/mod_ctrls.c: 
	Bug#2792 - ProFTPD fails after SIGHUP signal when Controls support
	is enabled.

2006-05-23 10:31  castaglia

	* src/dirtree.c: 
	Style tweaks.  Add handling of signals to a while() loop.

2006-05-23 08:06  castaglia

	* configure: 
	Updating configure script.

2006-05-23 08:02  castaglia

	* configure.in: 
	Fix the --without-getopt configure option so that it properly
	disables checks for the getopt_long() function and getopt.h header,
	in addition to disabling the check for the getopt() function.  This
	was causing a problem on FreeBSD 4.x builds, where the libgnugetopt
	package would install a getopt.h header (picked up by proftpd's
	configure script) that had a conflicting redefinition of the getopt
	struct.

2006-05-23 07:55  castaglia

	* configure.in: 
	Fix a bug, reported via the Debian bug system, where the paths from
	which proftpd would look for shared libraries included the
	--sbindir.
	
	The issue was the use of the -rpath linker parameter when linking
	the proftpd executable; it is not necessary.  Loading of DSO
	modules does not seem to be affected by the removal of that -rpath.

2006-05-22 09:45  castaglia

	* contrib/mod_tls.c: 
	Remove Perlism causing a broken module.  Add handling of signals to
	a potentially long-running while loop.

2006-05-22 09:22  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2514 - Trouble with mod_tls and DSA certificates.

2006-05-19 15:07  castaglia

	* src/netaddr.c: 
	Fix some compiler warnings, and a syntax error.

2006-05-18 09:45  castaglia

	* src/trace.c: 
	If pr_trace_msg() is used with an unknown channel, return -1 rather
	than 0.

2006-05-18 08:57  castaglia

	* configure: 
	Updating configure script.

2006-05-18 08:38  castaglia

	* Make.rules.in, NEWS, RELEASE_NOTES, config.h.in, configure.in,
	contrib/mod_ctrls_admin.c, include/conf.h, include/trace.h,
	modules/mod_core.c, src/main.c, src/response.c, src/trace.c: 
	Bug#2506 - Better ability to configure what sort of debug output to
	generate.

2006-05-17 17:47  castaglia

	* src/netaddr.c: 
	Add debug logging (level 10) of when the ACL comparison functions
	pr_netaddr_cmp() and pr_netaddr_ncmp() are comparing an IPv4
	address against an IPv4-mapped IPv6 address.

2006-05-17 09:18  castaglia

	* NEWS, README.IPv6, src/netacl.c, src/netaddr.c: 
	More work on Bug#2785.

2006-05-15 14:42  castaglia

	* doc/howto/DSO.html: 
	Make note of some of the errors you might encounter when using DSO
	modules.

2006-05-15 09:32  castaglia

	* NEWS, README.IPv6, README.PAM, README.classes, RELEASE_NOTES,
	modules/mod_core.c, modules/mod_xfer.c, src/netacl.c: 
	Getting the restored SourceForge devel CVS repository back up to
	sync, after their hard disk failure.  Joy.

2006-05-12 14:53  castaglia

	* README.AIX: 
	Document that some versions of AIX have sendfile issues.

2006-05-05 09:02  castaglia

	* contrib/mod_tls.c: 
	Clean up the handling of the TLSCACertificatePath directive.

2006-04-21 09:37  castaglia

	* contrib/mod_quotatab.c, doc/contrib/mod_quotatab.html: 
	Forgot to add the description for the QuotaExcludeFilter directive.

2006-04-21 09:26  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_quotatab.c,
	contrib/mod_quotatab.h, doc/contrib/mod_quotatab.html,
	doc/howto/Quotas.html: 
	Bug#2713 - Ability to check a user's existing disk bytes/files
	usage and update tally accordingly.

2006-04-20 19:04  castaglia

	* contrib/mod_sql.h: 
	Update the mod_sql header.  Crufty information, and a typo.

2006-04-20 19:02  castaglia

	* include/feat.h, src/feat.c: 
	Change the way the Feat API stores features to be listed, from
	using an array to using a table.  This makes it much easier to
	remove features from the listing.

2006-04-20 18:59  castaglia

	* contrib/: mod_sql.c, mod_sql_mysql.c, mod_sql_postgres.c: 
	Expanding the HOOKs exposed by mod_sql, so that other contrib
	modules can run their own SQL statements without having to reinvent
	mod_sql's wheel.

2006-04-20 18:32  castaglia

	* NEWS, README.modules, RELEASE_NOTES, contrib/mod_ban.c,
	doc/contrib/mod_ban.html: 
	Adding mod_ban.

2006-04-20 10:03  castaglia

	* NEWS, src/inet.c: 
	Bug#2733 - IP TOS not being set for data transfers.

2006-04-19 19:28  castaglia

	* src/parser.c: 
	Adding some sanity checks for NULL pointers, pointed out by
	Coverity scans.  Also remove some unnecessary conditionals.

2006-04-19 19:24  castaglia

	* modules/mod_log.c: 
	"writeable" -> "writable".

2006-04-19 19:06  castaglia

	* modules/mod_xfer.c: 
	Clean up dead code spotted by Coverity scan.

2006-04-19 19:01  castaglia

	* modules/mod_auth.c: 
	Clean up dead code spotted by Coverity scan.  Also fixup some
	formatting issues while I'm here.

2006-04-19 18:46  castaglia

	* src/data.c, modules/mod_auth_file.c: 
	Clean up dead code spotted by Coverity scan.

2006-04-19 18:42  castaglia

	* contrib/mod_sql.c: 
	Clean up dead code spotted by Coverity.

2006-04-19 16:10  castaglia

	* RELEASE_NOTES, modules/mod_xfer.c: 
	Get the ball rolling on deprecating HiddenStor, in favor of
	HiddenStores.

2006-04-19 09:59  castaglia

	* configure: 
	Updating configure.

2006-04-19 09:56  castaglia

	* NEWS, configure.in: 
	As part of addressing Bug #2447, make use of the --enable-openssl
	autoconf option automatically add libssl and libcrypto to the
	library list.

2006-04-19 09:44  castaglia

	* NEWS, config.h.in, configure.in, contrib/mod_ldap.c,
	contrib/mod_sql.c, src/main.c: 
	Bug#2447 - HAVE_OPENSSL should be managed in configure.

2006-04-17 15:48  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_log.c: 
	Bug#2651 - LogFormat should support variable for logging the
	response message.

2006-04-17 15:38  castaglia

	* doc/contrib/: mod_quotatab.html, mod_quotatab_radius.html: 
	Update mod_quotatab docs with links to RADIUS submodule.

2006-04-17 15:35  castaglia

	* NEWS, README.modules, RELEASE_NOTES,
	contrib/mod_quotatab_radius.c, contrib/mod_radius.c,
	doc/contrib/mod_quotatab_radius.html: 
	Bug#2627 - Support for RADIUS quotatab module.

2006-04-17 15:23  castaglia

	* NEWS, contrib/mod_sql.c: 
	Mention in NEWS that CreateHome should be used instead of
	SQLHomedirOnDemand.  Mark the SQLHomedirOnDemand config handler as
	deprecated in the mod_sql source.

2006-04-17 15:22  castaglia

	* modules/mod_core.c: 
	As per the warnings in the 1.3.0 release cycle, the Bind directive
	was deprecated, and is now removed.

2006-04-17 15:20  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sql.c: 
	Bug#2628 - SQLHomedirOnDemand should be deprecated.

2006-04-17 14:01  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_tls.c, doc/contrib/mod_tls.html:
	
	Bug#2686 - Allow CCC command but still require SSL/TLS protection
	during authentication.

2006-04-17 11:52  castaglia

	* NEWS, RELEASE_NOTES, modules/mod_auth.c,
	doc/howto/CreateHome.html, doc/howto/index.html, src/mkhome.c: 
	Bug#2611 - CreateHome should allow non-root-owned parent
	directories.

2006-04-17 11:39  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_tls.c, doc/contrib/mod_tls.html:
	
	Bug#2599 - Support for using OpenSSL "engines".

2006-04-17 10:53  castaglia

	* configure: 
	Updating configure.

2006-04-17 10:04  castaglia

	* NEWS, config.h.in, configure.in, modules/mod_auth_pam.c: 
	Bug#2769 - mod_auth_pam needs a patch to allow pam_group to work.

2006-04-17 09:48  castaglia

	* NEWS, doc/modules/mod_delay.html, modules/mod_delay.c: 
	Bug#2664 - Add 'delay info' ftpdctl action for showing DelayTable
	values.

2006-04-17 09:20  castaglia

	* NEWS, src/inet.c: 
	Bug#2777 - ProFTPD does handle data sockets properly on FreeBSD 6.

2006-04-16 16:18  castaglia

	* modules/mod_xfer.c: 
	At some point in the future, proftpd will support the MODE Z
	command.  When that happens, mod_xfer will need to not use
	sendfile() if MODE Z has been requested.

2006-04-16 16:08  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2740 - TYPE command not allowed before USER/PASS, causes
	problem for `ftp -n'.

2006-04-16 16:01  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2654 - FEAT command should be subject to <Limit>.

2006-04-16 15:51  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2753 - CCC not closing SSL/TLS connection correctly.

2006-04-16 15:45  castaglia

	* NEWS, include/dirtree.h, include/table.h, src/dirtree.c,
	src/table.c: 
	Bug#2535 - Compare directives using integer comparisons when
	possible to improve performance.

2006-04-16 15:41  castaglia

	* NEWS, modules/mod_auth_unix.c: 
	Bug#2721 - mod_auth_unix does not behave properly when first in
	AuthOrder.

2006-04-16 15:39  castaglia

	* NEWS, modules/mod_auth_file.c, modules/mod_auth_unix.c: 
	Bug#2714 - mod_auth_file munges AuthUserFile, AuthGroupFile
	records.

2006-04-16 15:35  castaglia

	* doc/howto/Debugging.html: 
	Adding mention of the stack trace logging to the Debugging howto.

2006-04-16 15:25  castaglia

	* configure: 
	Updating configure.

2006-04-16 15:23  castaglia

	* NEWS, RELEASE_NOTES, config.h.in, configure.in,
	include/options.h, src/main.c: 
	Bug#2766 - Support for automatic stack trace if SIGSEGV is
	received.

2006-04-16 15:12  castaglia

	* include/version.h: 
	Now that 1.3.0 is out, we can start on 1.3.1.

2006-04-16 14:39  castaglia

	* ChangeLog: 
	Updating the ChangeLog.

2006-04-16 14:36  castaglia

	* contrib/dist/rpm/proftpd.spec, include/version.h, NEWS: 
	Preparing for release of 1.3.0-final.

2006-04-10 09:41  castaglia

	* lib/glibc-mkstemp.c: 
	Fix typo in mkstemp() implementation, noted by Charles Seeger.

2006-04-07 18:20  castaglia

	* doc/howto/ConfigFile.html: 
	Update the description of the User/Group directives to mention
	effective versus real privs, and how some programs report on real
	instead of effective privs.

2006-03-22 14:10  castaglia

	* NEWS, lib/glibc-glob.c, lib/pwgrent.c, src/fsio.c: 
	Quell several compiler warnings:
	
	Bug#2770 - FreeBSD compiler warning that "__GLIBC__" is not
	defined.  Bug#2771 - FreeBSD compiler warning about undeclared
	fgetpwent/fgetgrent	       functions.  Bug#2772 - FreeBSD
	compiler warning that "_FILE_OFFSET_BITS" is not defined.

2006-03-22 13:45  castaglia

	* Make.rules.in, NEWS: 
	Bug#2733 - libtool requires sh/bash.

2006-03-22 10:51  castaglia

	* utils/: ftptop.c, scoreboard.c: 
	Minor fixes to ftptop: use snprintf(3) rather than sprintf(3), and
	make sure that any scoreboard path set via the -f command-line
	option actually exists.

2006-03-18 12:15  castaglia

	* ChangeLog: 
	Updated ChangeLog.

2006-03-18 12:13  castaglia

	* NEWS, RELEASE_NOTES, contrib/dist/rpm/proftpd.spec,
	include/version.h: 
	Rolling up RC5 release.

2006-03-17 10:52  castaglia

	* NEWS, modules/mod_delay.c: 
	Bug#2723 - mod_delay causes process to hang on OS X when proftpd
	exits.

2006-03-16 18:12  castaglia

	* RELEASE_NOTES: 
	Updating the release notes for the RC5 release.

2006-03-16 10:06  castaglia

	* README.controls, doc/howto/Controls.html: 
	Make notes about how Controls are affected by ServerType.

2006-03-15 11:41  castaglia

	* src/main.c: 
	We need to copy the session addresses into memory after any reverse
	DNS resolution is performed, not before.

2006-03-14 19:56  castaglia

	* NEWS, modules/mod_log.c, modules/mod_xfer.c, src/main.c: 
	Bug#2765 - Child process segfaults while handling a SIGTERM.  A
	field from a structure whose memory had been freed by the time the
	field was referenced was tickling the segfault.

2006-03-14 18:49  castaglia

	* modules/mod_auth.c: 
	Remove slightly misleading (and outdated) comment.

2006-03-14 18:47  castaglia

	* NEWS, modules/mod_auth.c: 
	Make the workaround for Bug#2717 be specific to glibc-2.3 or
	greater, not to Linux in general.

2006-03-14 18:09  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#2717 - Wrong timestamp in logs for chrooted processes.

2006-03-13 19:18  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2764 - REST command does not return an error for negative
	numbers.

2006-03-11 16:16  castaglia

	* include/privs.h: 
	Remove some duplicating logging in the PRIVS_RELINQUISH macro
	definition.

2006-03-11 09:27  castaglia

	* include/version.h: 
	Forgot to change the status back to "CVS", for now.

2006-03-09 10:50  castaglia

	* doc/contrib/mod_sql.html: 
	Add description of the SQLBackend directive.

2006-03-09 10:20  castaglia

	* configure: 
	Updating configure.

2006-03-09 10:12  castaglia

	* configure.in: 
	Updating changes made for fixing Bug#2759 so that the libsupp
	library can be found.

2006-03-08 11:11  castaglia

	* configure: 
	Updating configure.

2006-03-08 11:06  castaglia

	* NEWS, configure.in: 
	Bug#2759 - Adding --with-includes to configure can cause problems
	when building with other packages.

2006-03-06 13:49  castaglia

	* doc/howto/NAT.html: 
	Add a description of what can happen if the configured PassivePorts
	range is too small.

2006-03-06 10:17  castaglia

	* NEWS, contrib/dist/rpm/proftpd.spec: 
	Bug#2757 - Add support for quota modules to RPM spec.

2006-03-01 09:00  castaglia

	* RELEASE_NOTES: 
	Updating release notes.

2006-03-01 08:45  castaglia

	* ChangeLog, NEWS, contrib/dist/rpm/proftpd.spec,
	include/version.h: 
	Preparing for release of 1.3.0rc4.

2006-02-23 15:01  castaglia

	* doc/rfc/: draft-murray-auth-ftp-ssl-15.txt, rfc4217.txt: 
	The old IETF Draft which defined FTPS was finally upgraded to a
	full-fledged RFC in Nov 2005, as RFC4217.

2006-02-23 14:42  castaglia

	* doc/howto/SQL.html: 
	Added FAQ about libz linker errors to SQL howto.

2006-02-21 09:51  castaglia

	* modules/mod_delay.c: 
	Add more debug logging, level 10, for when mod_delay mmaps or
	munmaps.  This is for tracking down Bug #2723.	Also handle the
	case where munmap(2) fails.

2006-02-20 22:55  castaglia

	* NEWS, modules/mod_core.c: Bug#2752 - FEAT reply not RFC 2389
	compliant.

2006-02-07 17:25  castaglia

	* NEWS, src/data.c: 
	Bug#2746 - Data transfer function does not return error condition
	in case of read errors.  Now the pr_data_xfer() loop will error out
	if there is an error returned by pr_netio_read(), just as is
	already done if there is an error returned by pr_netio_write().

2006-01-11 05:55  castaglia

	* doc/howto/: index.html, AuthFiles.html: 
	Added the AuthFiles howto (it was referenced by the ConfigFile
	howto).

2006-01-04 05:31  castaglia

	* modules/mod_xfer.c: 
	Fix a warning about an unused variable.  The tcp_level variable is
	really only used if TCP_CORK is defined; thus it should be declared
	within an #ifdef TCP_CORK block.

2005-12-27 10:29  castaglia

	* RELEASE_NOTES: 
	Mention the OSX tweaks in the Release Notes.

2005-12-26 19:04  castaglia

	* src/main.c: Initialise the session.proc_prefix string upon client
	connection.  There was a strange edge case, involving
	mod_wrap-2.0.x, where proftpd was calling set_proc_title() using a
	NULL session.proc_prefix.  GNU libc handles printfs of NULLs
	gracefully, but other libc implementations (e.g. Solaris) are not
	as forgiving; this edge case was leading to segfaults on those
	platforms.

2005-12-19 10:59  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2735 - Allow REST 0 in ASCII mode.

2005-12-13 09:54  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#2709 - mod_sql improperly strips spaces from names, allowing
	for confusing authentication.

2005-12-07 14:15  castaglia

	* NEWS, modules/mod_auth_pam.c: 
	Bug#2729 - Authorative PAM authentication doesn't work.

2005-12-05 11:17  castaglia

	* RELEASE_NOTES, doc/howto/Quotas.html, doc/howto/index.html: 
	Adding Quotas howto to doc/ area.

2005-12-02 10:34  jwm

	* contrib/mod_ldap.c: some overdue cleanup: - use braces
	everywhere. honestly, i don't know why i wrote code this way.  -
	now that we're using strtoul() sanity checking on default [UG]IDs,
	we   don't need the isdigit() checking - use get_param_ptr for
	single-argument directives instead of find_config() - if a
	directive is present (get_param_ptr() returns non-NULL), assign its
	  value to the config variable; we don't want to assume default
	values	 in the variable initialization as well as the getconf
	handler.

2005-12-02 09:04  jwm

	* contrib/mod_ldap.c: - complain about invalid default [UG]IDs -
	only allocate enough arguments in the config_rec for LDAPDoAuth and
	  LDAPDoUIDLookups to cover the arguments specified

2005-12-02 08:51  jwm

	* contrib/mod_ldap.c: - remove get_param_int() usage; store values
	in an allocated pointer intsead - config handlers now take their
	directive name from c->argv[0], saving	 a few bytes of static
	strings

2005-11-29 10:19  castaglia

	* doc/contrib/mod_tls.html: 
	Adding more specific instructions for what a
	TLSCertificateChainFile should contain.

2005-11-28 18:42  castaglia

	* NEWS, src/inet.c: 
	Bug#2374 revisited, for the sake of updated Mac OSX releases.  When
	is a regression not a regression?  When it's the fault of the host
	system, not the application code.  Sigh.

2005-11-19 11:44  castaglia

	* doc/howto/DSO.html: 
	Adding more comments to the DSO howto, based on user
	feedback/questions.

2005-11-16 08:04  jwm

	* contrib/mod_ldap.c: release 2.8.16

2005-11-15 12:01  castaglia

	* doc/contrib/mod_quotatab.html: 
	Formatting changes.

2005-11-15 11:44  castaglia

	* doc/contrib/mod_quotatab.html: 
	Improve the mod_quotatab doc, emphasizing the definitions of limit
	and tally tables.  Also add HTML anchors, for easier referencing
	from the upcoming Quotas howto.

2005-11-14 09:47  castaglia

	* doc/contrib/mod_tls.html: 
	Update description of AllowDotLogin TLSOption, as proftpd now will
	not prompt for a password if none is required.

2005-11-14 08:33  castaglia

	* NEWS, include/pr-syslog.h, lib/pr-syslog.c, src/log.c: 
	Bug#2705 - proftpd fails to log anything to syslog after dropping
	privs on Solaris.
	
	Since proftpd has custom syslog routines, we can simply add an
	accessor function for setting the static log_facility variable. 
	libc-based syslogging cannot do this; proftpd used libc syslog
	routines in the past, hence the need to call openlog() again if the
	facility changed.
	
	Thanks to Kostantinos Koukopoulos for the patch.

2005-11-12 10:25  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2712 - DisplayFirstChdir directive does not work.

2005-11-11 13:05  castaglia

	* NEWS, include/ctrls.h, modules/mod_ctrls.c, src/ctrls.c: 
	Bug#2711 - Controls socket detection broken.

2005-11-10 11:14  castaglia

	* src/ctrls.c: 
	Copy the full length of the socket path, including the terminating
	NUL.

2005-11-08 09:59  castaglia

	* contrib/mod_tls.c: 
	Make the log messages generated during certificate verification a
	little cleaner.  Also add explicit handling of the INVALID_PURPOSE
	error case.

2005-11-08 08:13  castaglia

	* configure: 
	Updating configure.

2005-11-08 08:06  castaglia

	* NEWS, configure.in: 
	Bug#2708 - configure cannot detect some headers.

2005-11-04 08:36  castaglia

	* NEWS, src/log.c: 
	Bug#2706 - utmp/wtmp logging on NetBSD needs some tweaks.

2005-11-04 08:34  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2703 - Disk quota exceeded for small files not being triggered.

2005-10-31 15:23  castaglia

	* include/version.h: 
	Bump version to 1.3.0rc4 (hopefully will turn out to be
	1.3.0-stable).

2005-10-31 09:45  castaglia

	* ChangeLog: 
	One more update.

2005-10-31 09:39  castaglia

	* src/fsio.c: 
	Correct usage of pr_fsio_readlink().

2005-10-31 09:34  castaglia

	* NEWS, include/version.h, contrib/dist/rpm/proftpd.spec: 
	Preparing for 1.3.0rc3 roll.

2005-10-31 09:32  castaglia

	* ChangeLog: 
	Updating ChangeLog.

2005-10-28 08:54  castaglia

	* RELEASE_NOTES: 
	Updating release notes.

2005-10-26 16:36  castaglia

	* src/fsio.c: 
	Drat.  Forgot to replace all occurrences of ->readlink() with
	pr_fsio_readlink().

2005-10-26 09:53  castaglia

	* modules/mod_facl.c: 
	Use direct pointer assignment rather than acl_copy_entry(); the
	latter is not needed.  Patch supplied by Patrick McHardy.

2005-10-26 09:34  castaglia

	* src/fsio.c: 
	When cleaning the path in pr_insert_fs(), only add a trailing path
	separator if the original path had one _and_ the current cleaned
	path does _not_ have one.  Thanks to Patrick McHardy for pointing
	this out.

2005-10-26 09:19  castaglia

	* src/fsio.c: 
	Patrick McHardy pointed out that in a couple of places, the FSIO
	API uses the readlink function pointer, registered for an fs_t,
	directly.  However, it is not required for registered fs_ts to
	provide any particular FSIO function.  Thus pr_fsio_readlink(),
	which iterates through the fs layers in order to find the first
	that does provide a readlink function, should be used.

2005-10-23 14:50  castaglia

	* contrib/mod_sql.c: 
	Fix a segfault expanding the '%h' sequence for an SQLLog EXIT
	command by using the proper API.  Related to Bug #2695.

2005-10-20 08:33  castaglia

	* doc/contrib/mod_tls.html: 
	Fixed example installation instructions for mod_tls.

2005-10-19 16:33  castaglia

	* configure: 
	Updating configure.

2005-10-19 16:28  castaglia

	* configure.in, config.h.in, include/ctrls.h, modules/mod_ctrls.c,
	src/ctrls.c: 
	Change the location of the logic used to determine whether the
	platform prefers S_ISFIFO or S_ISSOCK for detecting Unix domain
	sockets.  Rather than using a test program as part of the configure
	script, move the check into the init_ctrls() code, so that it can
	be done at run-time.

2005-10-18 16:27  castaglia

	* contrib/mod_sql.c, modules/mod_log.c: 
	Fix handling of the %f log variable for the RNTO command.  Both
	mod_log and mod_sql were using session.xfer.path for %f, when in
	the case of RNTO, the %f that is desired is actually the argument
	of the command, cmd->arg, not session.xfer.path.

2005-10-18 11:30  castaglia

	* contrib/mod_sql.c, modules/mod_log.c: 
	When expanding the %J log variable (for command arguments), be sure
	to hide the arguments for the PASS command.

2005-10-10 10:58  castaglia

	* README.IPv6, src/netacl.c: 
	Only use the full range of characters which appear in an IPv6 (and
	IPv4) address when IPv6 support is enabled.
	
	Also, document the case where, when IPv6 support *is* enabled,
	certain DNS names are not handled as one would expect, due to the
	heuristics used by the ACL parser.

2005-10-08 13:51  castaglia

	* RELEASE_NOTES, doc/howto/Filters.html, doc/howto/Regex.html,
	doc/howto/index.html: 
	Add the regular expression tutorial to the doc/howto/ area.

2005-10-08 13:34  castaglia

	* RELEASE_NOTES: 
	Add some notes to the RELEASE_NOTES file for the upcoming 1.3.0rc3
	release.

2005-10-08 13:16  castaglia

	* configure: 
	Updating configure.

2005-10-08 13:14  castaglia

	* config.h.in, configure.in, modules/mod_ctrls.c: 
	Add an autoconf check to see if the platform prefers S_ISFIFO or
	S_ISSOCK for Unix domain sockets.  It seems that some systems (e.g.
	UnixWare) prefer S_ISFIFO, even though the file is created/bound
	using socket(2)/bind(2) rather than mknod(2).  Isn't portability
	grand.
	
	The added test defines a PR_ISSOCK_UNIX macro, defined to the
	appropriate S_IS* macro, for use in proftpd code.

2005-09-28 11:50  castaglia

	* doc/howto/Limit.html: 
	Style.

2005-09-27 19:06  castaglia

	* src/: dirtree.c, support.c: 
	Style.

2005-09-27 09:22  castaglia

	* src/response.c: 
	Style.

2005-09-27 09:11  castaglia

	* NEWS, src/response.c: 
	Bug#2692 - R_DUP response messages can break the FTP protocol
	responses.

2005-09-27 09:08  castaglia

	* NEWS, include/privs.h: 
	Bug#2682 - Signals can interrupt privilege switching.  To guard
	against this, the PRIVS macros now all contain
	pr_signals_block()/pr_signals_unblock() guards.

2005-09-26 16:36  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2697 - Improper SSL session shutdown sequence used for some
	FTPS clients.

2005-09-21 10:40  castaglia

	* modules/mod_core.c: 
	Clean up the debug logging done when handling config directive
	regexes.  No need to report on the memory location for the
	allocated regex.

2005-09-20 18:08  castaglia

	* doc/contrib/mod_tls.html: 
	Typo.

2005-09-20 18:04  castaglia

	* doc/contrib/mod_tls.html: 
	Use of the StdEnvVars TLSOption does not necessarily increase the
	process memory footprint; it depends on the various memory
	allocator caching strategies involved.

2005-09-20 15:45  castaglia

	* doc/contrib/mod_tls.html: 
	Enhancing the explanations of the TLSCACertificateFile and
	TLSRandomSeed directives.

2005-09-20 11:33  castaglia

	* doc/contrib/mod_tls.html: 
	Minor updates to mod_tls doc.

2005-09-19 14:35  castaglia

	* NEWS, contrib/mod_radius.c, contrib/mod_sql.c, include/netaddr.h,
	src/log.c, src/main.c, src/netaddr.c: 
	Bug#2695 - Client IP/host is not logged when client exits.

2005-09-19 10:14  castaglia

	* modules/mod_xfer.c: 
	Style.

2005-09-08 11:36  castaglia

	* README.modules: 
	Minor corrections to the location of contrib module documentation,
	thanks to Sven Hoexter.

2005-09-08 09:39  castaglia

	* contrib/mod_tls.c: 
	Log in the TLSLog when mod_tls denies FTP commands because of the
	configured security policy.

2005-09-04 17:05  castaglia

	* src/netaddr.c: 
	When reporting DNS resolution errors, report the type of address
	requested, i.e. IPv4 or IPv6.

2005-09-04 16:57  castaglia

	* NEWS, include/parser.h, src/main.c, src/parser.c: 
	Bug#2689 - Parser does not complain about unclosed configuration
	sections.

2005-08-29 18:45  castaglia

	* RELEASE_NOTES: 
	Fix typo.

2005-08-28 11:01  castaglia

	* src/fsio.c: 
	After cleaning the path given to pr_insert_fs(), we make sure it
	has a trailing '/' path separator character.  However, this is only
	necessary if the path being inserted is not '/' itself.  Check for
	that case, and make sure to not add the trailing '/' if it is not
	needed.

2005-08-25 10:53  castaglia

	* contrib/mod_tls.c: 
	The mod_tls version information was missing from a couple of log
	messages.

2005-08-24 09:10  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2685 - ListOptions' max parameters cannot be set higher than
	255.

2005-08-23 09:50  castaglia

	* modules/mod_auth.c, modules/mod_core.c, src/main.c: 
	Log, at debug level 6, if there was an error displaying a Display
	file.

2005-08-23 09:25  castaglia

	* src/dirtree.c: 
	Add explanatory comment.  When researching a problem earlier, I was
	a bit confused by the reuse of a pool variable; the comment is a
	reminder of what is going on.

2005-08-16 09:06  castaglia

	* INSTALL: 
	Update the section of the INSTALL doc that talks about xinetd
	configuration; as of xinetd-2.3.11, the 'RECORD' logging option has
	been deprecated.

2005-08-10 09:08  jwm

	* README.LDAP: update README.LDAP; oops, i've been forgetting about
	this

2005-08-07 09:35  castaglia

	* modules/mod_core.c: 
	When reporting on use or nonuse of <IfModule> and <IfDefine>
	sections, correctly report the "!" character.  Otherwise, the
	reporting is confusing.

2005-08-07 09:01  castaglia

	* contrib/mod_tls.c: 
	When handling any error returned by SSL_shutdown(3) (after it has
	been called the second time), and the error is not explicitly
	handled by the switch statement, log the error code.  This will
	help in debugging certain cases where tls_get_error() returns
	"(unknown)", which possibly indicates no error occurred.

2005-08-07 08:46  castaglia

	* configure: 
	Updating configure.

2005-08-07 08:44  castaglia

	* NEWS, configure.in: 
	Bug#2676 - configure option --disable-ipv6 enables IPv6.

2005-08-04 14:06  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#2674 - mod_sql string escape problem during group lookups.

2005-08-03 10:08  castaglia

	* contrib/mod_radius.c: 
	Pad the size of the radius_packet_t structure.

2005-08-03 10:06  castaglia

	* NEWS, contrib/mod_radius.c: 
	Bug#2669 - mod_radius segfaults if PASS command sent with no USER
	command.

2005-08-02 16:38  castaglia

	* doc/howto/ListOptions.html: 
	Fix documentation for "-a" ListOption.

2005-08-02 08:53  castaglia

	* NEWS, modules/mod_ctrls.c: 
	Bug#2668 - mod_ctrls fails to open socket during SIGHUP.

2005-08-01 18:34  castaglia

	* modules/mod_facl.c: 
	Add debugging output, level 6, showing when mod_facl has
	successfully registered its FS handler.

2005-08-01 13:49  castaglia

	* modules/mod_ctrls.c: 
	Display the mod_ctrls version when using `proftpd -vv'.

2005-07-31 20:16  castaglia

	* src/ftpdctl.c: 
	Display the name of the socket path being contacted when `ftpdctl
	-v' is used.

2005-07-31 20:15  castaglia

	* NEWS: 
	Bug#2667 - mod_tls handles SIGHUP badly.  Stop registering the
	handler for the "core.postparse" event in the "core.restart" event
	handler; such multiple registrations cause the "core.postparse"
	event handler to be invoked multiple times.

2005-07-30 18:25  castaglia

	* contrib/mod_tls.c: 
	The "core.restart" event handler for mod_tls was registering a
	handler for the "core.postparse" event; however, one was already
	being registered.  The duplicate "core.postparse" registrations
	would cause the handler to be called repeatedly, leading to locking
	of key passphrases into memory multiple times and other unintended
	funniness.

2005-07-27 11:45  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2662 - OpenSolaris/Solaris 11 has TCP_CORK but not SOL_TCP.

2005-07-27 10:48  castaglia

	* NEWS, contrib/dist/rpm/proftpd.spec: 
	Bug#2660 - Add mod_facl in rpm spec file.

2005-07-26 19:08  castaglia

	* contrib/mod_tls.c: 
	Explicitly mention that $SSL_CERT_DIR is an environment variable.

2005-07-24 12:25  castaglia

	* include/version.h: 
	Updating version.

2005-07-24 11:21  castaglia

	* ChangeLog: 
	Updating ChangeLog.

2005-07-24 11:15  castaglia

	* NEWS, contrib/dist/rpm/proftpd.spec, include/version.h: 
	Preparing for release of 1.3.0rc2.

2005-07-24 11:08  castaglia

	* NEWS, contrib/mod_radius.c: 
	Bug#2658 - Segfault in mod_radius when using long password.

2005-07-21 15:00  castaglia

	* RELEASE_NOTES: 
	Fix typo.

2005-07-20 17:43  castaglia

	* contrib/mod_tls.c: 
	Slight paranoia about calling BIO_free() on possibly NULL pointer.

2005-07-20 17:40  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2657 - Segfault in tls_get_error() function in mod_tls.

2005-07-18 17:30  castaglia

	* doc/howto/: Classes.html, SQL.html: 
	Updating Class and SQL howtos.

2005-07-15 15:13  castaglia

	* NEWS: 
	Minor rewording of NEWS, with respect to POSIX ACLs.

2005-07-08 08:53  castaglia

	* RELEASE_NOTES: 
	Updating the release notes.

2005-07-08 08:26  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2653 - When MaxStoreFileSize is reached, error should be EDQUOT
	rather than EPERM.

2005-07-07 07:45  castaglia

	* NEWS, src/data.c: 
	Bug#2560 - Reporting errors when user filesystem quota is exceeded.

2005-07-07 00:10  castaglia

	* modules/mod_log.c: 
	With the fixing of Bug #1965, the mod_log module no longer needs a
	PRE_CMD handler in order to properly log the QUIT command; the
	POST_CMD C_ANY handler suffices.  In fact, the PRE_CMD C_QUIT
	handler currently in place means that the QUIT command would be
	logged twice in an ExtendedLog.

2005-07-05 09:11  castaglia

	* doc/howto/: DNS.html, VirtualUsers.html, index.html: 
	Adding DNS, VirtualUsers howtos.

2005-07-05 08:49  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#2645 - SQLShowInfo format string vulnerability.

2005-07-05 08:42  castaglia

	* NEWS, src/response.c: 
	Bug#2646 - ftpshut format string vulnerability.

2005-07-03 11:52  castaglia

	* contrib/mod_ldap.c, contrib/mod_radius.c, contrib/mod_sql.c,
	contrib/mod_tls.c, modules/mod_auth.c, modules/mod_auth_file.c,
	modules/mod_auth_pam.c, modules/mod_auth_unix.c: 
	Update the auth modules to set the session.auth_mech member with
	the name of the module which successfully authenticates a user.

2005-07-03 11:13  castaglia

	* NEWS: 
	Bug#2375 - Slow directory listing with several blank .ftpaccess
	files.

2005-07-03 11:08  castaglia

	* src/dirtree.c: 
	When parsing .ftpaccess files, check that the size of the
	.ftpaccess file is non-zero before handling it.  This is related to
	Bug #2375, if not _the_ culprit.  I suspect that there are more
	improvements to be made with regards to .ftpaccess file processing,
	though.

2005-07-02 11:41  castaglia

	* NEWS, contrib/mod_sql.c: 
	Fix segfault where using SQLLog to execute a SQLNamedQuery (which
	uses %L or %a) for the EXIT command would attempt to use freed
	memory.

2005-07-02 11:06  castaglia

	* modules/mod_xfer.c: 
	Set the current working directory, in the FSIO layer, before an
	open() call.  This may be the cause of some strange behaviors seen
	with some of my FSIO modules (i.e. mod_md5).

2005-07-02 10:59  castaglia

	* modules/mod_delay.c: 
	More bounds checking in mod_delay, as part of an investigation into
	Bug #2621 using valgrind.

2005-06-29 17:39  castaglia

	* NEWS, include/conf.h: 
	Bug#2647 - Improper "socklen_t" redefine for HP-UX when using
	X/Open.

2005-06-29 12:11  castaglia

	* doc/modules/mod_delay.html: 
	This document covers mod_delay, not mod_dso.  Fix typo.

2005-06-27 13:40  castaglia

	* NEWS, contrib/mod_sql_mysql.c: 
	Bug#2644 - mod_sql_mysql should handle old MySQL password format
	more gracefully.

2005-06-26 22:38  castaglia

	* configure: 
	Updating configure.

2005-06-26 22:25  castaglia

	* config.h.in, configure.in: 
	Check for the size of a time_t.  We do not need this immediately,
	but we will soon.

2005-06-23 16:23  castaglia

	* contrib/mod_quotatab_sql.c: 
	Fix a rather broken assignment.  Newer versions of gcc, being less
	lenient, choke on this assignment whereas older versions of gcc let
	it pass.

2005-06-22 13:56  castaglia

	* contrib/mod_tls.c: 
	Always set the tls_pkey_list pointer to NULL after scrubbing the
	list.  Also, be sure to scrub that list at session initialization
	time if TLSEngine is not on for the session.

2005-06-22 10:22  castaglia

	* src/fsio.c: 
	The changes in the FSIO API to support chained FS objects changed
	some things; the lookup_file_fs() function made assumptions which
	were broken by those changes.  Update lookup_file_fs() to properly
	deal with FS objects whose stat or lstat function pointers may be
	NULL.

2005-06-21 18:58  castaglia

	* src/fsio.c: 
	Off by one in my calculation; PR_TUNABLE_PATH_MAX-1 is the last
	usable index in the buffer.  Of course, I may still be wrong here,
	but I'd rather be wrong by too large of a difference, rather than
	too small.

2005-06-21 16:11  castaglia

	* src/fsio.c: 
	Tracking down a bug in my crufty mod_md5fs module revealed the
	cause to be a subtle bug in pr_insert_fs().  The path provided by
	the caller was being cleaned via pr_fs_clean_path(), which would
	remove any trailing path separators.  However, in the case of FSIO
	FS objects, that trailing separator is important.  Re-add it if it
	was there.

2005-06-21 15:06  castaglia

	* configure: 
	Update configure.

2005-06-21 13:54  castaglia

	* src/bindings.c: 
	The ipv6_supported variable need only be defined if --enable-ipv6
	is used.

2005-06-21 11:49  castaglia

	* configure.in: 
	If the --enable-ctrls configure option is used, mod_ctrls will be
	built as a static module.  To get mod_ctrls to be built as a shared
	module, use --enable-ctrls and list mod_ctrls in the --with-shared
	list.  However, I have not tested how well mod_ctrls behaves as a
	shared module...

2005-06-21 11:27  castaglia

	* src/main.c: 
	Display the default libexec/ directory for the -V option, if DSO
	support is enabled.

2005-06-21 10:22  castaglia

	* configure: 
	Updating configure.

2005-06-21 10:02  castaglia

	* configure.in, src/bindings.c: 
	Undo yesterday's autoconf change for IPv6 support detection. 
	Instead, move that detection into init_bindings(), although I
	suspect that it will be needed in other places of the code as well.
	 At least this way, though, a proftpd compiled using --enable-ipv6
	on an IPv4 box will still start up properly and accept connections.

2005-06-21 06:54  castaglia

	* NEWS: 
	Update the description of Bug #2573, making note of the changed
	behavior and how to address it (as per Bug #2640).

2005-06-20 15:57  castaglia

	* configure: 
	Updating configure.

2005-06-20 15:35  castaglia

	* configure.in: 
	Have autoconf check for IPv6 support when the --enable-ipv6
	configure option is used.  It is completely possible for an
	IPv4-only box to be used to compile a proftpd configured using
	--enable-ipv6.	When that proftpd is started on the IPv4-only box,
	it would choke inexplicably.  This is due to changes made for Bug
	#2758.

2005-06-20 15:16  castaglia

	* src/netaddr.c: 
	Log when we are looking for IPv4 addresses via DNS, and when we're
	looking for IPv6 addresses.

2005-06-19 22:41  castaglia

	* src/mkhome.c: 
	Make sure to reset the umask in the case where mkdir() could fail. 
	Otherwise, the umask of the process will be left in the wrong
	state.

2005-06-19 19:05  castaglia

	* doc/contrib/mod_ifsession.html: 
	Updating mod_ifsession docs.

2005-06-18 14:05  castaglia

	* contrib/mod_tls.c: 
	OpenSSL 0.9.8 changed some macro names (and did not document it
	*sigh*).  Update mod_tls to use the new names as necessary.

2005-06-18 11:16  castaglia

	* NEWS, modules/mod_delay.c: 
	Bug#2630 - Use of mmap in mod_delay may be problematic on HP-UX.

2005-06-16 14:27  castaglia

	* include/table.h, src/table.c: 
	Add a new table flag, PR_TABLE_FL_USE_CACHE.  By default, this flag
	is off.  The caching behavior of previously-looked up keys in the
	table accessors was a bit confusing (which itself indicates the
	need for better table documentation).  Make use of that lookup
	cache disabled by default, so that the behavior is least surprising
	to developers.	Callers that require higher performance tables can
	enable the flag as needed.

2005-06-16 11:58  castaglia

	* src/table.c: 
	Added some missing pr_signals_handle() calls in while loops.

2005-06-15 10:38  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2639 - HiddenStores does not work.

2005-06-15 08:40  castaglia

	* src/dirtree.c: 
	Set a valid errno for pr_is_boolean().

2005-06-14 11:11  castaglia

	* src/auth.c: 
	Add debugging, level 10, of retrieved user/group names and
	UIDs/GIDs, similar to what is done during in pr_auth_getgroups().

2005-06-13 18:23  castaglia

	* contrib/mod_radius.c, contrib/mod_sql.c, contrib/mod_tls.c,
	include/compat.h, include/log.h, modules/mod_core.c,
	modules/mod_ctrls.c, modules/mod_log.c, src/log.c, src/xferlog.c: 
	Move the LOG_* macros (for indicating writable dirs, symlinks, and
	permission modes) into the PR_ namespace.  Provide compatibility
	macros for source compatibility for other modules, for now.

2005-06-13 15:01  castaglia

	* include/log.h, modules/mod_core.c, modules/mod_log.c, src/log.c: 
	Move the log_str2sysloglevel() function into the 'pr_' namespace.

2005-06-13 09:27  castaglia

	* NEWS, modules/mod_xfer.c, src/data.c: 
	Bug#2636 - Data connection failure when handling STOR does not
	trigger error response.

2005-06-11 21:42  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2637 - <Limit STAT> does not work.

2005-06-11 17:36  castaglia

	* include/: compat.h, dirtree.h: 
	Moving some macro (name redefinitions) into the more appropiate
	compat.h header.

2005-06-11 16:46  castaglia

	* contrib/mod_tls.c: 
	Style consistency and cleanup.

2005-06-11 15:18  castaglia

	* contrib/mod_tls.c: 
	Comment typo.

2005-06-10 10:21  castaglia

	* contrib/mod_tls.c, include/auth.h, modules/mod_auth.c,
	src/auth.c: 
	Removing the overloaded use of pr_auth_authenticate() in mod_auth
	for allowing RFC2228 modules to authenticate a user using non-PASS
	means.
	
	Instead, there is a new Auth API function, pr_auth_requires_pass().
	 All modules have a chance to provide handlers for this auth
	command; if any module can successfully authenticate the client
	without requiring the PASS command, then pr_auth_requires_pass()
	will return FALSE.  If and only if pr_auth_requires_pass() returns
	FALSE will mod_auth send the 232 response code to the client,
	indicating that no PASS command is required.

2005-06-10 10:06  castaglia

	* NEWS, lib/pr-syslog.c: 
	Bug#2632 - Invalid application of `sizeof' to an incomplete type on
	AIX.

2005-06-10 09:25  castaglia

	* doc/howto/NAT.html: 
	Provide an example configuration for the LAN/WAN MasqueradeAddress
	issue.

2005-06-09 06:14  castaglia

	* doc/howto/SQL.html: 
	Fix typo.

2005-06-08 11:33  castaglia

	* NEWS, contrib/mod_radius.c: 
	Bug#2631 - Segfault when using RadiusAcctServer.

2005-06-08 09:21  castaglia

	* doc/howto/SQL.html: 
	Grégoire COLBERT contributed a snippet of PHP code that can be used
	to generate base64-encoded MD5-digested password strings, suitable
	for use by mod_sql.

2005-06-07 11:58  castaglia

	* contrib/mod_radius.c: 
	Minor style cleanup.

2005-06-06 10:45  castaglia

	* doc/contrib/mod_rewrite.html: 
	No need for the trailing /, as the closing } serves as the
	delimiter.

2005-06-06 10:40  castaglia

	* doc/contrib/mod_rewrite.html: 
	The example RewriteRule directive provided had a problem.  One of
	its parameters contained an embedded whitespace, and the example
	did not enclose that parameter in quotations, which meant that the
	config parser would split that parameter incorrectly.

2005-06-05 11:26  castaglia

	* NEWS, README.FreeBSD: 
	Bug#2250 - Add ports, compiling info to FreeBSD README.

2005-06-05 11:20  castaglia

	* README: 
	Updated README to use "1.3.x" as ProFTPD version, rather than
	"1.2.x".

2005-06-03 00:12  castaglia

	* NEWS, include/fsio.h: 
	Bug#2624 - "fh_data" macro collision causes compiler error on Tru64
	V5.1A.

2005-06-02 08:25  castaglia

	* contrib/mod_radius.c: 
	Since mod_radius is distributed with the proftpd source, it should
	not have an "RC" version.  It will now be officially version 0.8.

2005-06-01 21:43  castaglia

	* modules/mod_delay.c: 
	Bug#2622 - Segfault seen randomly in mod_delay.
	
	This patch changes the bounds check for the j variable, which is
	decrementing, to be as necessary.

2005-06-01 16:21  castaglia

	* modules/mod_core.c: 
	Add better logging of when PORT, PASV, EPRT, and EPSV are denied
	because of <Limit> configurations.  Minor code style changes.

2005-06-01 14:07  castaglia

	* doc/contrib/mod_radius.html: 
	Remove extraneous space.

2005-06-01 14:03  castaglia

	* doc/contrib/mod_radius.html: 
	Updating mod_radius documentation.

2005-06-01 13:52  castaglia

	* README.Solaris2.5x: 
	Use "ProFTPD", not "ProFTP".

2005-06-01 13:50  castaglia

	* contrib/mod_radius.c: 
	More strict checking of the number of parameters for the RadiusLog
	directive.
	
	In general, this a problem with the CHECK_ARGS macro.  It allows >=
	n parameters, where it should check strictly for == n.

2005-06-01 10:21  castaglia

	* NEWS, src/bindings.c, src/netaddr.c: 
	Bug#2578 - ProFTPD does not listen on IPv6 addresses on FreeBSD.

2005-05-31 16:40  castaglia

	* NEWS, modules/mod_delay.c: 
	Bug#2622 - Segfault seen randomly in mod_delay.

2005-05-31 09:15  castaglia

	* NEWS, modules/mod_delay.c: 
	Bug#2601 - mod_delay sometimes delays for a long time.

2005-05-20 19:16  castaglia

	* modules/mod_auth.c: 
	If we are unable to resolve a user's home directory, try to
	interpolate it (as when the home dir is "~"), in order to provide a
	more informative log message to the admin.  This will greatly help
	in debugging.

2005-05-10 09:35  castaglia

	* NEWS, lib/pr-syslog.c: 
	Bug#2585 - Proftpd does not write RFC 3164 compliant messages into
	/dev/log.

2005-05-08 13:42  castaglia

	* configure: 
	Updated configure.

2005-05-08 13:37  castaglia

	* NEWS, configure.in: 
	Bug#2598 - Build system should check for duplicate module requests.

2005-05-07 12:19  castaglia

	* Makefile.in, modules/Makefile.in: 
	Make the use of `test' in the Makefiles non-silent, to aid in
	debugging build issues.

2005-05-07 10:52  castaglia

	* contrib/mod_load/Makefile.in: 
	Make mod_load's Makefile portable.  Related to Bug#2589.

2005-05-07 10:38  castaglia

	* NEWS: 
	Wrong bug number.

2005-05-07 10:38  castaglia

	* NEWS, modules/Makefile.in: 
	Bug#2589 - Makefile in modules/ directory is not portable.

2005-05-07 10:01  castaglia

	* src/netaddr.c: 
	Typo; we were checking the wrong variable, which causes the wrong
	error message to (possibly) be displayed if there were resolver
	errors.

2005-05-05 22:53  castaglia

	* NEWS, modules/mod_core.c, modules/mod_ctrls.c, src/table.c: 
	Bug#2605 - Compiler warnings/errors about missing typecasts on
	HP-UX.

2005-05-05 22:33  castaglia

	* contrib/mod_tls.c: 
	Bug#2607 - Compiler warnings about missing typecasts in mod_tls on
	HP-UX.

2005-05-05 22:24  castaglia

	* contrib/mod_rewrite.c: 
	Bug#2606 - Compiler warnings about missing typecasts in mod_rewrite
	on HP-UX.

2005-04-30 17:04  castaglia

	* src/netaddr.c: 
	Log, at debug level 10, if we're returning an IP address when a DNS
	name was requested because of the UseReverseDNS setting.

2005-04-30 16:32  castaglia

	* configure: 
	Updating configure.

2005-04-30 16:27  castaglia

	* configure.in: 
	Removed --disable-auth-unix configure option.  It isn't very
	useful; trying to actually use a proftpd compiled with that option
	would not work well.  Perhaps it will come back later, in a
	better/more usable fashion.

2005-04-30 12:59  castaglia

	* NEWS, contrib/mod_ctrls_admin.c,
	doc/contrib/mod_ctrls_admin.html: 
	Add new 'dns' control action to mod_ctrls_admin, for setting
	UseReverseDNS at runtime.

2005-04-30 12:07  castaglia

	* src/bindings.c: 
	Add debugging denoting when there is no exactly matching vhost
	configured for an incoming connection and we end up using the
	DefaultServer.

2005-04-30 11:03  castaglia

	* NEWS, modules/mod_auth_unix.c: 
	Bug#2582 - ProFTPD on Tru64 with SIA does not call sia_ses_estab().

2005-04-29 09:34  castaglia

	* configure: 
	Updating configure.

2005-04-29 09:26  castaglia

	* configure.in, config.h.in, modules/mod_auth_unix.c: 
	Systems with shadow library support (e.g. Solaris) may require that
	the setspent(3) function be called prior to calling getspent(3) et
	al.

2005-04-27 14:04  castaglia

	* configure: 
	Updating configure.

2005-04-27 14:01  castaglia

	* NEWS, config.h.in, configure.in: 
	Bug#2588 - AIX requires _USE_IRS #define to use hstrerror().

2005-04-25 15:12  castaglia

	* src/bindings.c: 
	It's possible for pr_ipbind_listen() to be called without any calls
	to pr_ipbind_create().	The ipbind_pool was being initialized in
	pr_ipbind_create() if it didn't already exist.	pr_ipbind_listen()
	tries to use ipbind_pool, but did not check to see if ipbind_pool
	was initialized.  So when pr_ipbind_listen() was called without any
	prior calls to pr_ipbind_create(), proftpd would segfault.  Oops.

2005-04-24 14:48  castaglia

	* config.h.in: 
	Typo.

2005-04-23 15:54  castaglia

	* modules/mod_delay.c: 
	Have mod_delay log the random value it adds to the delay factor, at
	debug level 10.  Is this where the extra-long delays are coming
	from?  Perhaps...

2005-04-23 11:03  castaglia

	* contrib/mod_quotatab.c: 
	More formatting tweaks for mod_quotatab's display in response to a
	SITE QUOTA command.

2005-04-23 09:13  castaglia

	* contrib/mod_quotatab.c: 
	Fix minor formatting/spacing issue seen when QuotaDisplayUnits is
	set to something other than 'b' and the number of units to be
	displayed is not "unlimited".

2005-04-23 08:53  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2596 - STAT command can cause segfault.

2005-04-22 09:26  castaglia

	* contrib/mod_sql.c: 
	Be consistent in the style/formatting of the "cache hit for"
	messages by quoting the group name, too.

2005-04-21 10:58  castaglia

	* NEWS, modules/Makefile.in: 
	Bug#2593 - `make install-modules' does not honour DESTDIR
	enviroment variable.

2005-04-21 10:33  jwm

	* .cvsignore, lib/libltdl/.cvsignore: update for libtool

2005-04-21 10:08  jwm

	* modules/.cvsignore: - ignore libtool-generated files -
	mod_linuxprivs is gone

2005-04-17 10:12  castaglia

	* NEWS, modules/mod_delay.c, modules/mod_xfer.c: 
	Bug#2590 - AIX uses unsigned int for ULONG_MAX, causing printf
	format warning Bug#2591 - wrong argument type in call to
	pr_log_debug in mod_delay.c on AIX

2005-04-15 14:18  castaglia

	* NEWS, src/dirtree.c: 
	Bug#2587 - HideNoAccess does not work for DefaultRoot/<Anonymous>
	logins.

2005-04-14 22:55  castaglia

	* include/: auth.h, compat.h, conf.h, log.h: 
	Add a header whose role is to hold preprocessor directives for
	backward compatibility.  Function renames, macro changes, etc, that
	sort of thing.

2005-04-11 10:02  castaglia

	* NEWS, contrib/mod_sql_postgres.c: 
	Bug#2584 - mod_sql_postgres missing end-of-comment character.

2005-04-11 09:47  castaglia

	* include/version.h: 
	Update version.

2005-04-10 16:21  castaglia

	* NEWS: 
	Updating release date for 1.3.0rc1.

2005-04-10 16:19  castaglia

	* src/data.c: 
	As per comments in Bug #2509, it seems that Linux x86_64
	environments do not support sendfile() for more than 2^31 bytes.  I
	don't know if Solaris suffers from the same design.
	
	Have I ever mentioned how much I find the sendfile API to be
	broken?

2005-04-10 16:15  castaglia

	* NEWS, modules/mod_delay.c: 
	Bug#2554 - mod_delay gets segfault-signal on several logins.

2005-04-04 13:40  castaglia

	* NEWS, modules/mod_auth_unix.c: 
	Bug#2580 - ProFTPD on Tru64 with SIA allows login with blank
	password.

2005-03-26 13:10  castaglia

	* NEWS, include/version.h, contrib/dist/rpm/proftpd.spec,
	ChangeLog: 
	Preparing for release of 1.3.0rc1.

2005-03-26 12:53  jwm

	* RELEASE_NOTES: mod_ldap is now 2.8.15

2005-03-26 12:48  castaglia

	* RELEASE_NOTES: 
	Updating release notes, preparing for release of 1.3.0rc1.

2005-03-25 08:41  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2493 - mod_tls should support CCC command.

2005-03-18 10:25  castaglia

	* NEWS, src/support.c: 
	Bug#2576 - PWD command does not handle " character properly.

2005-03-16 23:12  castaglia

	* modules/mod_auth.c: 
	Call PRIVS_ROOT before PRIVS_REVOKE, to make absolutely sure that
	the real and effective UIDs are as needed in order for privs
	revocation to work.

2005-03-16 08:16  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2551 - Recursive LIST with symlinked directories gives
	duplicate results.

2005-03-15 22:16  castaglia

	* modules/mod_ls.c: 
	Cruft removal.

2005-03-12 09:36  castaglia

	* modules/mod_ls.c: 
	Fix an unreported bug where attempting to use the -t directory
	listing option would trigger a segfault.

2005-03-11 12:44  jwm

	* contrib/mod_ldap.c: [no log message]

2005-03-08 09:06  castaglia

	* NEWS, src/pool.c: 
	Bug#2567 - Segmentation fault with 64-bit binary due to structure
	layout difference.

2005-03-05 22:03  castaglia

	* contrib/mod_quotatab.c: 
	More consistent log messages.

2005-03-05 15:02  castaglia

	* contrib/mod_quotatab.c: 
	Fixed quotatab_fsio_write() to check the xfer limit as well as the
	upload limit.

2005-03-05 14:55  castaglia

	* NEWS, contrib/mod_quotatab.c: 
	Bug#2515 - mod_quotatab should enforce hard limits at the
	filesystem level.

2005-03-05 09:46  castaglia

	* NEWS, contrib/mod_tls.c, modules/mod_auth.c, src/auth.c: 
	Bug#2164 - Support non-PASS response codes.

2005-03-05 09:33  castaglia

	* NEWS, src/inet.c: 
	Bug#2559 - IPv6 socket option should be set for ServerType inetd.

2005-03-04 09:01  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug #2573 - TLSProtocol directive in proftpd.conf is ignored.

2005-03-02 12:33  castaglia

	* modules/mod_delay.c: 
	Allow for <IfClass>-based tweaks of the DelayEngine directive.

2005-02-27 18:50  castaglia

	* README.DSO: 
	Mention the DSO howto.

2005-02-27 11:23  castaglia

	* README.modules: 
	List mod_facl in the modules README.

2005-02-27 11:21  castaglia

	* README.facl: 
	Fleshing out the POSIX ACL doc.

2005-02-27 09:46  castaglia

	* README.DSO: 
	Update the DSO doc with information on where to find more
	documentation for the mod_dso module.

2005-02-26 18:37  castaglia

	* README.DSO: 
	Adding more substance to the DSO doc.

2005-02-26 12:22  castaglia

	* RELEASE_NOTES: 
	Mention the new --enable-facl configure option, mod_facl module in
	the release notes.

2005-02-26 09:55  castaglia

	* src/fsio.c: 
	Fix missing variable declaration.

2005-02-26 09:39  castaglia

	* configure: 
	Updating configure.

2005-02-26 09:28  castaglia

	* NEWS, README.facl, config.h.in, configure.in, include/conf.h,
	include/dirtree.h, include/fsio.h, include/privs.h,
	include/proftpd.h, include/support.h, modules/mod_auth.c,
	modules/mod_facl.c, modules/mod_ls.c, src/dirtree.c, src/fsio.c,
	src/main.c, src/support.c: 
	Bug #2331: Proftpd does not honor POSIX ACLs.

2005-02-24 18:01  castaglia

	* NEWS, contrib/mod_sql_mysql.c: 
	Bug #2563: Linking fails on Solaris with libz and libmysqlclient.

2005-02-24 16:00  castaglia

	* ChangeLog: 
	Updated ChangeLog.

2005-02-15 13:54  jwm

	* contrib/dist/rpm/proftpd.spec: i don't have access to red hat
	machines anymore, so i'm no longer maintaining this

2005-02-07 10:15  castaglia

	* include/inet.h, src/inet.c: 
	Use "const char *" where appropriate.

2005-02-04 15:54  castaglia

	* NEWS, src/fsio.c: 
	Bug#2556: Rename of directory across devices fails.

2005-01-25 11:30  castaglia

	* NEWS, lib/libcap/cap_sys.c: 
	Bug#2503 - Bundled libcap library does not compile on IA64 machine.

2005-01-12 16:19  castaglia

	* modules/mod_ls.c: 
	
	The fix for Bug #2229 (rev 1.119 of modules/mod_ls.c) inadvertently
	broke globbing; it was calling globfree(3) on a struct whose
	members had been allocated from memory that was not obtained via
	glob(3).  This is a bad combination.

2005-01-06 15:39  castaglia

	* contrib/mod_load/mod_load.c.in, contrib/mod_radius.c,
	modules/mod_delay.c: 
	Fix compiler warnings (generated by gcc-3.4.2 on an AMD64 machine
	running Linux 2.6.9).

2005-01-06 10:55  castaglia

	* src/bindings.c: 
	Fix segfault caused by a NULL listener_list.

2005-01-02 21:36  castaglia

	* doc/howto/Stopping.html: 
	Updating FAQ URL.

2005-01-02 16:21  castaglia

	* INSTALL: 
	Apparently configure scripts don't pass env vars very well to
	sub-configure scripts.

2005-01-02 13:00  jwm

	* lib/glibc-hstrerror.c: silence ranlib's 'object contains no
	symbols' warning if the host OS already has hstrerror()

2005-01-02 00:01  castaglia

	* RELEASE_NOTES: 
	Make a note to describe the addition of mod_delay to the module
	list.

2005-01-01 12:15  castaglia

	* doc/contrib/mod_load.html: 
	Updating the mod_load docs to mention the provided Display
	variables.

2005-01-01 12:06  castaglia

	* doc/howto/DisplayFiles.html: 
	Mention that other modules can add their own Display variables.

2005-01-01 12:04  castaglia

	* contrib/mod_load/mod_load.c.in: 
	Enhance mod_load to use the Variables API.

2005-01-01 11:42  castaglia

	* contrib/mod_load/configure: 
	Updating configure.

2005-01-01 11:41  castaglia

	* doc/contrib/mod_load.html: 
	Eliminated the need for Solaris users to do anything special when
	building mod_load; its configure script handles everything.

2005-01-01 11:39  castaglia

	* contrib/mod_load/: configure.in, getloadavg.c, mod_load.c,
	mod_load.c.in: 
	Modified the configure script to detect when additional libraries
	are needed, and to generate mod_load.c from mod_load.c.in, with the
	$Libraries$ tag properly populated.
	
	Note that newer autoconf treatment of the AC_FUNC_GETLOADAVG macro
	requires that a getloadavg.c file be present, even if empty.  How
	annoying.

2005-01-01 11:13  castaglia

	* contrib/mod_load/mod_load.c: 
	No need for mod_load's getloadavg() function to be visible outside
	of the source file.

2005-01-01 11:02  castaglia

	* contrib/mod_load/mod_load.c: 
	Fix some compiler warnings about formats.
	
	Add an empty $Libraries$ tag.  Soon, mod_load's configure script
	will process the mod_load source, and substitute in a list of
	libraries that mod_load conditionally requires (e.g. libkstat on
	Solaris).

2005-01-01 10:55  castaglia

	* contrib/mod_load/mod_load.c: 
	Slightly prettier code organization.

2005-01-01 10:49  castaglia

	* contrib/mod_load/mod_load.c: 
	Updating mod_load source style.

2005-01-01 10:42  castaglia

	* doc/contrib/index.html: 
	Update doc/contrib index to include mod_load reference.

2005-01-01 10:40  castaglia

	* README.modules, RELEASE_NOTES: 
	Add mod_load to the list of modules.

2005-01-01 10:37  castaglia

	* NEWS, contrib/mod_load/Makefile.in, contrib/mod_load/configure,
	contrib/mod_load/configure.in, contrib/mod_load/mod_load.c,
	contrib/mod_load/mod_load.h.in, doc/contrib/mod_load.html: 
	Bug#1651 - Add contrib module to limit connection acceptance based
	on system load.

2005-01-01 10:36  castaglia

	* configure: 
	Updating configure.

2005-01-01 10:20  castaglia

	* modules/Makefile.in: 
	Fix the install target when handling only shared modules that
	install themselves.

2004-12-31 19:02  castaglia

	* .autom4te.cfg, Make.rules.in, Makefile.in, NEWS, configure.in,
	modules/Makefile.in: 
	Bug#2549 - Allow contrib modules to be built from multiple source
	files.

2004-12-31 11:17  castaglia

	* doc/howto/FTP.html: 
	Updating the list of SITE commands supported by ProFTPD.

2004-12-31 10:55  castaglia

	* doc/howto/FTP.html: 
	Updating the list of FTP commands supported by ProFTPD.

2004-12-30 15:08  castaglia

	* contrib/mod_sql_mysql.c: 
	Log if mod_sql_mysql fails to authenticate a password using the
	'backend' SQLAuthType because of a password mismatch.

2004-12-30 14:51  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2541 - <Directory ~user> path resolved at startup time, rather
	than at session time.

2004-12-30 14:23  castaglia

	* NEWS, modules/mod_delay.c: 
	Bug#2540 - Fails to disable mod_delay if no DelayTable file exists.

2004-12-23 12:17  castaglia

	* modules/: mod_auth.c, mod_core.c, mod_log.c: 
	More prettification of error messages.

2004-12-23 11:55  castaglia

	* contrib/mod_sql.c: 
	Makes for nicer error messages.

2004-12-22 22:58  castaglia

	* INSTALL: 
	Updating the installation notes.

2004-12-17 15:14  castaglia

	* modules/Makefile.in: 
	Make the Makefile for the modules/ directory nicer, so that when
	developing shared modules within the source directory, make picks
	up on the updated source file and does The Right Thing.

2004-12-17 13:56  castaglia

	* modules/mod_dso.c: 
	Avoid compiler warning about unused function.

2004-12-17 10:24  castaglia

	* NEWS, contrib/mod_ifsession.c: 
	Bug#2536 - mod_ifsession does not properly merge in all directives.

2004-12-16 17:58  castaglia

	* src/sets.c: 
	Update xaset_insert_end() so that it updates the 'next' field of
	the previous member in the set.

2004-12-16 17:25  castaglia

	* contrib/mod_ifsession.c: 
	Hide some of the label strings used by mod_ifsession by prefacing
	their names with an underscore.  Such names are not displayed by
	pr_config_dump().

2004-12-16 16:03  castaglia

	* contrib/mod_ldap.c: 
	Typo.

2004-12-16 15:54  castaglia

	* contrib/mod_ctrls_admin.c: 
	Support being unloaded as a shared module.

2004-12-16 15:37  castaglia

	* contrib/mod_rewrite.c: 
	Support being unloaded as a shared module.

2004-12-16 15:26  castaglia

	* contrib/mod_radius.c: 
	Add code to support being unloaded as a shared module.

2004-12-16 14:55  castaglia

	* contrib/: mod_quotatab.c, mod_quotatab.h, mod_quotatab_file.c,
	mod_quotatab_ldap.c, mod_quotatab_sql.c: 
	Add a new quotatab_unregister_backend() function to the
	mod_quotatab API, and rename quotatab_register() to
	quotatab_register_backend().  This makes it consistent with
	mod_sql's backend API, and also makes it possible to unregister a
	quotatab backend module.
	
	Adds support for graceful unloading of mod_quotatab et al as shared
	modules.

2004-12-16 11:38  castaglia

	* contrib/mod_tls.c: 
	Add code to mod_tls to support being unloaded as a shared module.

2004-12-16 10:33  castaglia

	* modules/mod_dso.c, src/main.c: 
	Rather than having the core engine unload modules during a restart,
	have them unloaded by mod_dso.	That's only fair, since a) mod_dso
	was responsible for loading the modules in the first place, and b)
	mod_dso also handles the unloaded of the handles from libltdl,
	about which the core engine knows nothing.

2004-12-16 10:17  castaglia

	* contrib/: mod_sql.c, mod_sql_mysql.c, mod_sql_postgres.c: 
	Tweak the SQL modules to better handle being built as shared
	modules.

2004-12-16 10:13  castaglia

	* src/main.c: 
	During a restart (e.g. SIGHUP), unload all non-static modules, i.e.
	all shared modules that have been dynamically loaded.  This is to
	handle the case where an admin removes a LoadModule directive from
	proftpd.conf, then issues a SIGHUP.
	
	Note that this requires changes to shared modules, to make sure
	they unload themselves properly.  Such changes for the contrib/
	modules will follow shortly.

2004-12-15 19:01  castaglia

	* include/event.h, src/event.c: 
	Tweak the Event API to allow blanket unregistration of all a
	module's event listeners in one pr_event_unregister() call.
	
	Gracefully avoid a possible segfault during pr_event_register().

2004-12-15 18:30  castaglia

	* src/auth.c: 
	'login' is a global variable somewhere, so compiling under
	--enable-devel kicks up compiler warnings.

2004-12-15 18:23  castaglia

	* Makefile.in: 
	The shell's test function prefers to operate on single strings, so
	enclose the expanded $SHARED_MODULE_OBJS list within quotations.

2004-12-15 16:54  castaglia

	* doc/howto/DisplayFiles.html: 
	Updating the DisplayFiles doc with the newly added Display
	variables.

2004-12-15 16:50  castaglia

	* doc/howto/: DisplayFiles.html, index.html: 
	Adding a doc covering the Display directives.

2004-12-12 15:55  castaglia

	* doc/howto/DSO.html: 
	Grammatical nicety.

2004-12-12 15:03  castaglia

	* doc/howto/ListOptions.html: 
	Updating URL for current location under doc/howto/.

2004-12-12 15:01  castaglia

	* doc/howto/: ListOptions.html, index.html: 
	Adding the ListOptions howto to the source distribution.

2004-12-12 14:57  castaglia

	* RELEASE_NOTES: 
	Update the release notes.

2004-12-12 14:56  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2534 - Add suport for -S ListOption, for sorting files by file
	size.

2004-12-12 14:00  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2229 - NLST and LIST behave differently e.g. when listing an
	empty directory.  Make the behavior between LIST and LIST
	consistent with respect to empty directories, and when listing
	nonexistent directories.

2004-12-12 13:52  castaglia

	* doc/howto/: DSO.html, index.html: 
	Adding DSO howto to source distribution.

2004-12-12 11:27  castaglia

	* doc/contrib/mod_sql.html: 
	Add documentation for the SQLEngine directive.

2004-12-12 09:53  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sql.c: 
	Bug#2406 - Add a SQLEngine directive.

2004-12-11 21:59  castaglia

	* modules/: mod_ctrls.c, mod_site.c: 
	Use the Auth API functions in the 'pr_' namespace.

2004-12-11 16:14  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2027 - Add log message for timed out passive transfers.

2004-12-08 14:30  castaglia

	* doc/contrib/mod_quotatab.html: 
	Explicitly mention that only one type of limit is in effect at a
	time, and that applicable limits for a given user are not combined.

2004-12-05 00:12  castaglia

	* src/main.c: 
	Yet another place where main_server needs to be set to NULL before
	calling free_pools().  Only affects servers built using the
	--enable-devel=nodaemon option.

2004-12-05 00:03  castaglia

	* src/main.c: 
	If main_server is not set to NULL before freeing all of the pools
	(from which main_server is allocated), segfaults can occur if
	something tries to log a message.  Note that this only happens if
	the --enable-devel configure option is used, so it doesn't affect
	most users.

2004-12-04 23:58  castaglia

	* src/main.c: 
	Properly set session.c and session.d to NULL once we've closed
	them.

2004-12-04 22:38  castaglia

	* doc/howto/Authentication.html: 
	Correct the RequireValidShell FAQ URL.

2004-12-04 21:50  castaglia

	* include/auth.h, modules/mod_auth.c, src/auth.c: 
	Move that code responsible for looking up the anonymous
	configuration for a given user name, if applicable, out of
	mod_auth.c and into the Auth API.  The main reason for this is to
	allow contrib modules that may need to determine whether a given
	login is to be handled anonymously (e.g.  mod_wrap, mod_sql) the
	ability to use the same code as mod_auth, rather than having to
	duplicate it themselves.  A nice side benefit as that the Auth API
	function added, pr_auth_get_anon_config(), more legibly describes
	what the function does.  This will help to make the mod_auth code
	slightly easier to understand (for some value of "easier").

2004-12-04 20:25  castaglia

	* doc/howto/Limit.html: 
	Add examples of blocking PORT or PASV commands.

2004-12-04 11:17  castaglia

	* doc/howto/: Upgrade.html, index.html: 
	Add an Upgrade mini-HOWTO to doc/howto/.

2004-12-04 01:20  castaglia

	* doc/contrib/mod_quotatab.html: 
	Fix up the links to the quotatab submodule docs.

2004-12-04 01:13  castaglia

	* doc/contrib/mod_quotatab.html: 
	Update the mod_quotatab installation instructions.

2004-12-03 23:52  castaglia

	* contrib/mod_quotatab.c, contrib/mod_quotatab.h,
	doc/contrib/mod_quotatab.html: 
	Add some Display variables for mod_quotatab:
	
	  %{mod_quotatab.limit.bytes_in}
	  %{mod_quotatab.limit.bytes_out}
	  %{mod_quotatab.limit.bytes_xfer}
	  %{mod_quotatab.limit.files_in}
	  %{mod_quotatab.limit.files_out}
	  %{mod_quotatab.limit.files_xfer}
	  %{mod_quotatab.tally.bytes_in}
	  %{mod_quotatab.tally.bytes_out}
	  %{mod_quotatab.tally.bytes_xfer}
	  %{mod_quotatab.tally.files_in}
	  %{mod_quotatab.tally.files_out}
	  %{mod_quotatab.tally.files_xfer}
	
	These are documented in the mod_quotatab documentation under
	doc/contrib/.

2004-12-03 23:43  castaglia

	* src/var.c: 
	Pass the exact pointers provided by callers of pr_var_set(), rather
	than copies of the pointed-to data.

2004-12-03 23:40  castaglia

	* modules/mod_core.c: 
	Reduce complexity of code needed for displaying byte/file Variables
	by reducing the number of callbacks to two (as opposed to six).

2004-12-03 23:39  castaglia

	* src/display.c: 
	Fix displaying of variables.

2004-12-03 23:02  castaglia

	* RELEASE_NOTES: 
	Mention the new Display variables in the release notes.

2004-12-03 22:59  castaglia

	* NEWS, include/proftpd.h, modules/mod_core.c, modules/mod_xfer.c,
	src/display.c: 
	Bug#2170 - Add byte count variables, similar to the file count
	Display variables.

2004-12-03 17:16  castaglia

	* modules/mod_core.c: 
	Handle the case where there's only one name provided in the
	Allow/Deny rule.

2004-12-02 15:15  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2528 - Incorrect username 'and' parsing in AllowUser.

2004-12-01 17:45  castaglia

	* src/main.c: 
	Close the control and data connections before running any
	registered 'core.exit' event handlers.

2004-12-01 17:24  castaglia

	* contrib/mod_tls.c: 
	Unregister the NetIO streams registered by mod_tls during its
	'core.exit' handler.  This prevents segfaults that can happen when
	a session is exiting (as when ABORting an in-progress data
	transfer).

2004-12-01 10:08  castaglia

	* contrib/mod_rewrite.c, modules/mod_core.c, modules/mod_xfer.c: 
	Correct a few lingering cases where pr_log_pri() was being called
	with a log level that wasn't in the PR_ namespace.

2004-11-29 14:28  castaglia

	* src/dirtree.c: 
	Style cleanup.

2004-11-28 16:26  castaglia

	* doc/howto/Debugging.html: 
	Updating URL.

2004-11-25 11:03  jwm

	* modules/mod_delay.c: include signal.h to fix the build under
	Solaris 8

2004-11-24 12:38  castaglia

	* src/support.c: 
	More old-style exit handler cruft.

2004-11-22 19:43  castaglia

	* src/display.c: 
	Extraneous #include (and at the bottom of a file).

2004-11-22 19:30  castaglia

	* modules/mod_core.c: 
	We were calling pr_display_file() on DisplayQuit files with the
	arguments in the wrong order.

2004-11-21 22:09  castaglia

	* doc/contrib/mod_ctrls_admin.html: 
	Fix the mod_ctrls_admin documentation.	First, there was a
	duplicate entry for the 'down' control action.	Second, the
	'shutdown' entry had gone completely missing.

2004-11-21 21:36  castaglia

	* NEWS: 
	Bug#2510 - Use of ExportCertData TLSOption leads to segfault.

2004-11-21 21:21  castaglia

	* contrib/mod_tls.c: 
	Since we stuff an SSL * in the strm_data slot for each NetIO
	stream, and there are two streams for a connection, when closing a
	connection, we want to call tls_end_session() (which ends up
	freeing that SSL *) only once per connection.  I chose to do this
	always for the write stream of a connection.  Should help with some
	of the OpenSSL reference counter issues we've been seeing.
	
	This patch is also part of the solution for Bug #2313.

2004-11-21 17:37  castaglia

	* contrib/mod_tls.c: 
	Adding some missing logic; pointers that have been free()'d should
	always be set to NULL afterwards.

2004-11-21 16:34  castaglia

	* Makefile.in: 
	As per Michael's suggestion, remove the .libs/ directory, and
	libtool, during the 'distclean' target.

2004-11-21 16:27  castaglia

	* src/support.c: 
	More old-style exit handler cruft.

2004-11-21 16:26  castaglia

	* src/main.c: 
	Straggler run_exit_handlers() call.  Be gone with ye!

2004-11-21 16:21  castaglia

	* include/support.h, src/main.c, src/support.c: 
	No more support for the old-style exit handlers.

2004-11-21 15:36  castaglia

	* modules/mod_delay.c: 
	Allow SIGTERM to interrupt mod_delay.

2004-11-21 12:26  castaglia

	* modules/mod_delay.c: 
	Since mod_delay uses mmap(), any updates it makes to the DelayTable
	won't be reflected in the mtime field of the file's metadata.  To
	help alleviate this perception, add a 'core.exit' event handler
	that explicitly writes out the DelayTable to disk.
	
	Fix up some memory problems spotted under valgrind.  Also, if the
	expected DelayTable is smaller than the current table, make sure we
	truncate the file.

2004-11-21 11:16  castaglia

	* doc/contrib/mod_ifsession.html: 
	Forgot to list MaxInstances as not being alterable by
	mod_ifsession.

2004-11-21 11:09  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#2520 - Turning on AuthAliasOnly disables MaxClientsPerHost. 
	ProFTPD was not using the TOPLEVEL_CONF macro, as it should have
	been.

2004-11-20 14:35  castaglia

	* NEWS, include/timers.h, src/main.c, src/timers.c: 
	Bug#2516 - Getting "421 Login Timeout" immediately upon connect. 
	The child processes were inheriting the values of static Timer API
	variables, including the parent's timer list.  This causes problems
	when, in the parent process, one of those static variables stops
	being properly updated.  I'm not convinced that the root cause of
	this bug has been found, but this patch addresses the problematic
	behavior, so that at least session processes aren't affected so
	badly.

2004-11-20 13:20  castaglia

	* src/timers.c: 
	Be a little more paranoid: don't set the indispatch flag until
	after alarms have been blocked.

2004-11-20 12:38  castaglia

	* README.IPv6: 
	Remove mention of the Bind directive.  We want it gone.

2004-11-20 12:32  castaglia

	* NEWS, README.IPv6, RELEASE_NOTES, include/bindings.h,
	modules/mod_core.c, src/bindings.c, src/dirtree.c: 
	Bug#2454 - Extend <VirtualHost> to honor multiple addresses.

2004-11-19 19:15  castaglia

	* RELEASE_NOTES: 
	Adding a comment about how use of sendfile() causes download
	transfer speeds not to be displayable.

2004-11-17 09:58  castaglia

	* doc/howto/Controls.html: 
	Mention that only primary groups, not supplemental groups, are
	used.

2004-11-17 09:33  castaglia

	* configure: 
	Updating configure.

2004-11-17 09:28  castaglia

	* configure.in: 
	Tweak the configure script to always use our bundled version of
	getaddrinfo() on HP-UX 11.x, since HP-UX's getaddrinfo() (among
	many other things) is busted.

2004-11-14 17:39  castaglia

	* README.modules: 
	Updating README.modules.

2004-11-14 16:21  castaglia

	* modules/: mod_core.c, mod_xfer.c: 
	Deny the SIZE command if we're in ASCII mode, as we do for REST. 
	Be sure to add debug logging for both of these cases.

2004-11-14 15:58  castaglia

	* modules/mod_core.c: 
	Check that a scoreboard entry's PID is non-zero before sending the
	zero signal to that PID.

2004-11-14 15:45  castaglia

	* NEWS, doc/howto/ASCII.html, doc/howto/index.html,
	modules/mod_xfer.c: 
	Bug#2471 - Restart command (REST) is not working correctly for text
	files.

2004-11-14 13:03  castaglia

	* doc/howto/: Scoreboard.html, index.html: 
	Adding a ScoreboardFile mini-HOWTO.

2004-11-13 15:01  castaglia

	* ltmain.sh: 
	Increase the max allowed command line length in the libtool script
	to be 4K.  I'd rather we encounter the system limit before an
	arbitrarily imposed one.

2004-11-13 14:47  castaglia

	* include/fsio.h, src/fsio.c: 
	Beginnings of support for stackable FSIO layers.  Rather than
	allowing only a one-to-one mapping between paths and FS objects,
	this patch allows for one-to-many mappings, linking FS objects
	together in a linked list for the same path.
	
	At present, only the top layer on the stack, for a given FSIO
	operation, will be used.  I anticipate that it will be the
	responsibility of the called FSIO handler to decide whether it
	wants to act as a filter handler, and pass the parameters farther
	down the stack, or whether it wants to act as a source/sink handler
	and handle the parameters entirely by itself.  This behavior allows
	for backward compatibility with existing FSIO modules.

2004-11-13 14:41  castaglia

	* modules/mod_delay.c: 
	Use proper grammar.

2004-11-11 10:58  castaglia

	* RELEASE_NOTES, modules/mod_log.c: 
	Make "SECURE" an alias for "SEC" when configuring ExtendedLog
	logging classes.

2004-11-10 18:44  castaglia

	* include/table.h, src/main.c, src/table.c: 
	Add a function, pr_table_nalloc(), to the Table API which allows
	for allocating a table with the given number of chains. 
	Previously, callers would need to call pr_table_alloc(), then
	pr_table_ctl() to resize the number of chains, and in doing so
	there would be a slight memory leak.  Now such callers can allocate
	the number of chains (usually smaller than the default of 32) as
	they need.

2004-11-10 10:54  castaglia

	* configure: 
	Updating configure.

2004-11-10 10:34  castaglia

	* RELEASE_NOTES: 
	Mention the new UseSendfile directive.

2004-11-10 10:32  castaglia

	* NEWS, configure.in, modules/mod_xfer.c: 
	Bug#2507 - Enable use of sendfile by default.

2004-11-10 10:19  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_tls.c, include/modules.h,
	modules/mod_log.c: 
	Bug#2518 - Ability to log SSL/TLS commands in an ExtendedLog.

2004-11-09 19:26  castaglia

	* src/timers.c: 
	Prevent callers from providing a negative number of seconds when
	adding a timer.

2004-11-09 11:17  castaglia

	* NEWS: 
	Add a header to the NEWS file indicating the Bugzilla URL to use
	for looking up the mentioned bug reports.

2004-11-08 19:07  castaglia

	* modules/mod_delay.c: 
	Use PR_RUN_DIR, not RUN_DIR.

2004-11-08 18:46  castaglia

	* configure: 
	Updating configure.

2004-11-08 18:45  castaglia

	* NEWS: 
	Bug#2480 - Remote users discovery.

2004-11-08 18:41  castaglia

	* configure.in: 
	Make mod_delay one of the default modules.

2004-11-08 18:37  castaglia

	* modules/mod_delay.c, doc/modules/mod_delay.html: 
	Adding mod_delay to the distribution.  Part of Bug #2480.

2004-11-07 17:43  castaglia

	* modules/Makefile.in: 
	Found a case where make(1) was not providing $(RM).  How annoying.

2004-11-06 13:25  castaglia

	* configure: 
	Updating configure.

2004-11-06 13:21  castaglia

	* configure.in: 
	I prefer, if possible, to see the functions checked in alphabetical
	order.

2004-11-04 21:12  castaglia

	* README.DSO: 
	Adding reminder note.

2004-11-04 16:49  castaglia

	* configure: 
	Updated configure.

2004-11-04 16:43  castaglia

	* configure.in, config.h.in: 
	Check for the fdatasync(2) function.

2004-11-04 14:48  castaglia

	* NEWS, include/data.h, modules/mod_xfer.c, src/data.c: 
	Bug#2509 - sendfile() usage fails with > 2GB files.

2004-11-04 14:17  castaglia

	* doc/GetConf: 
	Removing crufty old file.

2004-11-04 11:25  castaglia

	* configure: 
	Updating configure.

2004-11-04 11:11  castaglia

	* config.h.in, configure.in: 
	Add checks for iconv() and nl_langinfo(), which will be needed for
	i18n support.

2004-11-03 12:11  castaglia

	* doc/contrib/index.html: 
	Adding an index to the doc/contrib/ directory.

2004-11-03 11:37  castaglia

	* doc/contrib/: ftpasswd.html, ftpquota.html, mod_ctrls_admin.html,
	mod_ifsession.html, mod_quotatab.html, mod_quotatab_file.html,
	mod_quotatab_ldap.html, mod_quotatab_sql.html, mod_radius.html,
	mod_rewrite.html, mod_site_misc.html, mod_sql.html, mod_tls.html,
	mod_wrap.html: 
	Moving the HTML documentation from contrib/ to doc/contrib/.

2004-11-03 11:37  castaglia

	* contrib/: ftpasswd.html, ftpquota.html, mod_ctrls_admin.html,
	mod_ifsession.html, mod_quotatab.html, mod_quotatab_file.html,
	mod_quotatab_ldap.html, mod_quotatab_sql.html, mod_radius.html,
	mod_rewrite.html, mod_site_misc.html, mod_sql.html, mod_tls.html,
	mod_wrap.html: 
	Moving the HTML documentation from contrib/ into doc/contrib/.

2004-11-03 08:53  castaglia

	* modules/: mod_auth_pam.c, mod_core.c, mod_ls.c, mod_xfer.c: 
	Removing deprecated directives.

2004-11-03 08:44  castaglia

	* contrib/mod_sql.c: 
	Cleaning up the style of code in mod_sql.  It still needs work, as
	it's inconsistent and thus harder to read and maintain.

2004-11-02 19:18  castaglia

	* config.h.in, configure.in: 
	Check for, and record, the size of a size_t.

2004-11-02 17:54  castaglia

	* include/table.h, src/table.c: 
	When removing keys and entries from the table, rather than
	destroying their pools, add them to free lists, associated with the
	table itself.  Check these free lists when adding new keys and
	entries.  Thus the total memory for a table is proportional to the
	total number of entries ever used at one time, and we don't have as
	much memory churn from the destroying of pools.  The pool members
	of the key and entry structs have thus been removed.
	
	Also handle signals while iterating through the table chains in
	pr_table_empty().

2004-11-02 16:40  castaglia

	* include/default_paths.h: 
	Remove an unused macro, and its accompanying crufty comment.

2004-11-02 10:18  castaglia

	* config.h.in, configure.in, contrib/mod_ctrls_admin.c,
	contrib/mod_radius.c, include/conf.h, include/default_paths.h,
	include/mod_ctrls.h, include/netaddr.h, include/scoreboard.h,
	modules/mod_auth.c, modules/mod_auth_unix.c, modules/mod_core.c,
	modules/mod_ctrls.c, modules/mod_dso.c, src/ctrls.c, src/dirtree.c,
	src/ftpdctl.c, src/inet.c, src/log.c, src/main.c, src/netacl.c,
	src/netaddr.c, src/scoreboard.c, src/support.c, utils/ftpcount.c,
	utils/ftpshut.c, utils/ftptop.c, utils/ftpwho.c,
	utils/scoreboard.c, utils/utils.h: 
	Moving many of the macros defining default paths into the 'PR_'
	namespace.  This isn't an issue now, but will become one when
	proftpd installs its header files into the production location,
	which will allow DSO modules to be built outside of the proftpd
	source tree.  When that happens, the likelihood of symbol
	collisions between ProFTPD macros/names and other files increases.

2004-11-01 20:01  castaglia

	* Makefile.in: 
	No need to invoke modules/Makefile's 'shared-modules' target if
	there are no shared module to build.

2004-11-01 19:35  castaglia

	* Makefile.in, lib/Makefile.in, modules/Makefile.in: 
	More tweaks to get builds using just --with-modules to work again.

2004-11-01 19:23  castaglia

	* configure: 
	Updating configure.

2004-11-01 19:15  castaglia

	* Makefile.in, configure.in, lib/Makefile.in, modules/Makefile.in: 
	Need to properly handle the case where the user might specify
	--with-modules, and no --with-shared.  In this case, the
	$(SHARED_MODULE_OBJS) variable will be empty, which was not being
	handled.

2004-11-01 09:48  castaglia

	* NEWS, README.DSO: 
	Mention the addition of DSO support in NEWS, and start on an
	accompanying README.DSO.  There will eventually appear a DSO
	mini-HOWTO as well.

2004-11-01 09:42  castaglia

	* configure: 
	Updating configure.

2004-11-01 09:38  castaglia

	* Make.rules.in, Makefile.in, configure.in, modules/Makefile.in: 
	Adding support for a --with-shared configure option, for building
	DSO (aka shared) modules.

2004-11-01 09:30  castaglia

	* modules/mod_dso.c: 
	Calling lt_dlexit() in a 'core.exit' event handler caused proftpd
	to segfault when shutting down.  All of the stashed module *m
	pointers for dynamically loaded modules become invalid after a call
	to lt_dlexit(), and those pointers can be used after mod_dso's exit
	handler.  The solution (though not clean) is to not call
	lt_dlexit().

2004-11-01 09:21  castaglia

	* src/display.c: 
	Bad reuse of variable name.

2004-11-01 09:12  castaglia

	* include/var.h: 
	Forgot to declare the pr_var_delete() function.

2004-10-31 14:39  castaglia

	* modules/mod_dso.c: 
	The dso_unload_module() function is only used if the 'rmmod'
	control action is used, which means that it requires Controls
	support.  Otherwise, we don't need it.

2004-10-31 14:36  castaglia

	* modules/mod_dso.c: 
	Remove an unnecessary function.

2004-10-31 14:27  castaglia

	* modules/mod_core.c: 
	Report the line number of the <IfDefine>, <IfModule> sections used
	or skipped.

2004-10-31 14:26  castaglia

	* include/parser.h, src/parser.c: 
	Add a function to the Parser API for getting the current line
	number.  This is useful for better reporting.

2004-10-31 14:11  castaglia

	* modules/mod_dso.c: 
	Some of the loop variables are only used if Controls support is
	enabled.

2004-10-31 14:03  castaglia

	* configure: 
	Updating configure.

2004-10-31 14:00  castaglia

	* aclocal.m4: 
	Update our local autoconf macros, specifically those dealing with
	libtool.  This should fix the warning:
	
	  libtool: link: warning: `AC_LIBTOOL_DLOPEN' not used. Assuming no
	dlopen support.
	
	that I was seeing.

2004-10-31 13:22  castaglia

	* src/table.c: 
	Quell a compiler warning about "use of cast expressions as lvalues"
	by being explicit.

2004-10-31 13:06  castaglia

	* config.h.in, include/conf.h: 
	The configure script was checking for <inttypes.h>, but we were not
	recording whether it was present or not, or including the header if
	it was present.  Shame on us.

2004-10-31 12:58  castaglia

	* modules/Makefile.in: 
	The building of modules should require the libltdl header or
	library.  Just libtool to handle the linking.

2004-10-31 12:56  castaglia

	* src/main.c: 
	Add the display of PR_TUNABLE_RCVBUFSZ, PR_TUNABLE_SNDBUFSZ to the
	-V output.

2004-10-31 12:49  castaglia

	* configure: 
	Updating configure.

2004-10-31 12:46  castaglia

	* configure.in, Makefile.in: 
	Attempting to get a DSO-enabled proftpd to link properly on
	platforms other than Linux by linking with libltdl as an object
	file, rather than linking against it as a library.

2004-10-31 12:24  castaglia

	* modules/mod_log.c: 
	Since we're using %ld as a format, explicitly cast the value as a
	long int, rather than as a time_t.

2004-10-31 12:19  castaglia

	* configure: 
	Updating configure.

2004-10-31 12:16  castaglia

	* Make.rules.in, configure.in: 
	Let's move the definition of HAVE_CONFIG_H into Make.rules.  The
	ordering of HAVE_CONFIG_H in the flags is therefore nicer.

2004-10-31 12:13  castaglia

	* configure: 
	Updating configure.

2004-10-31 12:11  castaglia

	* configure.in: 
	Define HAVE_CONFIG_H when compiling proftpd.  Some of the files
	under lib/ require this, in order to pull in <config.h>, and
	subsequently some of the system headers needed.

2004-10-31 12:06  castaglia

	* lib/Makefile.in: 
	If LIB_DEPS happens to be the empty string (as needed for Solaris),
	provide a target for it which does nothing.  Otherwise make will be
	cranky.

2004-10-31 12:01  castaglia

	* configure: 
	Updating configure.

2004-10-31 11:58  castaglia

	* src/var.c: 
	Quell a compiler warning about a label with no expressions.

2004-10-31 11:57  castaglia

	* config.h.in, configure.in: 
	Check for the <string.h> header.

2004-10-31 11:54  castaglia

	* configure: 
	Updating configure.

2004-10-31 11:51  castaglia

	* configure.in: 
	Initialize the socket buffer sizes, just to be safe.

2004-10-31 11:37  castaglia

	* RELEASE_NOTES, include/version.h: 
	As Daniel noted, it should be "1.3.0", not just "1.3".

2004-10-31 11:35  castaglia

	* configure: 
	Updating configure.

2004-10-31 11:31  castaglia

	* configure.in: 
	Bourne shell tests on Solaris don't like testing empty values; they
	prefer the empty string if nothing else.

2004-10-31 11:12  castaglia

	* configure: 
	Updating configure.

2004-10-31 11:09  castaglia

	* config.h.in, configure.in, include/options.h, src/data.c,
	src/dirtree.c: 
	First, fix a bug where session.xfer.buf was allocated as
	PR_TUNABLE_BUFFER_SIZE, rather than PR_TUNABLE_XFER_BUFFER_SIZE.
	
	Next, try to be smarter about the default value for
	PR_TUNABLE_XFER_BUFFER_SIZE.  The configure script now runs a small
	test program that uses getsockopt(2) to determine the sizes of a
	TCP socket's send and receive buffers.	The smaller of the two
	buffer sizes is used as the default value for
	PR_TUNABLE_XFER_BUFFER_SIZE; the --enable-transfer-buffer-size
	option will override this test.  The test program also records
	those send/receive buffer sizes in PR_TUNABLE_RCVBUFSZ and
	PR_TUNABLE_SNDBUFSZ, which were previously hardcoded to be 8K.

2004-10-31 11:03  castaglia

	* modules/mod_xfer.c, src/data.c: 
	Style nits: struct stat variables should be named 'st', and the
	'xlate' name for the ASCII handling routines is not appropriate in
	light of the i18n translation we will be needing.  It's more of a
	transformation, really.

2004-10-31 10:53  castaglia

	* NEWS: 
	Updating NEWS.

2004-10-31 10:53  castaglia

	* Make.rules.in, include/conf.h, include/display.h,
	include/modules.h, include/var.h, modules/mod_auth.c,
	modules/mod_core.c, src/display.c, src/main.c, src/var.c: 
	Bug#2701 - Add Variables API.
	
	This also separates the code used for handling Display* files into
	its own file; src/main.c was calling into modules/mod_core.c for
	that function, which is bad design.  Core code should not be using
	functions implemented in modules.

2004-10-31 10:45  castaglia

	* config.h.in, configure.in, src/main.c: 
	Make sure that if --enable-dso is used, it shows up when the -V
	command-line option is used.

2004-10-30 19:14  castaglia

	* RELEASE_NOTES: 
	Updating the release notes.  These still need some work.

2004-10-30 18:57  castaglia

	* src/inet.c: 
	Typo.

2004-10-30 18:39  castaglia

	* src/parser.c: 
	Update the license to reflect the proper original copyright
	holder(s).

2004-10-30 18:32  castaglia

	* Make.rules.in, contrib/mod_ifsession.c, include/conf.h,
	include/dirtree.h, include/parser.h, modules/mod_core.c,
	src/dirtree.c, src/main.c, src/parser.c: 
	Separating the parser code out from src/dirtree.c into its own
	file, src/parser.c, with a proper header file documenting the API
	(include/parser.h).  Update the rest of the core code to use the
	new API as needed.

2004-10-30 17:57  castaglia

	* contrib/mod_ifsession.c: 
	There is not enough information to call resolve_deferred_dirs() at
	session init time.  This function is usually for expanding the
	tilde in path names, and at session init time, we don't know the
	user name for expansion.

2004-10-30 16:18  castaglia

	* src/main.c: 
	Use pr_auth_getgroups(), not auth_getgroups().

2004-10-30 16:16  castaglia

	* contrib/mod_tls.c, contrib/mod_wrap.c, src/dirtree.c, src/fsio.c,
	src/support.c: 
	Use the Auth API functions in the 'pr_' namespace.

2004-10-30 16:14  castaglia

	* modules/mod_core.c: 
	Use the Auth API functions in the 'pr_' namespace rather than
	relying on the compatibility macros.

2004-10-30 15:11  castaglia

	* configure: 
	Updating configure.

2004-10-30 15:06  castaglia

	* configure.in: 
	Tweaking the configure script a bit, providing more complete path
	information in flags, etc.  Not really needed for the default build
	process which we all know and love, but will become necessary when
	building DSO modules.

2004-10-30 14:55  castaglia

	* src/timers.c: 
	This struct is no longer typedef'd.

2004-10-30 14:01  castaglia

	* include/timers.h: 
	Include some redefines for supporting legacy modules that may not
	have been updated to use the 'pr_' namespace Timer API.

2004-10-30 13:57  castaglia

	* contrib/mod_sql_mysql.c, contrib/mod_sql_postgres.c,
	contrib/mod_tls.c, modules/mod_ctrls.c: 
	Update the contrib/ modules to use the Timer API in the 'pr_'
	namespace (and mod_ctrls, too).

2004-10-30 13:45  castaglia

	* include/timers.h, modules/mod_auth.c, modules/mod_core.c,
	modules/mod_xfer.c, src/data.c, src/ident.c, src/inet.c,
	src/main.c, src/timers.c: 
	Moving the Timer API into the 'pr_' namespace.

2004-10-30 13:44  castaglia

	* include/ftp.h: 
	In the near future, a module will implement support for RFC2640's
	LANG command.

2004-10-30 13:42  castaglia

	* include/version.h: 
	With the addition of DSO support, ProFTPD is now moving into the
	1.3.x series.  Whee!

2004-10-29 15:56  castaglia

	* ltmain.sh: 
	Yet another bug in GNU's ltmain.sh script -- yet another undeclared
	variable.

2004-10-29 15:33  castaglia

	* doc/modules/mod_dso.html: 
	Typo (spotted by Michael).

2004-10-29 15:23  castaglia

	* doc/modules/mod_dso.html: 
	Adding documentation for mod_dso.

2004-10-29 14:46  castaglia

	* src/event.c: 
	As a comment to myself indicated, it is necessary to pstrdup() the
	name of the event for which a listener is being registered, rather
	than stashing a pointer to the given name directly.  This was
	causing a segfault when the pointer to the name given was part of a
	dynamically loaded module.

2004-10-29 12:17  castaglia

	* modules/mod_core.c: 
	The DebugLevel configuration handler was not recognizing 10 as a
	valid debug level.

2004-10-29 09:08  castaglia

	* doc/modules/mod_ctrls.html: 
	Grammar fix.

2004-10-29 08:29  castaglia

	* modules/mod_dso.c: 
	Removing debugging cruft.

2004-10-29 08:21  castaglia

	* configure: 
	Updating configure.

2004-10-28 23:01  castaglia

	* lib/libltdl/Makefile.in: 
	Disable the actions that try to use autoheader and automake.  These
	aren't installed on every system, and we don't really use them.

2004-10-28 22:51  castaglia

	* configure.in, lib/Makefile.in: 
	Only configure, build, and clean the libltdl/ directory if
	--enable-dso is selected.  Otherwise, let the build proceed as
	usual, and let the normal 'clean' target work without throwing an
	error.

2004-10-28 22:33  castaglia

	* configure: 
	Updating configure.

2004-10-28 22:28  castaglia

	* Make.rules.in, Makefile.in, config.h.in, configure.in,
	include/default_paths.h, lib/Makefile.in, modules/Makefile.in: 
	More DSO support changes.

2004-10-28 22:21  castaglia

	* ltmain.sh, modules/mod_dso.c: 
	Adding a (slightly modified) copy of ltmain.sh, which is
	responsible for creating the libtool executable.  Also adding
	mod_dso.c.  All part of the preparations for adding DSO support to
	ProFTPD.

2004-10-28 22:19  castaglia

	* aclocal.m4: 
	Adding GNU libtool M4 definitions to our aclocal.m4.

2004-10-28 22:17  castaglia

	* lib/libltdl/: COPYING.LIB, Makefile.am, Makefile.in, README,
	acinclude.m4, aclocal.m4, config-h.in, config.guess, config.sub,
	configure, configure.ac, install-sh, ltdl.c, ltdl.h, ltmain.sh,
	missing: 
	Adding GNU libtool's libltdl files to ProFTPD.

2004-10-28 18:10  castaglia

	* modules/mod_core.c: 
	The checks for <IfDefine>, </IfDefine>, <IfModule>, and
	</IfModule>, within the respective directive handlers, need to be
	case-insensitive.

2004-10-28 12:11  castaglia

	* NEWS, utils/ftptop.c: 
	Bug#2484 - Better ftptop formatting.

2004-10-26 18:49  castaglia

	* modules/mod_xfer.c: 
	Typo.

2004-10-26 16:24  castaglia

	* include/dirtree.h, include/modules.h, include/proftpd.h,
	modules/mod_site.c, modules/mod_xfer.c, src/main.c, src/modules.c: 
	Removing old privdata_t structures in favor of table entries, using
	the new Table API.

2004-10-26 15:28  castaglia

	* configure: 
	Updating configure.

2004-10-26 15:19  castaglia

	* config.h.in, configure.in: 
	Define CONFIG_DIR to point to the hardcoded directory containing
	the proftpd.conf file.

2004-10-26 15:14  castaglia

	* Make.rules.in, include/conf.h, include/table.h, src/table.c: 
	Adding the Table API source.

2004-10-19 18:32  castaglia

	* contrib/mod_tls.c: 
	It is possible for SSL_read() to return SSL_ERROR_WANT_WRITE as
	well, so handle that case the same way as handling
	SSL_ERROR_WANT_READ: select() on the socket until it is available
	for writing, then call SSL_read() again.
	
	Note that this happens (ideally) only when a renegotiation is
	occuring on the underlying SSL session.  So set the
	SSL_MODE_AUTO_RETRY mode too (if the OpenSSL version supports it),
	which will hopefully keep renegotiations from causing SSL_read() to
	return SSL_ERROR_WANT_WRITE.

2004-10-18 09:42  castaglia

	* modules/mod_xfer.c: 
	A few cases where log_pri() was being used, rather than
	pr_log_pri().

2004-10-17 16:42  castaglia

	* doc/howto/Directory.html: 
	Mention using quotations to enclose directory paths that contain
	spaces.

2004-10-17 16:29  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#1965 - Change timing of handling of QUIT command.

2004-10-17 12:09  castaglia

	* contrib/mod_sql.c: 
	Extraneous redeclaration of a variable.

2004-10-17 10:47  castaglia

	* contrib/: mod_sql_mysql.c, mod_sql_postgres.c: 
	Fixing bad reuse of variable name from outer scope.

2004-10-16 18:21  castaglia

	* RELEASE_NOTES: 
	Mention the new MaxConnectionsPerHost directive in the release
	notes.

2004-10-16 18:10  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#2273 - Ability to limit number of unauthenticated clients from
	a single host.

2004-10-15 17:43  castaglia

	* NEWS, modules/mod_auth_pam.c: 
	Bug#2497 - Users can login without password if pam_start() fails.

2004-10-15 10:07  castaglia

	* NEWS, src/auth.c, src/dirtree.c: 
	Bug#2499 - make_cmd() does not NULL-terminate cmd->argv[].

2004-10-14 19:43  castaglia

	* modules/mod_auth.c: 
	Move the handling of the AccessGrantMsg and DisplayLogin directives
	into the POST_CMD handler for PASS, rather than in the CMD handler.
	 This is aesthetically where such handling should occur, and it
	makes it possible for future enhancements where contrib modules can
	add their own variables to be interpolated into the DisplayLogin
	file.

2004-10-11 20:07  castaglia

	* src/inet.c: 
	Nicer error message.

2004-10-11 10:03  castaglia

	* src/bindings.c: 
	Avoid an infinite loop problem with Bind is used by stashing
	pointers to the bindings to use, when accepting a client
	connection, in an array_header, rather than overloading the 'next'
	field in the conn_t struct.

2004-10-11 09:33  castaglia

	* src/dirtree.c: 
	Fix case where the config tree was not dumped if the server_rec had
	an empty set of config_recs.  The name of the server_rec should
	still be dumped in such cases.

2004-10-09 15:34  castaglia

	* doc/howto/TLS.html: 
	Update link to FTPS Draft.

2004-10-09 15:24  castaglia

	* src/dirtree.c: 
	The parser internals are crufty, and are in need of rewriting and
	prettification.  Until then, make the code a little more legible
	(to me, at least).

2004-10-09 13:46  castaglia

	* NEWS, include/inet.h, include/netio.h, src/data.c, src/inet.c,
	src/netio.c: 
	Bug#2494 - ABOR problem with Cisco routers copy ftp flash.

2004-10-09 13:44  castaglia

	* src/main.c: 
	Generate a 'core.connect' event after a client has connected and
	we've forked, but before we lookup the server_rec for the session.

2004-10-08 18:16  jwm

	* contrib/mod_ldap.c: release 2.8.14

2004-10-07 14:17  castaglia

	* contrib/ftpasswd: 
	Explicitly mention "RequireValidShell off" if the given shell is
	not in /etc/shells.

2004-10-07 11:59  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2496 - NLST off-by-one bug when handling relative paths in a
	chrooted session.

2004-10-07 11:35  castaglia

	* contrib/mod_sql.html: 
	Remove mention of the PERCALL parameter of SQLConnectInfo, until
	the feature actually works.

2004-10-07 08:53  castaglia

	* modules/mod_ls.c: 
	Use the Auth API in the 'pr_' namespace.

2004-10-06 11:42  castaglia

	* contrib/mod_sql.html: 
	Removing mention of SQLAuthenticate's "*" suffix, as it was
	deprecated in the 1.2.10 release cycle.

2004-10-02 13:22  castaglia

	* contrib/mod_tls.c: 
	Handle signals when in potentially infinite gotos, so that the
	process can be interrupted.
	
	Expand the TLSLog entry for refused PROT commands a little more, to
	explain why the PROT command was refused (e.g. 'PROT C' was sent,
	but TLSRequired setting requires data protection).

2004-10-02 13:05  castaglia

	* doc/howto/TLS.html: 
	Adding two more FAQs to the TLS howto.

2004-10-01 22:48  castaglia

	* doc/rfc/: draft-murray-auth-ftp-ssl-13.txt,
	draft-murray-auth-ftp-ssl-15.txt: 
	Updating the FTPS Draft to the current version.

2004-10-01 21:24  castaglia

	* contrib/mod_tls.c: 
	Fix the logic when reporting on syscall errors, so that the errors
	are properly reported.

2004-10-01 20:34  castaglia

	* modules/mod_auth.c: 
	Stop sending 232 as a response code to the PASS command; it is
	valid only in response to a USER command.  Part of Bug #2164.

2004-10-01 20:30  castaglia

	* contrib/mod_tls.c: 
	Remove code that is never compiled.

2004-09-30 17:43  castaglia

	* NEWS, modules/mod_auth_pam.c: 
	Bug#2492 - Off-by-one error in FreeBSD PAM username length check.

2004-09-29 14:04  castaglia

	* NEWS, src/dirtree.c: 
	Bug#2490 - <Limit ALL> affects PORT command.  The EPRT, EPSV, PORT,
	and PASV commands are now explicitly excluded from the ALL command
	group.

2004-09-27 18:25  jwm

	* NEWS, contrib/mod_ldap.c: new mod_ldap 2.8.13

2004-09-27 10:12  castaglia

	* contrib/mod_quotatab_ldap.c: 
	mod_ldap now looks for a HOOK, rather than a CMD, for the
	mod_quotatab_ldap lookup symbol, as per John's request.

2004-09-26 14:12  castaglia

	* modules/mod_auth_file.c: 
	Use the 'pr_' namespace of the Auth API.

2004-09-26 14:07  castaglia

	* modules/mod_auth_unix.c: 
	Use the 'pr_' namespace of the Auth API.

2004-09-26 13:23  castaglia

	* modules/mod_auth.c: 
	Removing code that should not have been committed.  Oops.

2004-09-26 13:11  castaglia

	* include/auth.h, include/conf.h, include/modules.h,
	modules/mod_auth.c, src/auth.c: 
	Moving the Auth API into the 'pr_' namespace, and creating a
	separate header file defining the pr_auth function prototypes.

2004-09-26 11:24  castaglia

	* NEWS, contrib/mod_sql.c, contrib/mod_sql_mysql.c,
	contrib/mod_sql_postgres.c: 
	Bug#2485 - SQL backend modules close all open connections too
	early.

2004-09-26 11:17  castaglia

	* NEWS: 
	Mention the new init.d script for SuSE.

2004-09-26 11:09  castaglia

	* NEWS, RELEASE_NOTES, contrib/mod_sql.c, contrib/mod_sql.h,
	contrib/mod_sql_mysql.c, contrib/mod_sql_postgres.c: 
	Bug#2392 - mod_sql needs better handling of its backend modules.

2004-09-26 10:57  castaglia

	* src/mkhome.c: 
	Generate a 'core.create-home' event when creating a home directory;
	the event_data is currently the name of the user whose home is
	being created.	And correct a typo.

2004-09-25 16:47  jwm

	* contrib/dist/rpm/proftpd.init.d.suse: suse init script Submitted
	by: Daniel Weuthen <dw@megabit.net>

2004-09-23 14:37  castaglia

	* NEWS, include/privs.h: 
	Bug#2488 - Wrong order of privs calls on HP generates "unable to
	setregid()" error.

2004-09-18 12:08  castaglia

	* contrib/mod_quotatab.c: 
	When handling the 'core.restart' event, do not bounce the log file
	descriptor.  Restarts are processed by the daemon process, and
	mod_quotatab only logs in session processes; bouncing the log
	descriptor in the daemon process was causing mod_quotatab to open a
	descriptor onto stdout, which then wreaked havoc with the rest of
	the system.

2004-09-17 17:40  castaglia

	* src/proftpd.8.in: 
	Document the new -N option in the proftpd(8) man page.

2004-09-17 17:38  castaglia

	* NEWS, include/proftpd.h, modules/mod_core.c, src/main.c: 
	Bug#2468 - Ability to disable address/port collision checking.

2004-09-17 10:50  castaglia

	* contrib/mod_quotatab.c: 
	Explicitly use the more modern 'pr_log_openfile' symbol.

2004-09-14 18:01  castaglia

	* include/conf.h: 
	Typo (log -> long).

2004-09-14 10:49  castaglia

	* NEWS, contrib/mod_ldap.c, contrib/mod_radius.c,
	contrib/mod_sql.c, include/conf.h, include/modules.h,
	modules/mod_auth.c, modules/mod_auth_file.c,
	modules/mod_auth_unix.c, modules/mod_core.c, modules/mod_ctrls.c,
	modules/mod_log.c, modules/mod_ls.c, modules/mod_site.c,
	modules/mod_xfer.c, src/auth.c, src/data.c, src/xferlog.c: 
	Bug#2389 - 64-bit compilation warnings.

2004-09-12 18:47  castaglia

	* src/support.c: 
	Add an explicit typecast to quell warnings on 64-bit platforms.

2004-09-12 18:43  castaglia

	* modules/mod_auth_pam.c: 
	Quell a compiler warning on Solaris with an explicit typecast.

2004-09-12 17:12  castaglia

	* doc/howto/Limit.html: 
	Add example of using <Class> and mod_ifsession to configure a user
	so that they can only login from a certain IP range.

2004-09-12 16:36  castaglia

	* doc/howto/FXP.html: 
	Add text noting the ISPs may filter FTP ports, blocking FXP.

2004-09-11 16:43  castaglia

	* contrib/UPGRADE.mod_sql: 
	Removing crufty old file.

2004-09-11 10:53  castaglia

	* src/main.c: 
	Typo.

2004-09-07 17:40  castaglia

	* contrib/mod_quotatab.c: 
	Add logging of the non-ENOENT cases when the uploaded file has
	disappeared.

2004-09-07 15:34  castaglia

	* src/main.c: 
	Settings display format tweak.

2004-09-07 15:29  castaglia

	* src/main.c: 
	Add --settings option to the long getopt() list.

2004-09-07 15:23  castaglia

	* src/main.c: 
	Update the long descriptions for the -n, -d command-line
	parameters.

2004-09-07 15:18  castaglia

	* include/proftpd.h: 
	Removing cruft.

2004-09-07 12:41  castaglia

	* contrib/mod_quotatab.c: 
	Handle the case where, after an upload, the file to which bytes
	have been added has disappeared (as when MaxStoreFileSize and
	DeleteAbortedStores are in effect).

2004-09-07 12:22  castaglia

	* src/proftpd.8.in: 
	Mention debug level 10 in the proftpd(8) man page.

2004-09-05 15:42  castaglia

	* src/event.c: 
	More graceful handling of NULL evh->module pointers.

2004-09-05 15:01  castaglia

	* doc/mod_sample.c: 
	Update the sample module to include registering the module version.

2004-09-05 14:36  castaglia

	* configure: 
	Updating configure script.

2004-09-05 14:36  castaglia

	* src/main.c: 
	Display the --enable-scoreboard-updates setting in the -V output.

2004-09-05 14:34  castaglia

	* NEWS, config.h.in, configure.in: 
	Add autoconf support for a --enable-scoreboard-updates option.

2004-09-05 14:29  castaglia

	* NEWS, include/options.h, modules/mod_xfer.c: 
	Bug#2455 - Allow fine-tuning of how often mod_xfer updates the
	scoreboard.

2004-09-05 14:24  castaglia

	* RELEASE_NOTES: 
	Update release notes for 1.2.11 release cycle.

2004-09-05 14:21  castaglia

	* src/proftpd.8.in: 
	Remove extra space.

2004-09-05 14:16  castaglia

	* src/proftpd.8.in: 
	Document the new -V command-line option in the proftpd(8) man page.

2004-09-05 14:12  castaglia

	* configure: 
	Updating configure script.

2004-09-05 14:10  castaglia

	* NEWS, config.h.in, configure.in, src/main.c: 
	Add support for a -V command-line option, which displays various
	compile-time settings, a la Apache.

2004-09-04 19:37  castaglia

	* config.h.in, include/conf.h: 
	Move the HPUX socklen_t bug fix to include/conf.h, a header file
	that is not preprocessed by autoconf.  The autoconf preprocessing
	was causing the #undef in the generated config.h header file to be
	commented out, which would result in complaints from stringent
	compilers.

2004-09-04 19:23  castaglia

	* contrib/: mod_sql.c, mod_sql_mysql.c, mod_sql_postgres.c: 
	Remove the _MOD_VERSION #define from mod_sql, as it was not doing
	as was intended, I think.  Much better, cleaner, and more explicit
	to have each module #define its own VERSION string, and to use that
	version string consistently within the module.

2004-09-04 17:53  castaglia

	* modules/mod_log.c: 
	Convert mod_log to use the Events API.

2004-09-04 17:43  castaglia

	* contrib/mod_rewrite.c: 
	Convert mod_rewrite to use the Events API.

2004-09-04 17:38  castaglia

	* src/regexp.c: 
	The Regexp API need not use the core_module pointer for registering
	its callbacks; registered events can have a NULL module pointer.

2004-09-04 17:36  castaglia

	* src/regexp.c: 
	Convert the Regexp API to use the Events API for cleanup.

2004-09-04 17:36  castaglia

	* modules/mod_xfer.c: 
	Update mod_xfer to use the Events API a little more.

2004-09-04 17:31  castaglia

	* modules/mod_auth_unix.c: 
	Convert mod_auth_unix to use the Events API.

2004-09-04 17:31  castaglia

	* modules/mod_auth_pam.c: 
	Convert mod_auth_pam to use the Events API.

2004-09-04 17:19  castaglia

	* contrib/mod_sql.c: 
	Convert mod_sql to use the Events API.

2004-09-04 17:16  castaglia

	* contrib/mod_radius.c: 
	Convert mod_radius to use the Events API.

2004-09-04 17:15  castaglia

	* contrib/mod_quotatab.c: 
	Convert mod_quotatab to using the Events API.

2004-09-04 16:05  castaglia

	* NEWS, src/fsio.c: 
	Bug#2476 - Incorrect detection of symbolic link loop across
	devices.  The algorithm used for loop detection relied solely on
	the inode number, which does not account for the possibility that
	different devices may reuse inode numbers.  This patch adds the
	device number to the detection algorithm.

2004-09-04 15:56  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2463 - mod_xfer doesn't check how many bytes it has written to
	disk.

2004-09-04 15:53  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#2458 - Bad handling of CreateHome parameters.

2004-09-04 15:51  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2457 - Directory listing provides bad info when path ends with
	/.

2004-09-04 15:46  castaglia

	* NEWS, src/main.c: 
	Bug#2449 - ProFTPD silently ignores extra command-line parameters.

2004-09-04 14:21  castaglia

	* include/version.h: 
	Update version, indicating CVS status once more.

2004-09-04 11:54  castaglia

	* ChangeLog: 
	Updating ChangeLog.

2004-09-04 11:50  castaglia

	* NEWS, contrib/dist/rpm/proftpd.spec, include/version.h: 
	Preparing to release 1.2.10-final.

2004-08-25 11:08  castaglia

	* src/data.c: 
	When using sendfile(), only reset the transmission timers if bytes
	have actually been written out.  sendfile() can return zero,
	indicating that it wrote zero bytes -- we do not want to reset the
	timers in this case, for it could indicate other issues with the
	file descriptor from which data are being read.
	
	This fixes an endless loop seen at a particular site involving use
	of sendfile() and NFS/SAN-shared files.

2004-08-24 15:24  castaglia

	* modules/mod_xfer.c: 
	Reset the 'have_prot' flag to false when a successful PROT C
	command is processed.

2004-08-12 16:24  castaglia

	* modules/mod_xfer.c: 
	Update to patch to mod_xfer for Bug #2444: the PROT command is
	allowed before authentication.	The patch was required
	authentication first, causing issutes for FTPS clients that sent
	PROT before USER.

2004-08-07 15:22  castaglia

	* NEWS, src/log.c, src/main.c: 
	Bug#2427 - proftpd gets a memory fault when run from ssh batch
	mode.

2004-08-07 15:21  castaglia

	* src/main.c: 
	Two more cases where the IP address contacted by the client should
	be used, if present, rather than the ServerAddress field of the
	relevant server_rec.

2004-08-07 13:58  castaglia

	* src/main.c: 
	Fix a minor bug in the reporting of ServerIdent, where the wrong IP
	address may be displayed.  For example, with the following
	configuration:
	
	  <VirtualHost 127.0.0.1>
	    Bind 1.2.3.4
	    ...
	  </VirtualHost>
	
	a client connecting to 1.2.3.4 should see "[127.0.0.1]" at the tail
	end of the default ServerIdent displayed, rather than the more
	appropriate "[1.2.3.4]".  The fix is to use the IP address to which
	the client connected, rather than the ServerAddress field of the
	server_rec to which the client connected.  As the case with Bind
	shows, multiple IP addresses may be associated with the same
	server_rec, and the IP address displayed to the connecting client
	should not "leak" this fact.

2004-08-05 19:16  castaglia

	* src/main.c: 
	Reorder the timing of calling pr_ident_lookup(), making it occur
	after modules have been initialized.  This makes it possible for
	mod_ifsession, for example, to alter if ident lookups will be
	enabled, e.g.:
	
	  <IfClass foo>
	    IdentLookups off
	  </IfClass>
	
	so that ident lookups can be enabled/disabled selectively.

2004-08-05 17:58  castaglia

	* doc/howto/Limit.html: 
	Add description of applying <Limit> sections to SITE commands.

2004-08-05 12:12  castaglia

	* RELEASE_NOTES: 
	Updating the release notes.

2004-08-04 11:52  castaglia

	* NEWS, modules/mod_core.c: 
	Add support for automatically scrubbing the scoreboard for stale
	sessions on session init time, for inetd proftpds.  Scrubbing is
	already done periodically for standalone proftpds.

2004-08-03 16:17  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2444 - Use of sendfile() does not interoperate well with
	RFC2228 security mechanisms.

2004-08-02 17:44  castaglia

	* contrib/mod_sql.c: 
	Convert mod_sql to using ProFTPD's sstrcat() function, rather than
	strcat(3).

2004-08-01 12:02  castaglia

	* NEWS, modules/mod_auth_file.c: 
	Bug#2445 - AuthUserFile in <Global> context overrides <VirtualHost>
	setting.  Note that this bug will be revisited in the next release
	cycle, and fixed The Right Way(tm).

2004-07-30 18:35  castaglia

	* modules/mod_core.c: 
	Store the original name configured by a MasqueradeAddress directive
	in the config_rec, along with the resolved netaddr object.  This
	will make it possible to re-resolve the original name at a later
	date.

2004-07-30 17:07  castaglia

	* doc/howto/Limit.html: 
	Add example <Limit LOGIN> configuration that allows only anonymous
	logins.

2004-07-30 10:42  castaglia

	* modules/mod_core.c: 
	Make certain that all occurrences of an environment variable are
	removed when handling the UnsetEnv directive; a environment
	variable can appear multiple times in the environ array.

2004-07-28 13:41  castaglia

	* doc/howto/Authentication.html: 
	Updating the section on "Resolving ~", fixing mention of
	mod_auth_pam.

2004-07-22 14:49  castaglia

	* NEWS, modules/mod_auth_pam.c: 
	Bug#2442 - Segfault in FreeBSD PAM library with long login names.

2004-07-22 13:53  castaglia

	* README.PAM: 
	Update the PAM docs about AuthPAMAuthoritative, and add an Issues
	section.

2004-07-21 17:11  castaglia

	* contrib/: mod_ldap.c, mod_sql.c: 
	Apply the same criteria for including <crypt.h> to mod_ldap and
	mod_sql as are used for mod_auth_unix and mod_auth_file.

2004-07-21 16:58  castaglia

	* NEWS, modules/mod_auth_file.c, modules/mod_auth_unix.c: 
	Bug #2411 - AIX5 portability bug with mod_auth_unix, mod_auth_file.
	 Using gcc on AIX5, these files compile without complaint. 
	However, using the IBM compiler and following the instructions in
	README.AIX, they will fail on AIX5.  The fix is to extend for AIX5
	the portability hack that is done for AIX4.

2004-07-20 10:39  castaglia

	* NEWS, include/modules.h, modules/mod_core.c, src/auth.c: 
	Bug #2440 - Unable to use PAM authentication properly.	As
	explained in the bug report, the deprecation of all *Authoritative
	directives causes an issue with modules like mod_auth_pam.  This
	patch makes use of an unused flag variable in the authtable
	structure in order to implement the setting of auth module
	authoritativeness via the AuthOrder directive.

2004-07-14 17:08  castaglia

	* modules/mod_ctrls.c: 
	We were forgetting to remove our previous timer before adding a new
	one.

2004-07-14 17:07  castaglia

	* src/timers.c: 
	Prevent add_timer() from adding multiple timers that use the same
	timerno.

2004-07-14 14:51  castaglia

	* modules/mod_ctrls.c: 
	We don't want child processes handling these events for mod_ctrls.

2004-07-13 17:20  castaglia

	* include/version.h: 
	Let's try this again.

2004-07-13 16:58  castaglia

	* ChangeLog: 
	Updating ChangeLog.

2004-07-13 16:57  castaglia

	* NEWS, contrib/dist/rpm/proftpd.spec, include/version.h: 
	How embarassing.  A typo broke 1.2.10rc2, necessitating a release
	of rc3.

2004-07-13 16:51  castaglia

	* modules/mod_core.c: 
	Typo.

2004-07-13 15:19  castaglia

	* include/version.h: 
	Bump version for CVS checkouts.

2004-07-13 11:34  castaglia

	* ChangeLog: 
	Updating ChangeLog.

2004-07-13 11:32  castaglia

	* NEWS, include/version.h, contrib/dist/rpm/proftpd.spec: 
	Preparing for release of 1.2.10rc2.

2004-07-13 10:56  castaglia

	* modules/mod_core.c: 
	Variable name collision from different scopes; fix to quell a
	compiler warning.

2004-07-13 10:53  castaglia

	* src/support.c: 
	Quell a warning about reusing a global symbol name 'dup'.

2004-07-13 09:54  castaglia

	* modules/mod_core.c: 
	Rest of patch for Bug#2439.

2004-07-11 14:52  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2439 - <Limit CWD> doesn't work.

2004-07-09 11:24  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2438 - Display variable %z not expanded properly.

2004-07-08 14:38  castaglia

	* contrib/mod_ifsession.c: 
	Only perform <Limit LOGIN> checks if we've actually merged
	something in.  Also, when performing this check, use the
	TOPLEVEL_CONF macro (which correctly handles <Anonymous> contexts)
	to avoid inadvertently checking the wrong <Limit LOGIN> block.

2004-07-06 10:32  castaglia

	* doc/howto/TLS.html: 
	Update the link to the most current FTPS Draft.

2004-07-06 10:31  castaglia

	* doc/rfc/: draft-murray-auth-ftp-ssl-10.txt,
	draft-murray-auth-ftp-ssl-13.txt: 
	Updating the FTPS Draft to the current version.

2004-06-30 19:00  castaglia

	* src/dirtree.c: 
	Fix pr_expr_eval_class_and() and pr_expr_eval_class_or() to
	properly handle the case where session.class may be NULL (as when
	there is no <Class> definition that matches the connecting client).
	 Previously, if there was no matching <Class> for a client, a rule
	such as:
	
	  <IfClass !name>
	
	would evaluate to false.  It _should_ evaluate to true; this change
	makes it so.
	
	This fixes a problem Michael was encountering with mod_ifsession
	and Classes.

2004-06-30 18:52  castaglia

	* src/dirtree.c: 
	When handling <Global> contexts in fixup_globals(), only handle
	contexts that have both the right config_type (CONF_GLOBAL) _and_
	the right name ("<Global>").  Contrib modules (e.g. mod_ifsession)
	might create their own contexts that use the CONF_GLOBAL flag; in
	the case of mod_ifsession, the fact that fixup_globals() was
	handling the mod_ifsession-created context config_recs was causing
	a bug when <If*> sections were used within <Global> contexts.
	
	This change also includes some style cleanup.

2004-06-30 18:17  castaglia

	* src/dirtree.c: 
	Style.

2004-06-30 18:06  castaglia

	* contrib/mod_tls.c: 
	Improve mod_tls' error reporting by displaying the paths that are
	given in the configuration data for various files, in the cases
	where mod_tls determines that those paths do not exist.

2004-06-30 11:25  castaglia

	* contrib/mod_tls.html, doc/howto/TLS.html: 
	Updating the mod_tls docs, and the TLS howto, to mention the new
	AllowPerUser TLSOption, and the risks involved in its use.

2004-06-30 10:52  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2419 - Ability to disable TLSRequired on per-user basis (e.g.
	for anonymous logins).

2004-06-29 19:42  castaglia

	* NEWS, src/class.c, src/netacl.c, src/netaddr.c: 
	Bug#2303 - Problem evaluating multiple <Class> rules.

2004-06-23 10:47  castaglia

	* contrib/mod_sql.html: 
	Typo.

2004-06-22 17:04  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#2431 - mod_sql does not use UID/GID properly in cache lookups. 
	For the most part this is an issue only if you define a user
	account with UID of zero, or a group account with GID of zero, in
	your SQL user tables.

2004-06-21 10:34  castaglia

	* contrib/mod_ifsession.html: 
	Add ExtendedLog to the list of directives that mod_ifsession does
	not handle.

2004-06-18 14:29  castaglia

	* contrib/mod_tls.html: 
	Typo.

2004-06-17 13:34  castaglia

	* NEWS, include/dirtree.h, src/dirtree.c, src/main.c: 
	Bug#2418 - chmod returns 550 with filename containing multiple
	spaces.

2004-06-16 17:06  castaglia

	* NEWS: 
	Typo.

2004-06-15 09:45  castaglia

	* src/netio.c: 
	Style.

2004-06-11 19:03  castaglia

	* src/modules.c: 
	Removal of symbols (e.g. AuthOrder) was not working properly
	without this change.

2004-06-11 14:19  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#2422 - %v not working in SQLNamedQuery.

2004-06-10 14:51  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2411 - Caching effects cause RNTO to fail if AllowOverwrite is
	off and target path does not exist.

2004-06-10 11:30  castaglia

	* contrib/mod_sql.c: 
	Remove debugging cruft.

2004-06-10 11:27  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#2424 - SQLDefaultHomedir overrides column value.

2004-06-08 16:08  castaglia

	* doc/howto/ServerType.html: 
	ProFTPD is now IPv6-capable; it simply needs the proper configure
	option.  Update the ServerType howto to reflect this (relevant for
	Solaris users).

2004-06-07 16:00  castaglia

	* contrib/: mod_quotatab.h, mod_sql.c: 
	Increment versions of mod_quotatab, mod_sql.

2004-06-07 15:58  castaglia

	* NEWS, contrib/mod_quotatab_sql.c, contrib/mod_sql.c,
	include/support.h, src/support.c: 
	Bug#2420 - Name field is not escaped before querying database.
	
	This patch fixes mod_quotatab_sql to escape the name string used. 
	To do this, several changes were made: the _sql_strip_spaces()
	function of mod_sql.c was made a public ProFTPD API string function
	(pr_str_strip), so that that code need not be duplicated in both
	mod_sql.c and mod_quotatab_sql.c, a new HOOK to mod_sql's
	sql_escapestring function was added, under the symbol
	'sql_escapestr', to avoid further code duplication, and
	mod_quotatab_sql was updated to make use of the new API.

2004-06-05 18:14  castaglia

	* contrib/mod_tls.c: 
	Fix scrubbing of passphrases when a session process exits.

2004-06-03 10:32  castaglia

	* contrib/mod_tls.html: 
	Adding required OpenSSL clauses.

2004-05-31 15:07  castaglia

	* include/dirtree.h, include/event.h, src/dirtree.c, src/event.c: 
	Add a pr_event_dump() function, for dumping internal Events info. 
	Adjust config-dumping function names to match (i.e.
	pr_config_dump()).

2004-05-31 14:49  castaglia

	* contrib/mod_ctrls_admin.c: 
	Removing the 'dump' control action from mod_ctrls_admin.  A new
	module, mod_dumper, will implement this control action.  I
	anticipate the audience for mod_dumper to be much smaller than for
	mod_ctrls_admin.

2004-05-31 14:47  castaglia

	* src/modules.c: 
	Slightly cleaner structure.

2004-05-31 14:20  castaglia

	* src/dirtree.c: 
	Attempting to dump the config for a minimally configured server_rec
	(i.e.  server_rec->conf is NULL) would segfault.

2004-05-31 12:33  castaglia

	* src/modules.c: 
	When iterating through the stash for removing symbols, be sure to
	pass in the previously-found entry, not NULL.  Otherwise, symbols
	can inadvertently be skipped.

2004-05-31 11:58  castaglia

	* src/modules.c: 
	Fix removal of a module from the loaded_modules list.

2004-05-31 10:54  castaglia

	* src/modules.c: 
	Fix a bug introduced in the handling of HOOK vs CMD symbols.  Fix
	handling of loaded_modules pointer when unloading a module.  Add
	signal handling where appropriate.

2004-05-31 10:47  castaglia

	* src/modules.c: 
	Missed a case where the PR_SYM_CONF hashing needed to be handled
	differently.

2004-05-30 18:51  castaglia

	* src/modules.c: 
	The changes made earlier, to have processing of configuration
	directives use the stash directly, caused a problem.  The prior
	structure allowed for case-insensitive comparisons between the
	directive name in the config file and the name defined by the
	processing module.  By switching to doing lookups from the stash
	directly, such case-insensitive comparisons became difficult.
	
	So, for now, whenever a PR_SYM_CONF symbol is added or requested
	from the stash, its hash value is calculated not from the symbol
	name directly, but from a lowercased version of the name (and only
	for PR_SYM_CONF symbols).  In order to make this work, there is now
	special-case handling of PR_SYM_CONF, and the stash_lookup()
	functions use strcasecmp() rather than strcmp().  I hope this
	doesn't cause any problems with other symbols.
	
	In the future, when the proposed Tables API is complete, I'd like
	to have completely separate tables for the different symbol types. 
	This will (hopefully) make lookups faster (smaller namespace to
	search) and allow customized hashing/comparison functions
	(PR_SYM_CONF symbols needing different treatment from other symbols
	in this case) on a per-table basis.

2004-05-30 15:46  castaglia

	* contrib/mod_ctrls_admin.c, include/modules.h, modules/mod_core.c,
	src/modules.c: 
	Add pr_module_load() and pr_module_unload() functions, for loading
	and unloading modules (and their symbols) from the stash.  Rework
	the rest of the code to work with the changes (i.e. removed crufty
	globals).

2004-05-30 14:54  castaglia

	* NEWS: 
	Bug#2125 - -vv command line switch should list versions of modules.

2004-05-30 14:50  castaglia

	* modules/mod_cap.c, src/main.c: 
	Minor formatting tweak.  Update mod_cap to report its version. 
	Other modules will follow.

2004-05-30 14:48  castaglia

	* src/main.c: 
	Typo.

2004-05-30 14:45  castaglia

	* src/main.c: 
	Bug#2125 - -vv command line switch should list versions of modules.
	
	With this change, modules _can_ report their version (or other
	short descriptor)in such a way that it will be listed if the -vv
	command line option is used.  It is not required for modules to do
	so; if they do not, just the module name is displayed.

2004-05-30 14:34  castaglia

	* include/modules.h: 
	Extend the module structure to include fields for module version,
	and an opage handle for the module (for libltdl pointers).  This
	extension do not break the currently-defined module structures in
	module files.

2004-05-29 19:39  castaglia

	* contrib/mod_ctrls_admin.c, src/dirtree.c, src/modules.c,
	src/sets.c: 
	More prep work for loadable modules.  This change removes use of
	the m_conftable global variable, shifting the users of that
	variable to using the stash directly, via pr_stash_get_symbol(). 
	For example, mod_ctrls_admin was using m_conftable for supporting
	the 'get directives' control action.  Now that handler iterates
	through the stash directly for PR_SYM_CONF symbols (which required
	some adjusting of the stash internals to allow for such
	interating).

2004-05-29 16:38  castaglia

	* src/event.c: 
	Make pr_event_unregister() function as documented if given a NULL
	callback argument.

2004-05-29 16:02  castaglia

	* include/modules.h, modules/glue.sh, modules/mod_core.c,
	src/modules.c: 
	More fun with the loaded_modules list.	Initially, the
	loaded_modules linked list will be NULL; it is the job of
	modules_init() to initialize the modules in the static_modules
	list, and add a pointer to the loaded module to the loaded_modules
	list.
	
	More work needs to be done on abstracting the process of loading of
	a module.

2004-05-29 15:31  castaglia

	* modules/mod_ctrls.c: 
	Clean up the ControlsLog entries when encountering a stale
	connection: we don't need to know the full timestamps, just the
	difference as compared to the ControlsAuthFreshness.

2004-05-29 14:02  castaglia

	* include/modules.h, src/main.c, src/modules.c: 
	Use "modules", plural, to indicate that the function acts on
	multiple modules, not just one.

2004-05-29 13:13  castaglia

	* src/modules.c: 
	Add sane errno values.

2004-05-29 13:03  castaglia

	* include/modules.h, modules/glue.sh, modules/mod_core.c,
	modules/mod_ctrls.c, src/main.c, src/modules.c: 
	Beginning work on supporting loadable modules.	The modules/glue.sh
	file autogenerates a file that defines the static_modules array,
	which contains the module structure pointers from all the
	statically compiled modules.  This list cannot be modified.  For
	loadable modules, we need a modifiable list, which I've added to
	the script: loaded_modules.  Initially, loaded_modules is identical
	to static_modules.  A pr_module_get() function has been added, to
	lookup a module pointer given its name.

2004-05-29 12:52  castaglia

	* modules/mod_ctrls.c: 
	Add more info to the ControlsLog when the ControlsAuthFreshness is
	exceeded, to help in debugging why this happens.

2004-05-29 11:55  castaglia

	* contrib/mod_tls.c: 
	Typo (thanks John!).

2004-05-28 21:22  castaglia

	* doc/howto/Directory.html: 
	Wording update.

2004-05-28 21:19  castaglia

	* contrib/mod_tls.c: 
	Fix handling of memory passed to mlock(2).  It seems that mlock(2)
	is very picky, and wants a page-aligned address only. 
	malloc(3)/calloc(3) do not return page-aligned addresses by default
	(although FreeBSD's man page suggests that for a sufficient size
	request, they will), so we help them along by adding some
	page-alignment code.  We still want to stash the pointer returned
	by malloc(), not the aligned address, so that we can properly free
	the allocated memory later.
	
	Also use pr_log_debug(), rather than logging to the TLSLog, when
	locking passphrases into memory, for at that point in the server
	lifecycle, the TLSLog has not yet been opened.

2004-05-28 18:56  castaglia

	* contrib/mod_tls.c: 
	Silence a compiler warning by providing a default value.

2004-05-28 18:55  castaglia

	* contrib/mod_tls.c: 
	Typo.

2004-05-28 17:28  castaglia

	* src/scoreboard.c: 
	Unblock signals properly.

2004-05-28 09:46  castaglia

	* README.modules: 
	Update this README.

2004-05-27 10:20  castaglia

	* contrib/mod_tls.c: 
	Registering for the wrong event: we want 'core.postparse', not
	'core.restart'.  Close the TLSLog during a restart, so that it can
	be rolled.  The TLSLog will be reopened by the next session.

2004-05-26 12:25  castaglia

	* src/ctrls.c: 
	Make sure that the destination ctrl object has a valid temporary
	pool from which to copy arguments.

2004-05-26 11:54  castaglia

	* src/dirtree.c: 
	Reset the sid (server ID) counter when preparing to parse a
	configuration.

2004-05-25 19:17  castaglia

	* configure: 
	Updating configure script.

2004-05-25 19:15  castaglia

	* config.h.in, configure.in: 
	Check if intptr_t is defined.

2004-05-25 16:31  castaglia

	* modules/mod_ctrls.c: 
	When closing fds, set them to -1, to make sure that a cached fd
	value is not inadvertently used somewhere it shouldn't be.  Also,
	block alarms when handling the 'core.restart' event.

2004-05-25 16:00  castaglia

	* contrib/mod_tls.c: 
	Check the return value of SSL_CTX_set_default_verify_locations(),
	and log the error (if any).

2004-05-25 10:41  castaglia

	* doc/howto/BCP.html: 
	Wording.

2004-05-25 10:17  castaglia

	* src/main.c: 
	Make sure that fixup_servers() happens before generating the
	'core.postparse' event (mod_tls' 'core.postparse' handler was
	tickling a segfault because one of the server_recs had a NULL
	ServerName field; fixup_servers() sets all of the server_rec fields
	appropriately).

2004-05-24 16:27  castaglia

	* modules/mod_ctrls.c: 
	Fix a problem when restarting a proftpd with mod_ctrls.  Some
	variables were allocated from the module pool, and then being used
	after that pool had been destroyed/reallocated.  This meant that
	different configurations and interactions might (or might not)
	work.

2004-05-24 14:35  castaglia

	* lib/pr-syslog.c: 
	Mention the Sun bug number that caused the /dev/log kernel memory
	leak.

2004-05-22 17:11  castaglia

	* contrib/mod_quotatab_sql.c: 
	Typo.

2004-05-22 16:59  castaglia

	* contrib/mod_quotatab_sql.c: 
	Don't complain about being unable to delete a nonexistent
	QuotaLock.

2004-05-21 10:46  castaglia

	* RELEASE_NOTES: 
	Style.

2004-05-21 10:35  castaglia

	* RELEASE_NOTES: 
	Update the release notes with mention of TimeoutLinger.

2004-05-21 10:19  castaglia

	* NEWS, include/data.h, modules/mod_core.c, src/data.c: 
	Add a TimeoutLinger option.  It's just simpler to change this value
	via the config file, for those sites that encounter troubles with
	lingering closes, rather than requiring a reconfigure and
	recompile.

2004-05-20 10:28  castaglia

	* contrib/mod_ctrls_admin.c: 
	Check for signals while waiting for all kids to end when handling a
	graceful shutdown.

2004-05-19 20:39  castaglia

	* doc/howto/: Controls.html, index.html: 
	Add a Controls howto.

2004-05-19 14:44  castaglia

	* modules/mod_auth.c: 
	Make sure a Class has been assigned before attempting to use it.

2004-05-19 10:07  castaglia

	* NEWS, lib/pr-syslog.c, src/main.c: 
	Bug#2336 - Use of /dev/log on Solaris leads to kernel memory leak.

2004-05-18 19:32  castaglia

	* src/dirtree.c: 
	Style.

2004-05-18 16:22  castaglia

	* contrib/mod_ctrls_admin.html: 
	Typo.

2004-05-18 15:43  castaglia

	* contrib/mod_ctrls_admin.html: 
	Document that 'ftpdctl get' accepts both 'config' and 'directives'
	parameters.

2004-05-17 11:24  castaglia

	* modules/mod_auth.c, modules/mod_xfer.c, src/data.c, src/main.c: 
	Generate events when the Timeout* callbacks cause the session to
	time out.

2004-05-15 10:25  castaglia

	* src/data.c: 
	Fix an edge case when handling ASCII translation: if this buffer
	ends in a CR, and the next buffer starts with an LF, we need not
	add a CR in front of the LF.  Prior to this change, though, proftpd
	would forget about that dangling CR in the previous buffer, treat
	the LF as a bare LF, and add a CR, resulting in a CR-CR-LF sequence
	in the output stream rather than the proper CR-LF.

2004-05-13 07:01  castaglia

	* contrib/mod_tls.c, include/modules.h, src/main.c, src/modules.c: 
	Remove the explicit postparse callback registration code in favor
	of the new Events API.

2004-05-12 19:58  castaglia

	* contrib/mod_tls.c: 
	Use more future-proof APIs to access the X509v3 subjectAltNames in
	the client cert.  Properly NUL-terminate strings obtained from
	memory BIOs.

2004-05-12 18:13  castaglia

	* NEWS, modules/mod_auth.c, src/mkhome.c: 
	Bug#2410 - CreateHome always copies skel directory.

2004-05-11 19:20  castaglia

	* src/main.c: 
	I don't think this is valid anymore, if it ever was.  The
	IPV6_ADDRFORM socket option is not supported on FreeBSD or Solaris,
	and looks to be deprecated (if not removed entirely) in later Linux
	kernels.

2004-05-11 16:37  castaglia

	* NEWS, modules/mod_auth_file.c, modules/mod_auth_unix.c: 
	Bug#2407 - mod_auth_file does not allow for proper cascading of
	"end" and "set" auth requests

2004-05-11 09:56  castaglia

	* include/modules.h, src/main.c, src/modules.c: 
	Removing the daemon startup registration handlers; these have been
	superceded by Events (e.g. the "core.startup" event).

2004-05-10 10:50  castaglia

	* NEWS, src/main.c: 
	Bug#2332 - SO_OOBINLINE error after upgrading proftpd from 1.2.6 to
	1.2.9.	Attempt to fix by moving the setting of these socket
	options to happen earlier in the session.

2004-05-09 13:05  castaglia

	* src/data.c: 
	When opening a data connection, check for the ESPV ALL mode as
	well.

2004-05-08 18:07  castaglia

	* src/fsio.c: 
	When looking up the FS to use for a path, always start with the
	root FS ("/") as the best FS to handle the path.  This fixes a bug
	where the FS handlers registered by modules like mod_md5fs or
	mod_gzipfs were being used for paths other than those for which
	they were registered.
	
	Also fix a bug where an FS that did not start with a '/', such as
	one used by mod_conf_sql, would cause the FSIO API to prepend the
	current location when it shouldn't have; the FSIO API simply needed
	to use the proper check for whether the given path was an absolute
	path or not.

2004-05-07 20:21  castaglia

	* contrib/: mod_sql_mysql.c, mod_sql_postgres.c: 
	Style cleanup of the SQL backend modules.  Also updating them to
	use an event handler for the "core.exit" event.
	
	Fixed their session initialization routines to always allocate a
	new conn_pool and a new conn_cache.  Eventually the mod_sql API
	will be revamped to handle these structures a little better.

2004-05-07 14:31  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2366 - Add support for -h list option.

2004-05-07 11:17  castaglia

	* modules/mod_ls.c: 
	Redeclaring a variable isn't a good thing to do.

2004-05-06 20:36  castaglia

	* src/child.c: 
	Include <signal.h> so that the kill(2) function prototype is
	visible.

2004-05-06 08:35  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2405 - "LIST *" should not list dotfiles.

2004-05-05 10:49  castaglia

	* src/child.c: 
	Fix the logic determining when to create a new child list.  Also,
	when creating that list, use a subpool of the child_pool, rather
	than passing child_pool itself; the list allocator assigns the
	given pool into the list's 'pool' member, rather than creating a
	subpool from the given pool and allocating the list from what
	(which is how I would expect it to be done).

2004-05-04 09:54  castaglia

	* lib/glibc-glob.c: 
	The buffer length should be PR_TUNABLE_LOGIN_MAX + 1.

2004-05-03 19:59  castaglia

	* lib/glibc-glob.c: 
	Patch the bundled glob implementation to use PR_TUNABLE_LOGIN_MAX
	when the _SC_LOGIN_MAX sysconf variable is not available.  This
	brings the implementation more in line with the rest of proftpd.

2004-05-03 10:25  castaglia

	* NEWS, include/class.h, src/class.c, src/main.c: 
	Bug#2403 - Sending SIGHUP to proftpd stops it when using Classes.

2004-05-02 08:05  castaglia

	* NEWS, contrib/mod_rewrite.c, contrib/mod_rewrite.html: 
	Bug#2082 - Add mod_rewrite "replaceall" builtin function.

2004-05-01 22:42  castaglia

	* NEWS, contrib/mod_ctrls_admin.c, contrib/mod_ctrls_admin.html: 
	Bug#2399 - Rename start/stop control actions to up/down.

2004-05-01 20:39  castaglia

	* include/glibc-glob.h: 
	Quell some warnings seen on FreeBSD by checking that a preprocessor
	symbol (_FILE_OFFSET_BITS) is defined before using its value in a
	comparison.

2004-05-01 11:44  castaglia

	* contrib/mod_tls.c: 
	Only report the version of OpenSSL being used at debug level 2 or
	higher.

2004-05-01 11:27  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#2401 - MaxClientsPerClass only checks first directive in config
	file.

2004-05-01 11:01  castaglia

	* NEWS, src/class.c: 
	Bug#2400 - <Class> search order is wrong.

2004-04-30 12:01  castaglia

	* NEWS, contrib/mod_ctrls_admin.c, contrib/mod_ctrls_admin.html,
	include/child.h, src/child.c, src/main.c: 
	Bug#2034 - Add support for a "graceful shutdown" signal.  Includes
	adding a convenience function to the Child API, child_signal(), for
	sending a given signal to all child processes.

2004-04-29 13:09  castaglia

	* contrib/mod_ctrls_admin.html: 
	Typo.

2004-04-29 12:28  castaglia

	* Make.rules.in, include/child.h, include/conf.h, src/child.c,
	src/main.c: 
	Move the handling of child objects into their own file.  This will
	help by letting modules be able to know how many existing sessions
	there are.  However, the child list routines will not be in the
	public "pr_" namespace, as they are not currently suitable for
	general consumption.

2004-04-28 20:35  castaglia

	* contrib/mod_ldap.c, include/sets.h, modules/mod_auth_unix.c,
	src/dirtree.c, src/main.c, src/sets.c, src/support.c: 
	Rename crufty 'mempool' symbol to be 'pool', which is more
	consistent with the pool members of other proftpd structures.

2004-04-28 20:35  castaglia

	* README.IPv6: 
	Note the sysctl names that affect handling of wildcard sockets and
	IPv6 binds.  The current code should override these sysctl
	settings, but it is still good to have the sysctl names noted for
	reference.

2004-04-28 18:55  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2396 - NLST command doesn't understand options.

2004-04-28 14:29  castaglia

	* modules/mod_core.c: 
	When using pr_fs_copy_file() to handle RNFR/RNTO across device
	mounts, make sure to unlink the source path.

2004-04-28 14:00  castaglia

	* include/version.h: 
	Set version back to CVS status for rc2.

2004-04-28 10:54  castaglia

	* ChangeLog: 
	Updating ChangeLog.

2004-04-28 10:52  castaglia

	* NEWS, include/version.h, contrib/dist/rpm/proftpd.spec: 
	Preparing to roll 1.2.10rc1 tarball.

2004-04-28 10:43  castaglia

	* README, RELEASE_NOTES: 
	Add a RELEASE_NOTES file (name may change in the future) that will
	track the sort of comments usually mentioned in the release
	announcement email, including new and deprecated configuration
	directives, new and deprecated modules, upgrade notes, etc.
	
	Add a note about RELEASE_NOTES to the README.

2004-04-27 13:49  castaglia

	* contrib/mod_sql.html: 
	Update mod_sql installation instructions.

2004-04-27 09:58  castaglia

	* modules/mod_xfer.c: 
	Make the error message returned here consistent with the other
	occurrences of 500 responses in mod_xfer.

2004-04-26 16:33  castaglia

	* include/dirtree.h, src/dirtree.c: 
	Split the Boolean checking code into a public function, so that it
	can be used for checking strings from sources other than cmd_recs.

2004-04-23 18:17  castaglia

	* modules/mod_auth.c: 
	Do not warn about a successful root login until after root has
	indeed successfully logged in.

2004-04-23 18:13  castaglia

	* doc/modules/mod_auth_pam.html: 
	Add HTML docs for mod_auth_pam.

2004-04-23 14:29  castaglia

	* modules/mod_ls.c: 
	The prior fix for Bug#2367 has some unintended (i.e. _bad_)
	consequence, spotted by Michael.  This fixes it up properly
	(hopefully for good).

2004-04-23 13:46  castaglia

	* src/netacl.c: 
	The '{' character is also used in globs.

2004-04-23 11:35  castaglia

	* modules/mod_ls.c: 
	Write a debug message, level 1, when NLST commands with options (as
	from ncftp) are received.

2004-04-22 18:32  castaglia

	* contrib/mod_sql.c: 
	Protect against a possible segfault that occurs when mod_sql
	assumes that a query has data, by checking for a valid data pointed
	in the returned modret_t object.

2004-04-21 18:32  castaglia

	* src/inet.c: 
	Only set the TOS (Type Of Service) flags on IPv4 sockets; IPv6
	sockets don't support TOS flags, as far as I know.  This should fix
	the
	
	  error setting write fd IP_TOS: Option not supported by protocol
	
	errors seen on some platforms (e.g. Solaris).

2004-04-21 14:29  castaglia

	* doc/howto/: index.html, Classes.html: 
	Add a howto for the new <Class> format.

2004-04-20 18:23  castaglia

	* src/main.c: 
	Style cleanup.

2004-04-20 18:15  castaglia

	* src/main.c: 
	Capture the actual errno value, rather than assuming that
	intervening functions will not change errno.

2004-04-20 16:26  castaglia

	* doc/howto/Limit.html: 
	Consistency of style is a Good Thing.

2004-04-20 13:57  castaglia

	* contrib/mod_ctrls_admin.c: 
	If the 'dump classes' control action is requested, make sure that
	the Class dump output includes the Satisfy setting.

2004-04-19 19:05  castaglia

	* src/log.c: 
	Fix the logging of IP addresses in the utmp/wtmp log on Linux. 
	Formatting cleanup.

2004-04-19 16:59  castaglia

	* include/class.h, modules/mod_core.c, src/class.c: 
	Add a Satisfy directive.  Note that this directive does NOT
	function like Apache's Satisfy directive.  This current
	implementation is to be used when defining a class, to specify how
	to evaluate all of the rules of the class: any, or all.
	
	Future work will overload this directive to work as users would
	like (see Bug#1898) for the <Limit> context.

2004-04-19 16:33  castaglia

	* src/dirtree.c: 
	Report line numbers when parsing .ftpaccess files, too.

2004-04-18 10:00  castaglia

	* src/dirtree.c: 
	Have the fatal messages reported during configuration parsing
	report the line number and configuration file, for easier fixing of
	broken configs.

2004-04-16 09:33  castaglia

	* NEWS, include/privs.h: 
	Bug#2317 - Wrong order of privs calls on HP generates "unable to
	setregid()".  error.  The problem turned out to be a call to
	setregid() before a call to setreuid(), but only in the HP privs
	code (non-seteuid() case).  The fix was trivial: call setreuid()
	first, to make sure the proper UIDs are set, then call setregid().

2004-04-15 18:08  castaglia

	* NEWS: 
	Mention in NEWS the new doc/modules/ directory.

2004-04-15 17:54  castaglia

	* doc/modules/mod_ctrls.html: 
	Updating mod_ctrls' installation instructions.

2004-04-15 17:36  castaglia

	* doc/modules/: mod_auth_file.html, mod_cap.html, mod_ctrls.html: 
	Add a 'doc/modules/' directory, for core module documentation.	Add
	the docs for mod_auth_file, mod_cap, and mod_ctrls.

2004-04-15 17:19  castaglia

	* contrib/: mod_ifsession.html, mod_quotatab.html, mod_radius.html,
	mod_sql.html, mod_tls.html, mod_wrap.html: 
	Formatting fixups.

2004-04-15 16:16  castaglia

	* include/ctrls.h: 
	These changes should've been part of an earlier commit.

2004-04-15 15:19  castaglia

	* contrib/mod_rewrite.html: 
	The features listed under "future work" have been implemented.

2004-04-15 15:14  castaglia

	* contrib/mod_tls.c: 
	Much improved handling of OpenSSL's error queue, so that the TLSLog
	can properly show all of the errors in the queue (rather than just
	the top error, which is usually not too helpful in pinpointing the
	actual problem).

2004-04-15 14:31  castaglia

	* contrib/mod_rewrite.html: 
	Document the flags parameters for RewriteCondition, RewriteRule. 
	Also document the possible pattern variants allowed for
	RewriteCondition.  Add an example of using mod_rewrite to make all
	uploaded files have uppercased filenames.

2004-04-15 11:46  castaglia

	* sample-configurations/basic.conf: 
	The default configuration file should not allow use of SITE CHMOD.

2004-04-15 10:33  castaglia

	* contrib/mod_rewrite.html: 
	Formatting typo.

2004-04-14 19:47  castaglia

	* src/main.c: 
	Cleanup the error reported if the PidFile cannot be opened.

2004-04-14 13:25  castaglia

	* modules/mod_core.c: 
	Michael suggested that this log message be at the INFO level.

2004-04-14 11:11  castaglia

	* contrib/mod_ctrls_admin.c, modules/mod_ctrls.c, src/ctrls.c: 
	Remove the unused 'set' control action from mod_ctrls_admin.  Make
	the 'lsctrl' control action list only enabled control actions. 
	Initialize the ControlsSocketACL such that access to the socket is
	allowed to everyone by default; access to individual control
	actions still defaults to "deny" unless access is explicitly
	granted via configuration.

2004-04-13 13:19  castaglia

	* doc/howto/Filters.html: 
	Emphasize _not_ using both an Allow and a Deny Filter at the same
	time.

2004-04-13 10:55  castaglia

	* include/privs.h: 
	Revert part of my previous update to privs.h; it included a
	possible fix for Bug#2317, but that fix is not ready to be
	committed just yet.

2004-04-13 10:52  castaglia

	* NEWS, include/privs.h: 
	Bug#2387 - PRIVS_USER macro should set effective GID to user's
	primary GID.

2004-04-13 09:48  castaglia

	* include/dirtree.h, src/dirtree.c: 
	Add a SID (Server ID) to every server_rec.  This SID is a unique ID
	that is automatically assigned to each generated server_rec when
	proftpd parses its configuration.  SIDs are useful for tracking
	purposes, particularly for contrib modules that want to track which
	vhost caused something to happen.
	
	Format/style cleanups, removed unused CLASS_USER #define.

2004-04-13 09:46  castaglia

	* contrib/mod_ctrls_admin.c: 
	Update the proftpd version required by mod_ctrls_admin.

2004-04-12 10:41  castaglia

	* modules/mod_auth.c: 
	Have AnonRejectPasswords generate an event.

2004-04-12 10:35  castaglia

	* modules/mod_ctrls.c: 
	Consistent use of strcmp().  Use ANY_MODULE where appropriate,
	rather than NULL.

2004-04-12 10:14  castaglia

	* src/fsio.c: 
	Fix pr_fsio_getline() to handle the case where a config line,
	broken across several lines in the config file using line
	continuations, has one of the lines commented out, e.g.:
	
	   SomeDirective \
	     foo \
	   #  bar \
	     baz
	
	Without this patch, pr_fsio_getline() would return the '#'
	character, which is not what most people would think would happen.

2004-04-12 10:09  castaglia

	* src/dirtree.c: 
	Be a little more strict when checking for "${env:...}" strings in
	the config file.
	
	Format/style cleanup.

2004-04-11 15:50  castaglia

	* doc/howto/: BCP.html, Globbing.html, index.html: 
	Add the Globbing and BCP howtos.

2004-04-11 15:38  castaglia

	* include/options.h: 
	Updating outdated comments.

2004-04-11 15:13  castaglia

	* modules/mod_xfer.c: 
	Typo.

2004-04-11 15:03  castaglia

	* modules/mod_xfer.c: 
	Make the 'core.signal.USR2' event handler check for new
	TransferRates when involved in any of the file data transfer
	commands (APPE, RETR, STOR, STOU), not just RETR.  Update comments
	as well.

2004-04-11 13:42  castaglia

	* NEWS, modules/mod_ctrls.c, src/ctrls.c: 
	Bug#2383 - mod_ctrls.c: ctrls_listen(): Invalid size in bind()
	argument.

2004-04-11 13:35  castaglia

	* modules/mod_xfer.c: 
	Add a handler for the event 'core.signal.USR2' to mod_xfer.  The
	handler causes mod_xfer, if and only if the RETR command is
	currently being handled, to rescan the config tree for TransferRate
	entries.
	
	The 'core.signal.USR2' event is only generated when Controls have
	been enabled, so in most cases this won't change anything.  Its
	purpose is mainly to help the mod_shaper module be able to change
	the TransferRate for a session in mid-transfer.

2004-04-11 13:27  castaglia

	* include/dirtree.h, src/dirtree.c: 
	Add a new merge flag, CF_SILENT.  Unlike the rest of the CF_ flags,
	this flag is handled by fixup_dirs(); the other CF_ flags are
	handled by the internal _reorder_dirs() function.  When
	fixup_dirs() sees CF_SILENT, it will not print a debug
	configuration dump, which is its default behavior.

2004-04-11 13:22  castaglia

	* src/event.c: 
	Make sure that the order of event registration matches module load
	order.	This helps when the same event may be handled by multiple
	modules, and the order of handling is important.

2004-04-11 13:12  castaglia

	* modules/mod_core.c: 
	This copy of copy_file() is no longer needed.

2004-04-10 13:55  castaglia

	* contrib/: ftpasswd.html, ftpquota.html, mod_ctrls_admin.html,
	mod_ifsession.html, mod_quotatab.html, mod_quotatab_file.html,
	mod_quotatab_ldap.html, mod_quotatab_sql.html, mod_radius.html,
	mod_rewrite.html, mod_site_misc.html, mod_sql.html, mod_tls.html,
	mod_wrap.html: 
	Minor formatting change (removed extraneous <br>).

2004-04-10 13:42  castaglia

	* doc/howto/: FXP.html, index.html: 
	Add FXP howto.

2004-04-10 13:37  castaglia

	* doc/howto/: NAT.html, index.html: 
	Add NAT howto.

2004-04-10 13:11  castaglia

	* doc/howto/SQL.html: 
	Update the SQL howto to mention using SQLLogFile.

2004-04-10 12:02  castaglia

	* doc/howto/index.html: 
	Add an index page for these howtos.

2004-04-10 11:44  castaglia

	* doc/howto/Directory.html: 
	Typo.

2004-04-10 11:33  castaglia

	* doc/howto/Directory.html: 
	Add paragraph describing how the * glob within a path is matched
	(i.e.  only for single directory level, not multiple directory
	levels).

2004-04-10 11:01  castaglia

	* doc/howto/: Authentication.html, Chroot.html, ConfigFile.html,
	Debugging.html, Directory.html, FTP.html, Filters.html, Limit.html,
	SQL.html, ServerType.html, Stopping.html, TLS.html, Umask.html,
	Vhost.html: 
	Standardize on "Last Updated" in the footer.

2004-04-10 10:59  castaglia

	* doc/howto/Logging.html: 
	Add Logging doc.

2004-04-10 10:42  castaglia

	* doc/howto/: Authentication.html, ConfigFile.html, Filters.html,
	Limit.html, ServerType.html, Stopping.html, Vhost.html: 
	Modifying links in docs to reference other docs in this area,
	rather than the pages on www.castaglia.org.

2004-04-10 10:29  castaglia

	* doc/howto/Stopping.html: 
	Add doc for starting/stopping proftpd.

2004-04-10 10:23  castaglia

	* doc/howto/FTP.html: 
	Add doc covering FTP commands supported by proftpd.

2004-04-10 10:16  castaglia

	* doc/howto/ServerType.html: 
	Adding ServerType doc.

2004-04-09 19:30  castaglia

	* modules/mod_auth_unix.c: 
	When compiling on a HP-UX box which supports bigcrypt(), the
	following warning is seen:
	
	  passing arg 1 of `bigcrypt' discards qualifiers from pointer
	target type
	
	Quell this warning by explicitly casting the arguments to
	bigcrypt() to be char *.

2004-04-09 19:01  castaglia

	* doc/howto/SSH.html: 
	Add FTP-over-SSH mini-HOWTO.

2004-04-09 17:34  castaglia

	* doc/howto/: Authentication.html, Chroot.html, ConfigFile.html,
	Debugging.html, Directory.html, Filters.html, Limit.html, SQL.html,
	TLS.html, Umask.html, Vhost.html: 
	Adjusting footers for consistency.

2004-04-09 17:19  castaglia

	* doc/howto/Umask.html: 
	Add the Umask mini-HOWTO.

2004-04-09 11:49  castaglia

	* doc/howto/Filters.html: 
	Add the Filters mini-HOWTO to the source distro.

2004-04-09 10:19  castaglia

	* contrib/: mod_ctrls_admin.c, mod_ctrls_admin.html: 
	Add ability to kick entire Classes via the 'kick' action.

2004-04-09 09:58  castaglia

	* include/fsio.h, modules/mod_core.c, src/fsio.c, src/mkhome.c: 
	The CreateHome code also included a static copy_file() function. 
	This change refactors the code so that both CreateHome and the
	rename-across-mount-points code both use the same function, added
	to the FSIO code as pr_fs_copy_file().	Code reuse good.

2004-04-09 09:54  castaglia

	* contrib/mod_ifsession.c: 
	Removing this HOOK, as it won't work as intended.  May re-add in
	the future.

2004-04-08 17:23  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2385 - Renames fail with error "Invalid cross-device link".  In
	the case of EXDEV from rename(2), mod_core now manually copies the
	file from the source to the destination location.  Any content
	existing at the destination location is lost.

2004-04-08 15:50  castaglia

	* contrib/mod_ifsession.html: 
	Add note about making sure that mod_ifsession is last in the
	--with-modules list.

2004-04-07 19:54  castaglia

	* contrib/mod_ctrls_admin.html: 
	Updating author, copyright info.

2004-04-07 19:43  castaglia

	* contrib/mod_ctrls_admin.html: 
	Add mod_ctrls_admin docs for the 'kick' action.

2004-04-07 19:39  castaglia

	* contrib/mod_ctrls_admin.c: 
	Add the 'kick' action to mod_ctrls_admin, for disconnecting clients
	by user or host names.

2004-04-07 13:12  castaglia

	* doc/howto/Authentication.html: 
	Add note about avoiding use of mod_auth.c and mod_auth_pam.c in
	AuthOrder directives.

2004-04-07 12:55  castaglia

	* contrib/mod_quotatab.html: 
	Add comment about per-session settings in mod_quotatab docs.

2004-04-07 12:02  castaglia

	* contrib/mod_quotatab.c: 
	Add a QuotaLog message warning that when per_session is true, the
	QuotaTallyTable will not be updated.

2004-04-06 16:17  castaglia

	* NEWS, config.h.in: 
	Bug#2221 - proftpd on hp-ux 11.22.  Override the default socklen_t
	detection on HP-UX 11 to be an int.  APR suffers from this same
	problem (the bug is ultimately an HP-UX problem).

2004-04-05 18:50  castaglia

	* src/ctrls.c: 
	Fix a format warning on Solaris.

2004-04-05 16:01  castaglia

	* contrib/mod_tls.c: 
	Make sure and clear the relevant bits in tls_flags when the control
	and data channels are closed.

2004-04-05 11:01  castaglia

	* src/ctrls.c: 
	Remove a hardcoded maximum limit on the size of request strings
	that can be sent using the Controls API.  Uncovered when trying to
	send messages larger than 8 Kb via SysV message queues.

2004-04-05 10:59  castaglia

	* modules/mod_auth.c, src/scoreboard.c: 
	Check for an error return value from pr_rewind_scoreboard().
	
	Keep track of the process which opened the cached scoreboard fd. 
	It's possible to have the daemon process open the fd, and then
	fork, which means the child will have that same fd.  However, the
	child may fdopen() another file onto that fd (e.g. if the fd is 0),
	thus losing the scoreboard fd.	This patch also prevents the
	possibility of a file descriptor leak by having the same process
	open the scoreboard multiple times (e.g. when multiple modules call
	pr_open_scoreboard()).

2004-04-05 10:54  castaglia

	* NEWS: 
	Mention the adding of mini-HOWTOs in NEWS.

2004-03-25 11:22  castaglia

	* configure: 
	Updating configure.

2004-03-25 11:16  castaglia

	* configure.in: 
	Remove checks for README.mod_sql from configure.

2004-03-25 09:33  castaglia

	* contrib/mod_tls.c: 
	Report the version of OpenSSL used in server debugging output.

2004-03-24 13:57  castaglia

	* contrib/ftpasswd.html: 
	Reflect Bug#2371's new --not-previous-passsword addition in the
	ftpasswd HTML docs.

2004-03-24 13:55  castaglia

	* NEWS, contrib/ftpasswd: 
	Bug#2371 - ftpasswd should have option to compare password against
	value in passwd file.

2004-03-23 15:29  castaglia

	* contrib/mod_tls.c: 
	Be more explicit about the expected return value from
	SSL_CTX_load_verify_locations(3).  Handle the cases where the
	pointers to the CA file or CA path may be NULL, as some libcs do
	not handling printing of NULL pointers gracefully, unlike glibc.

2004-03-23 10:40  castaglia

	* modules/mod_ls.c: 
	Add a comment explaining the fix for Bug#2367.

2004-03-23 10:37  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2367 - LIST *.* strange behaviour.

2004-03-22 11:44  castaglia

	* doc/howto/: Authentication.html, Chroot.html, ConfigFile.html,
	Debugging.html, Directory.html, Limit.html, TLS.html, Vhost.html: 
	Adding more howtos.

2004-03-22 11:32  castaglia

	* README.mod_sql: 
	Removing this outdated README; see doc/howto/SQL.html for an
	updated version.

2004-03-22 11:31  castaglia

	* doc/howto/SQL.html: 
	Adding an HTML SQL howto to the doc/ area, to replace the
	README.mod_sql (which is now terribly outdated).

2004-03-19 12:22  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2369 - EPSV should not send network address when
	MasqueradeAddress is used.  RFC 2428 is not very clear on this
	point, for it introduces a discrepancy in the possible responses to
	PASV versus EPSV.  Until this can be cleared up, do not honor
	MasqueradeAddress when EPSV is used by the client.

2004-03-17 10:48  castaglia

	* contrib/mod_sql.html: 
	Removed mention of "*" for the SQLAuthenticate directive.

2004-03-16 13:46  castaglia

	* contrib/mod_sql.c: 
	Mark the SQLLog and SQLShowInfo config_recs as CF_MERGEDOWN_MULTI. 
	This doesn't affect how mod_sql processes these directives, but it
	does make them work properly within mod_ifsession blocks.

2004-03-10 18:18  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2363 - ABOR response RFC 959 compliance.

2004-03-10 18:02  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#2361 - Second USER command causes problems with chrooted
	session.  The PRE_CMD handler for C_USER should check to see if a
	user is already logged in before doing any processing.

2004-03-10 16:13  castaglia

	* NEWS: 
	Typos.

2004-03-09 17:31  castaglia

	* include/privs.h: 
	Typo.

2004-03-08 16:53  castaglia

	* src/netaddr.c: 
	Add some debug logging, level 10, showing when a name is being
	resolved to its IP addresses, including when DNS is used.
	
	At debug level 10, things are getting quite verbose; we should
	start looking into debugging output masks.

2004-03-08 12:32  castaglia

	* README.controls: 
	Clarify that using --enable-ctrls means not using
	--with-modules=mod_ctrls.

2004-03-05 10:48  castaglia

	* modules/mod_core.c: 
	On second thought, setting errno to ENOENT in these cases may not
	be the best idea.

2004-03-05 10:36  castaglia

	* modules/mod_core.c: 
	Make sure that errno has an appropriate value in the case where a
	resolved path may actually be NULL.  Also, report on failed paths
	using cmd->arg, rather than cmd->argv[1], to handle the case where
	the client may have specified a path containing whitespace
	characters.

2004-03-05 10:22  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2321 - FTP permission checks inconsistent for DELE and RMD when
	symlink in directory path.  For future reference, if
	dir_canonical_path() is used to obtain a path, use
	dir_check_canon() for checking <Limit> permissions on that returned
	path, instead of using dir_check().  The dir_* namespace could use
	some cleaning up, to make this sort of relationship a little
	clearer.

2004-03-04 19:24  castaglia

	* NEWS, utils/ftptop.c: 
	Bug#2357 - ftptop should use COLS for determining display width.

2004-03-04 19:00  castaglia

	* configure: 
	Updating configure.

2004-03-04 18:13  castaglia

	* NEWS, config.h.in, configure.in, modules/mod_xfer.c: 
	Bug#2353 - REST doesn't handle offsets greater than 2 GB.

2004-03-04 13:13  castaglia

	* modules/mod_core.c: 
	Change handling of the SetEnv, UnsetEnv directives so that that
	they can be set on a per-vhost basis.

2004-03-03 17:41  castaglia

	* contrib/mod_tls.c: 
	Didn't mean to commit those debugging changes.	Oops.

2004-03-03 17:33  castaglia

	* contrib/mod_tls.c: 
	No need to be that verbose.

2004-03-03 13:21  castaglia

	* contrib/mod_tls.c: 
	Handle the case where mod_tls has been configured to set
	environment variables but the client does not present a certificate
	(e.g. when not verifying clients).  Previously, this would cause a
	segfault.

2004-03-02 16:24  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2355 - Send error message to client when 'TLSRequired both' is
	in effect.

2004-03-02 09:43  castaglia

	* contrib/mod_tls.c: 
	Typo.

2004-03-01 08:55  castaglia

	* include/conf.h: 
	Doesn't help to check for <utime.h> if we don't include it.

2004-03-01 08:54  castaglia

	* contrib/mod_ctrls_admin.c: 
	Typo.  Eventually, mod_ctrls_admin's dump control will handling
	list of variables in the (as yet uncommitted) Variables API.

2004-03-01 08:47  castaglia

	* configure: 
	Updating configure.

2004-03-01 08:44  castaglia

	* config.h.in, configure.in: 
	Check for the <utime.h> system header.

2004-03-01 08:43  castaglia

	* contrib/mod_ctrls_admin.c, contrib/mod_ctrls_admin.html,
	src/netacl.c: 
	Complete the 'dump classes' control for mod_ctrls_admin.  Also adds
	the missing pr_netacl_get_type() function.

2004-03-01 08:42  castaglia

	* src/event.c: 
	Add some basic caching of the last valid event generated, as a
	minor optimization.

2004-02-27 16:17  castaglia

	* contrib/mod_sql.html: 
	Add HTML docs for mod_sql.

2004-02-27 14:53  castaglia

	* modules/mod_ls.c: 
	STAT is an INFO command more than it is a DIRS command (for logging
	purposes).

2004-02-27 14:42  castaglia

	* contrib/mod_sql.c: 
	Add handling of the %L (local IP address) and %V (local DNS name)
	tags.  Fix formatting.

2004-02-27 11:44  castaglia

	* modules/mod_cap.c: 
	Bug#2348 prompted this addition of handling CAP_DAC_OVERRIDE and
	CAP_DAC_READ_SEARCH, in addition to CAP_CHOWN.

2004-02-27 11:27  castaglia

	* NEWS, README.modules: 
	Bug#2257 - Add SITE SYMLINK command to mod_site.  Added a new
	contrib module, mod_site_misc, instead.

2004-02-27 10:41  castaglia

	* contrib/: mod_site_misc.c, mod_site_misc.html: 
	New contrib module that implements miscellaneous SITE commands
	(e.g. SITE SYMLINK, SITE UTIME, etc) that other ftpds may recognize
	(e.g. ncftpd).

2004-02-24 12:34  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2339 - STAT command doesn't follow RFC959.

2004-02-24 12:32  castaglia

	* sample-configurations/basic.conf: 
	It's a little more efficient to have AllowOverwrite in the server
	config context, rather than in a <Directory> context that covers
	the entire filesystem.

2004-02-24 12:13  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#2311 - MaxClients counts unauthenticated users.

2004-02-24 11:45  castaglia

	* contrib/mod_sql.c: 
	Oops.  My previous commit included my work-in-progress patch for
	SQLShowInfo, which isn't ready yet.

2004-02-24 11:39  castaglia

	* contrib/mod_sql.c: 
	Fixed a bug in mod_sql in the show_group() function, where a large
	list of users that belonged to a single group could tickle a
	segfault.  There was a hardcoded buffer size of 2K that was being
	exceeded.  Better to use pstrcat() and build up the needed string.
	
	Also add some typecasts to unsigned longs for reporting IDs.

2004-02-24 08:52  castaglia

	* modules/mod_core.c: 
	Typos.

2004-02-23 16:44  castaglia

	* modules/mod_xfer.c: 
	Allow uploading to FIFOs.  Should we allow uploading to symlinks,
	too?

2004-02-23 15:27  castaglia

	* modules/mod_site.c: 
	mod_site no longer uses a configuration handler table.

2004-02-23 11:30  castaglia

	* src/dirtree.c: 
	Quell a minor compiler warning on OSX.

2004-02-23 10:34  castaglia

	* README.modules: 
	Adding mod_quotatab et al to the list of modules that accompany
	proftpd.

2004-02-20 10:34  castaglia

	* NEWS, include/dirtree.h, modules/mod_core.c, src/dirtree.c,
	src/main.c: 
	Bug#1696 - Include directive should support directories.

2004-02-20 09:10  castaglia

	* contrib/ftpasswd: 
	When the --not-system-password option is used, it's possible for
	there to be no entry in the system password files for the user
	being created, in which case $hash and $syspasswd will both be the
	empty string -- and will match, making ftpasswd think that a
	different password is needed.  Fix this by checking for the empty
	strings.

2004-02-19 10:22  castaglia

	* README.IPv6: 
	Updating the IPv6 notes.

2004-02-19 10:13  castaglia

	* contrib/mod_ifsession.c: 
	Add a check for <Limit LOGIN> to mod_ifsession, after all the
	configuration merging is done.	This allows for configurations
	like:
	
	  <IfUser foo>
	    <Limit LOGIN>
	      DenyAll
	    </Limit>
	  </IfUser>

2004-02-16 19:53  castaglia

	* NEWS, modules/mod_auth_pam.c: 
	Bug#2105 - Remove Authoritative directives.

2004-02-16 19:09  castaglia

	* contrib/ftpasswd.html: 
	Documenting the new --delete-user and --delete-group options. 
	Examples should be added at some point, too.

2004-02-16 19:06  castaglia

	* NEWS, contrib/ftpasswd: 
	Bug#2171 - Add delete options to ftpasswd.

2004-02-16 18:15  castaglia

	* Make.rules.in, contrib/mod_tls.c, include/conf.h, include/help.h,
	modules/mod_auth.c, modules/mod_core.c, modules/mod_ls.c,
	modules/mod_site.c, modules/mod_xfer.c, src/help.c: 
	Adding a new API so that modules can declare, for the HELP response
	list, which FTP commands they support.	This makes it
	easier/cleaner for contrib modules, e.g. mod_tls, to declare their
	support for FTP commands that may not be handled by the core code.

2004-02-16 15:05  castaglia

	* NEWS, modules/mod_xfer.c: 
	Bug#2237 - HiddenStores does not check for existing file in edge
	case.

2004-02-15 14:58  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#2327 - SQLNegativeCache causes unnecessary errors in server
	logging.

2004-02-15 14:42  castaglia

	* contrib/mod_sql.c: 
	Note the directive name when warning of deprecated * usage.

2004-02-15 14:05  castaglia

	* contrib/mod_sql.c: 
	Disable the "*" functionality in SQLAuthenticate, which was used to
	configure mod_sql to be authoritative.	This conflicts with the
	AuthOrder configuration directive, which should be used instead.

2004-02-15 11:41  castaglia

	* NEWS: 
	Mention in the NEWS file that Class and Classes are now deprecated.

2004-02-13 15:37  castaglia

	* contrib/mod_quotatab.h: 
	Update mod_quotatab's PROFTPD_VERSION_NUMBER check.

2004-02-13 15:28  castaglia

	* contrib/mod_ifsession.c: 
	Update the PROFTPD_VERSION_NUMBER check.

2004-02-13 14:47  castaglia

	* contrib/mod_rewrite.c: 
	Updating mod_rewrite for Class code changes.

2004-02-13 14:45  castaglia

	* contrib/mod_quotatab.c: 
	Updating mod_quotatab for Class code changes.

2004-02-13 14:44  castaglia

	* contrib/mod_ifsession.c: 
	Updating mod_ifsession to reflect Class changes.

2004-02-12 15:46  castaglia

	* NEWS, Makefile.in: 
	Bug#2340 - Problem with parallel builds.

2004-02-11 19:48  castaglia

	* contrib/mod_radius.html: 
	Update the mod_radius installation instructions.

2004-02-11 19:47  castaglia

	* contrib/mod_radius.html: 
	Typo.

2004-02-11 19:41  castaglia

	* contrib/mod_radius.html: 
	Update the mod_radius docs.

2004-02-10 15:31  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2337 - TLSRenegotiate parameters not processed correctly.

2004-02-09 20:07  castaglia

	* contrib/mod_tls.c: 
	When walking the server_list list, we need to start with
	server_list->xas_list, not just server_list.  This is a subtle and
	easy to miss bug, and was causing the list-walking code to attempt
	to access inaccessible memories (not good).
	
	This highlights a need for a good list/set-iterating API, rather
	than relying on details of the actual structures.

2004-02-07 17:55  castaglia

	* contrib/mod_readme.c: 
	Update mod_readme to use the new pr_gmtime() function.

2004-02-07 17:12  castaglia

	* NEWS, utils/ftpcount.c: 
	Bug#2306 - ftpcount output should handle case of no users.

2004-02-07 16:40  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2324 - Directories whose names contain whitespace are
	inaccessible.  The problem was that the dir_check() call was using
	cmd->argv[0], rather than cmd->arg; the former is the first
	parameter of the command (where the parameters are assumed to be
	whitespace-separated) whereas the latter is the entire parameter
	list as a single string.  The rest of the patch cleans up the
	formatting in the chdir() handling code.

2004-02-04 10:45  castaglia

	* src/xferlog.5.in: 
	Document in the xferlog(5) man page that any space or control
	characters in a filename will be converted to an underscore in
	TransferLogs.

2004-02-03 15:57  castaglia

	* NEWS, modules/mod_core.c, src/dirtree.c: 
	Bug#2315 - Overlapping virtual server causes error.
	
	Also changes the collision check log messages to say "warning"
	rather than "error".

2004-02-01 12:51  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2322 - NLST -a returns listing formatted for LIST -a.

2004-01-30 16:08  castaglia

	* src/log.c: 
	Addition of PID was redundant.	Oops.

2004-01-30 15:09  castaglia

	* src/netaddr.c: 
	"dup" is an already used global variable in some system headers. 
	How annoying.

2004-01-30 08:42  castaglia

	* src/main.c: 
	Remove an annoying "FTP session closed." message from being logged
	when doing a simple syntax check of a proftpd.conf whose ServerType
	is inetd.

2004-01-29 19:37  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2295 - mod_tls returns multi-line response to AUTH commands.

2004-01-29 19:09  castaglia

	* README.classes: 
	Explicitly mention that the Class and Classes directives are
	deprecated.

2004-01-29 14:20  castaglia

	* Make.rules.in, NEWS, contrib/mod_sql.c, include/class.h,
	include/conf.h, include/dirtree.h, include/netacl.h,
	include/proftpd.h, modules/mod_auth.c, modules/mod_core.c,
	modules/mod_log.c, src/class.c, src/dirtree.c, src/main.c,
	src/netacl.c: 
	Bug#1925 - Clean up of Class code.

2004-01-28 19:37  castaglia

	* src/log.c: 
	If --enable-devel is used, add the PID to the server debugging
	lines.	This might be useful enough to use all of the time, but for
	now it'll be restricted to developer use.

2004-01-28 19:19  castaglia

	* include/netaddr.h, src/netaddr.c: 
	Add a new function, pr_netaddr_dup(), for convenience.

2004-01-28 17:03  castaglia

	* contrib/mod_quotatab.c: 
	The SITE QUOTA command should be marked as a CL_MISC class command,
	so that ExtendedLogs that wish to log MISC commands record it.

2004-01-20 16:35  cyberrobo

	* .cvsignore: adding ftpdctl to the ignorelist

2004-01-20 15:26  castaglia

	* contrib/mod_quotatab_sql.html: 
	Add FREEFORM INSERT query that is needed when talking to SQL
	Server.

2004-01-20 09:11  castaglia

	* contrib/mod_radius.html: 
	Grammar fix.

2004-01-20 09:07  castaglia

	* contrib/mod_radius.html: 
	Make a note of some nonsensical RADIUS implementations not being
	supported by mod_radius.

2004-01-19 10:00  castaglia

	* contrib/mod_ctrls_admin.c, modules/mod_ctrls.c: 
	No need to re-register the controls themselves, just reallocate the
	ACLs from the new module pools.

2004-01-19 09:58  castaglia

	* contrib/mod_ctrls_admin.c, modules/mod_ctrls.c: 
	When handling the "core.restart" event, the module pools for both
	mod_ctrls and mod_ctrls_admin are destroyed/recreated.	Since the
	ACLs for the registered controls are allocated from these module
	pools, the ACLs need to be recreated as well.
	
	Also, when building mod_ctrls_admin, make sure that Controls
	support has been enabled.

2004-01-19 09:42  castaglia

	* src/log.c: 
	Make pr_log_writefile() a little more robust, by checking whether
	the given fd is valid before doing any work.

2004-01-18 11:01  castaglia

	* utils/: ftptop.c, utils.h: 
	No need to include <sys/types.h> in these files, as it is already
	included in config.h.

2004-01-18 10:21  castaglia

	* modules/mod_ctrls.c: 
	Change the usage of PRIVS macros in some of mod_ctrls' config
	handlers.  Michael found that this was causing problems when
	restarting a proftpd with Controls enabled (see Bug#2242).

2004-01-18 10:11  castaglia

	* modules/mod_ctrls.c: 
	No need to log the error using root privs.

2004-01-17 22:07  cyberrobo

	* src/.cvsignore: added ftpdctl manpage to ignore list

2004-01-17 15:18  castaglia

	* configure: 
	Updating configure script.

2004-01-17 15:16  castaglia

	* NEWS, configure.in: 
	Bug#2320 - autoconf check for socklen_t doesn't work on FreeBSD
	4.8-RELEASE.

2004-01-17 15:08  castaglia

	* NEWS, Makefile.in: 
	Bug#2319 - Build scripts have owner-only execute permission.

2004-01-17 14:57  castaglia

	* config.sub: 
	No, that didn't work.

2004-01-17 14:56  castaglia

	* config.sub: 
	Checking to see how to get permissions changed in CVS.	I think CVS
	requires that the file itself (not just the mode) differ.

2004-01-16 12:47  castaglia

	* README.classes: 
	First draft of a README describing the new <Class> syntax. 
	Edits/additions welcome.

2004-01-15 16:45  castaglia

	* modules/mod_core.c: 
	Have the emitted vhost collision message say "warning", rather than
	"error".

2004-01-15 16:29  castaglia

	* modules/mod_auth.c: 
	The current CreateHome description has the following examples:
	
	  CreateHome on skel /etc/ftpd/skel
	  CreateHome on dirmode 755
	  CreateHome on skel /etc/ftpd/skel dirmode 700
	
	However, the current CreateHome implementation assumes that the
	parameter after the Boolean will always be the mode.  This change
	makes the config handler check for any preceding 'skel' or
	'dirmode' keywords before trying to process that parameter as the
	mode.  Hopefully now the examples will work properly.

2004-01-15 15:54  castaglia

	* contrib/mod_quotatab.c: 
	Christian Schulte <cs@schulte.it> noticed that the handling of
	locks by mod_quotatab is not right.  The quotatab_write() function
	would obtain a write-lock, then call quotatab_read() to refresh its
	data, and quotatab_read() would degrade that write-lock to a
	read-lock, then release it completely, leaving the actual write
	operation unprotected by a lock.  This patch fixes the contention
	in the locking routinese by having them check and set a static
	variable.

2004-01-15 13:51  castaglia

	* README.controls: 
	Updating/fixing this document.

2004-01-14 12:57  castaglia

	* README.controls: 
	Add a README describing the new Controls code.	It's a work in
	progress.

2004-01-13 20:00  castaglia

	* modules/mod_auth.c: 
	Fix compiler warning.

2004-01-13 15:47  castaglia

	* NEWS: 
	Add comment that bug 2183 is the same as bug 2165.

2004-01-12 15:13  castaglia

	* modules/mod_xfer.c: 
	Consistency.

2004-01-12 15:01  castaglia

	* modules/mod_xfer.c: 
	Report errors when closing a file that has been written.  Such
	errors normally don't occur, but can happen with a disk is full.
	
	Fix a typo.

2004-01-11 13:33  castaglia

	* NEWS, contrib/mod_sql_mysql.c: 
	Bug#2307 - MySQL 4.1.1 API change causes mod_sql_mysql compilation
	failure.

2004-01-08 20:41  castaglia

	* src/pool.c: 
	The logic for handling new_block()'s exact argument was
	accidentally inverted.

2004-01-08 20:23  castaglia

	* include/pool.h, src/pool.c: 
	Be consistent with the argument data types.  These probably should
	be size_ts, but ints suffice.

2004-01-08 20:15  castaglia

	* include/pool.h, src/pool.c: 
	Adding some new functions to the Pool API.  These new functions
	allow for pools to be allocated for a specific size, rather than
	always having the requested size be rounded up to the nearest
	BLOCK_MINFREE (usu. 512 bytes).  These will be handy in cases where
	pools smaller than 512 bytes can be used (e.g. stash pools).

2004-01-02 07:27  jwm

	* NEWS: 
	- Bug 2267 - Broken IP subnet matching. Added new ACL
	parsing/matching code.

2003-12-30 15:17  castaglia

	* contrib/mod_sql.c: 
	Make mod_sql a little less noisy.  This "no SQLAuthTypes" message
	would be logged for every connection to a vhost that has not been
	configured for mod_sql (when mod_sql is present), which can be very
	annoying for those configurations where only some vhosts, not all,
	need to authenticate using SQL.

2003-12-30 14:56  castaglia

	* src/main.c: 
	Style.

2003-12-26 07:59  jwm

	* NEWS, Makefile.in: Bug 2305 - Compile Problems since > 1.2.9 Link
	ftpdctl against libsocket and libnsl to pick up dependency
	functions

2003-12-19 13:29  castaglia

	* contrib/mod_quotatab.c: 
	Don't subtract xfer bytes when deleting a directory.  Found and
	fixed by Christian Schulte <cs@schulte.it>

2003-12-16 09:43  castaglia

	* NEWS, src/netio.c: 
	Bug#2300 - poll() returns 1 and read returns 0, inifinite loop.

2003-12-14 14:09  jwm

	* contrib/dist/rpm/proftpd.spec: 
	[Bug 2301] New: (s)rpms should require "/sbin/chkconfig" instead of
	package "chkconfig"

2003-12-11 12:30  castaglia

	* contrib/mod_quotatab.h: 
	Bump the mod_quotatab version, for clarity.

2003-12-11 00:04  castaglia

	* modules/mod_auth.c: 
	Forgot to add strerror() to the DefaultRoot resolution debugging.

2003-12-10 23:59  castaglia

	* modules/mod_auth.c: 
	Add some debugging to the function which determines the actual path
	to use for DefaultRoot.

2003-12-09 12:08  castaglia

	* contrib/mod_quotatab.c: 
	More minor quotatab bugs fixed by Christian Schulte
	<cs@schulte.it>.

2003-12-09 11:57  castaglia

	* contrib/mod_quotatab_sql.c: 
	Bug found by Christian Schulte <cs@schulte.it>: delta values are
	signed, and can be negative.

2003-12-02 23:43  castaglia

	* contrib/: ftpquota.html, mod_quotatab.html,
	mod_quotatab_file.html, mod_quotatab_ldap.html,
	mod_quotatab_sql.html: 
	Updating mod_quotatab docs to reflect the fact that the current
	versions will now always be found in the source distribution,
	rather than on castaglia.org/proftpd.

2003-12-02 23:39  castaglia

	* NEWS, contrib/ftpquota, contrib/ftpquota.html,
	contrib/mod_quotatab.c, contrib/mod_quotatab.h,
	contrib/mod_quotatab.html, contrib/mod_quotatab_file.c,
	contrib/mod_quotatab_file.html, contrib/mod_quotatab_ldap.c,
	contrib/mod_quotatab_ldap.html, contrib/mod_quotatab_sql.c,
	contrib/mod_quotatab_sql.html: 
	Adding mod_quotatab to the contrib area.

2003-12-02 16:16  castaglia

	* NEWS, src/netaddr.c: 
	Bug#2288 - ServerFQDN set to 255.255.255.255 and not hostname. 
	This was due to the bundled inet_ntop() implementation not
	correctly handling the INADDR_NONE return value.

2003-12-01 19:06  castaglia

	* modules/mod_core.c: 
	Adjust mod_core.c to use the pr_* wrappers for gmtime(),
	localtime().

2003-12-01 18:54  castaglia

	* NEWS, include/support.h, modules/mod_ls.c, src/support.c: 
	Bug#2290 - gmtime() static storage may be overwritten by modules. 
	A portable solution is to use wrappers that memcpy() the gmtime()
	and localtime() results.

2003-11-19 12:57  castaglia

	* include/inet.h, include/netaddr.h, src/inet.c, src/netaddr.c: 
	Moving the declaration and definition of pr_get{addr,name}info,
	pr_freeadrinfo, pr_inet_{ntop,pton} from inet to netaddr, as
	netaddr is the file that uses those functions most.  Also, it
	solves some linking problems on older systems that do not have the
	get{addr,name}info(2) functions.

2003-11-19 12:13  castaglia

	* NEWS, Makefile.in: 
	Bug#1635 - Older systems' chown(1) does not support -h option.

2003-11-17 10:58  castaglia

	* src/netaddr.c: 
	Adding comments to clarify the purpose/usage of the get_v4inaddr()
	function.

2003-11-15 17:32  castaglia

	* src/netacl.c: 
	Forgot to change this function name.

2003-11-15 17:25  castaglia

	* src/netacl.c: 
	Typo.

2003-11-15 16:55  castaglia

	* include/netacl.h, src/dirtree.c, src/netacl.c: 
	Making the ACL type publically available via an accessor.

2003-11-15 16:49  castaglia

	* contrib/: mod_ctrls_admin.c, mod_ctrls_admin.html: 
	Split the 'debug config|memory' stuff into a new control action,
	'dump'.  In the future, the 'dump' action will also support dumping
	of <Class> and <Directory> information.

2003-11-15 15:49  castaglia

	* Make.rules.in, include/conf.h, include/dirtree.h,
	include/netacl.h, include/netaddr.h, modules/mod_core.c,
	src/dirtree.c, src/netacl.c, src/netaddr.c: 
	Adding new ACL parsing/matching code.  This is flexible enough to
	handle IPv6 addresses, and will be used in the new <Class>
	definition code (coming soon).	This should also fix the ACL
	checking that was broken (Bug#2267) in 1.2.9's IPv6 changes.

2003-11-15 12:41  castaglia

	* modules/mod_core.c: 
	Need to set the ServerAddress field of the main_server as well when
	handling the DefaultAddress directive, because fixup_servers()
	later checks that field.

2003-11-15 12:30  castaglia

	* src/dirtree.c: 
	Bad grammar.

2003-11-15 12:27  castaglia

	* NEWS, src/dirtree.c: 
	Bug#2048 - Add ability to get configuration file values from
	environment.

2003-11-15 11:52  castaglia

	* NEWS, include/dirtree.h, src/dirtree.c: 
	Bug#2274 - Default server only binds to one IP address of host if
	--enable-ipv6 is used.

2003-11-15 11:43  castaglia

	* modules/mod_core.c: 
	Handle IPv4 address Binds properly for DefaultAddress when IPv6 is
	in use.

2003-11-14 18:31  castaglia

	* configure: 
	Updating configure.

2003-11-14 18:27  castaglia

	* configure.in: 
	When checking for the security and sec libs on Tru64 Unix, we need
	to check for the libs before checking for the functions via
	AC_CHECK_FUNC, not after.

2003-11-12 23:25  castaglia

	* src/netaddr.c: 
	Should be using pcalloc() not palloc().

2003-11-12 11:14  castaglia

	* contrib/: mod_ctrls_admin.c, mod_ctrls_admin.html: 
	Use '#' as the address/port delimiter, rather than '/'.

2003-11-12 08:20  castaglia

	* NEWS, src/inet.c: 
	Updating code for Mac OS X 10.3 (Darwin 7).

2003-11-10 13:38  castaglia

	* configure: 
	Updating configure.

2003-11-10 13:33  castaglia

	* config.h.in, configure.in: 
	Add a check for the getenv(3) function.

2003-11-09 19:56  castaglia

	* contrib/mod_ctrls_admin.html: 
	Document the 'config' option to the 'debug' action.

2003-11-09 19:55  castaglia

	* contrib/mod_ctrls_admin.c, include/dirtree.h, src/dirtree.c: 
	Rearrange the config-dumping code a little and provide a public
	function for it, so that mod_ctrls_admin can support a 'debug
	config' action.

2003-11-09 19:52  castaglia

	* src/pool.c: 
	Better name for this printf-like function pointer variable.

2003-11-09 19:14  castaglia

	* configure: 
	Updating configure.

2003-11-09 19:10  castaglia

	* configure.in: 
	Some systems (e.g. FreeBSD) declare getaddrinfo(2) in
	<sys/socket.h>.

2003-11-09 16:51  castaglia

	* contrib/mod_ctrls_admin.c: 
	Update mod_ctrls_admin to use events.

2003-11-09 16:01  castaglia

	* contrib/: mod_ctrls_admin.c, mod_ctrls_admin.html: 
	Controls are useless without something implementing some control
	actions; add the mod_ctrls_admin module (was mod_ctrls_common) to
	contrib.

2003-11-09 15:32  castaglia

	* src/: auth.c, ctrls.c, data.c, dirtree.c, event.c, fsio.c,
	ident.c, log.c, main.c, mkhome.c, netaddr.c, scoreboard.c,
	support.c: 
	Updating the source code to use pr_log_debug() rather than
	log_debug().

2003-11-09 15:10  castaglia

	* modules/: mod_auth.c, mod_auth_file.c, mod_cap.c, mod_core.c,
	mod_ctrls.c, mod_log.c, mod_ls.c, mod_site.c, mod_xfer.c: 
	Updating modules to use pr_log_debug() rather than log_debug().

2003-11-09 14:59  castaglia

	* include/privs.h: 
	Use pr_log_debug() rather than log_debug().

2003-11-09 14:54  castaglia

	* doc/mod_sample.c: 
	Updating the sample module mod_sample.c to use pr_log_*() rather
	than log_*().

2003-11-09 14:51  castaglia

	* modules/mod_core.c: 
	unsetenv(3) returns void, not int.

2003-11-09 14:48  castaglia

	* src/main.c: 
	Typo.

2003-11-09 14:43  castaglia

	* src/main.c: 
	Forgot to cleanup one sig_debug() reference.

2003-11-09 14:40  castaglia

	* include/proftpd.h, src/main.c: 
	Tweak the handling of SIGUSR2 a little.  If controls are not
	enabled, keep the current behavior: the proftpd process will print
	a memory dump.	If controls are enabled, generate a
	"core.signal.USR2" event, which will allow modules to register
	multiple handlers for this same event.	This way, mod_ctrls_common
	can use SIGUSR2 to get other proftpd processes to print memory
	dumps, and thus keeping the ability to get memory dumps from any
	proftpd process.  Without this change, if controls are enabled, we
	can only get a memory dump of the daemon process (and most of the
	time, it is the session processes in which we are interested).

2003-11-09 14:19  castaglia

	* Make.rules.in, include/conf.h, include/log.h, include/support.h,
	include/xferlog.h, modules/mod_auth.c, modules/mod_core.c,
	modules/mod_xfer.c, src/log.c, src/main.c, src/support.c,
	src/xferlog.c: 
	Splitting the TransferLog routines into their own source file, and
	moving the functions into a nonpublic xferlog_ namespace.

2003-11-09 13:35  castaglia

	* contrib/mod_ldap.c: 
	Updating mod_ldap.c to use pr_log_*() rather than log_*().

2003-11-09 13:29  castaglia

	* contrib/mod_ratio.c: 
	Updating mod_ratio.c to use pr_log_*() rather than log_*().

2003-11-09 13:28  castaglia

	* contrib/mod_wrap.c: 
	Updating mod_wrap.c to use pr_log_*() rather than log_*().

2003-11-09 13:26  castaglia

	* contrib/mod_tls.c: 
	Updating mod_tls.c to use pr_log_*() rather than log_*().

2003-11-09 13:25  castaglia

	* contrib/mod_sql_postgres.c: 
	Updating mod_sql_postgres to use pr_log_*() rather than log_*().

2003-11-09 13:24  castaglia

	* modules/mod_core.c, src/main.c: 
	The function is now pr_log_setdebuglevel(), not
	log_setdebuglevel().

2003-11-09 13:23  castaglia

	* contrib/mod_sql_mysql.c: 
	Updating mod_sql_mysql.c to use pr_log_*() rather than log_*().

2003-11-09 13:22  castaglia

	* contrib/mod_sql.c: 
	Updating mod_sql.c to use pr_log_*() rather than log_*().

2003-11-09 13:20  castaglia

	* contrib/mod_rewrite.c: 
	Updating mod_rewrite.c to use pr_log_*() rather than log_*().

2003-11-09 13:19  castaglia

	* contrib/mod_readme.c: 
	Updating mod_readme to use pr_log_debug() rather than log_debug().

2003-11-09 13:18  castaglia

	* contrib/mod_radius.c: 
	Updating mod_radius.c to use pr_log_pri() rather than log_pri().

2003-11-09 13:16  castaglia

	* contrib/mod_ifsession.c: 
	Updating mod_ifsession to use pr_log_debug() rather than
	log_debug().

2003-11-09 13:11  castaglia

	* include/privs.h: 
	Updating privs.h to use the pr_log_* functions.  Also cleans up
	some cruft related to checking of when session.login_uid is set.

2003-11-09 13:09  castaglia

	* include/bindings.h, include/log.h, lib/pwgrent.c,
	modules/mod_auth.c, modules/mod_auth_file.c,
	modules/mod_auth_pam.c, modules/mod_auth_unix.c, modules/mod_cap.c,
	modules/mod_core.c, modules/mod_ctrls.c, modules/mod_log.c,
	modules/mod_ls.c, modules/mod_xfer.c, src/auth.c, src/bindings.c,
	src/ctrls.c, src/data.c, src/dirtree.c, src/fsio.c, src/inet.c,
	src/log.c, src/main.c, src/mkhome.c, src/modules.c, src/netaddr.c,
	src/pool.c, src/regexp.c, src/scoreboard.c, src/support.c: 
	Moving the log_*() functions into the pr_ namespace.  Let the
	terror and madness begin!  Actually, log.h includes some
	transitional macros, so that the old symbols will be redefined
	properly.

2003-11-09 11:53  castaglia

	* NEWS: 
	Note the affect of the logging class change for RNFR and RNTO.

2003-11-09 09:08  castaglia

	* src/ftpdctl.8.in: 
	Still not quite right.	Trying to get the action-parameters to be
	properly shown as optional parameters to the action part of the
	command.

2003-11-09 09:04  castaglia

	* src/ftpdctl.8.in: 
	Tweak the ftpdctl man page a little.

2003-11-09 00:02  castaglia

	* configure: 
	Updating configure.

2003-11-09 00:00  castaglia

	* Makefile.in, configure.in, src/ftpdctl.8.in: 
	Adding ftpdctl man page.

2003-11-08 23:47  castaglia

	* src/ctrls.c: 
	Tag pools allocated in the Controls API.  Style cleanup.

2003-11-08 21:38  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2046 - Change RFNR and RNTO logging class to WRITE.

2003-11-08 21:15  castaglia

	* contrib/mod_wrap.c: 
	Wrong function name.

2003-11-08 21:11  castaglia

	* modules/: mod_auth.c, mod_core.c, mod_xfer.c: 
	Updating the rest of the core code to use the newer Expressions
	API.

2003-11-08 21:03  castaglia

	* contrib/mod_wrap.c: 
	Updating mod_wrap for the newer Expressions API.

2003-11-08 20:53  castaglia

	* contrib/mod_ifsession.c: 
	Updating mod_ifsession to use the new Expressions API.	Fixed a
	compiler warning issued under --enable-devel.

2003-11-08 20:46  castaglia

	* include/dirtree.h, src/dirtree.c: 
	Cleaning up the API for evaluating user, group, and class
	expressions.  This commit gives the API a consistent pr_expr_
	prefix.  It also provides some transitional macros.

2003-11-08 20:43  castaglia

	* configure: 
	Updating configure.

2003-11-08 19:41  castaglia

	* contrib/mod_ifsession.c: 
	Adjust mod_ifsession to use the same expression indicator values as
	the core code.

2003-11-08 19:37  castaglia

	* NEWS, include/dirtree.h, modules/mod_core.c, src/dirtree.c: 
	Bug#2015 - Add AND, OR keywords to Allow/DenyUser directives.  This
	affects the AllowGroup and DenyGroup directives as well.

2003-11-08 18:34  castaglia

	* modules/mod_ctrls.c: 
	Register a handler for the "core.exit" event, rather than using
	pr_exit_register_handler().  The latter function will be being
	phased out.

2003-11-08 18:29  castaglia

	* modules/mod_auth.c: 
	Generate events when the MaxClients* and MaxHostsPerUser limits are
	hit.

2003-11-08 18:17  castaglia

	* include/event.h, src/event.c, src/main.c: 
	Add generation of "core.exit" event.  Adjust the event
	unregistration function to handle the needs of the core code when
	doing exit handler processing.

2003-11-08 18:08  castaglia

	* modules/mod_ctrls.c: 
	Modify mod_ctrls to use the new Event API (as all new modules
	should).

2003-11-08 17:55  castaglia

	* Make.rules.in, Makefile.in, NEWS, config.h.in, configure.in,
	include/bindings.h, include/conf.h, include/ctrls.h,
	include/mod_ctrls.h, include/pool.h, modules/mod_ctrls.c,
	src/Makefile.in, src/bindings.c, src/ctrls.c, src/ftpdctl.c,
	src/main.c, src/modules.c, src/pool.c: 
	Bug#2072 - Add Controls API.  Still to be done: a man page for
	ftpdctl, better documentation for mod_ctrls.

2003-11-08 16:52  castaglia

	* src/bindings.c: 
	Remove (now) unused variable.

2003-11-08 15:34  castaglia

	* NEWS, modules/mod_core.c, src/bindings.c: 
	Bug#2272 - Address/port collision check needs to handle
	DefaultAddress. The problem was that the address assigned by
	DefaultAddress was being assigned _after_ the addr/port collision
	check.

2003-11-08 14:45  castaglia

	* include/fsio.h, src/fsio.c: 
	Cleanup the FSIO API a little:
	
	  + some of the directory operation flags were improperly
	overloading file
	    operation flags
	  + change the prototype of the open/creat handlers to take a
	pointer to
	    a pr_fh_t (filehandle) rather than a pointer to a pr_fs_t
	(filesystem),
	    which allows the open/creat handlers to store file-specific
	data in
	    the handle (fh->fh_data), which was not possible when using the
	    filesystem pointer.
	  + added a new function, pr_remove_fs(), for removing a filesystem
	from
	    the map without explicitly destroying that filesystem object
	(as
	    pr_unregister_fs() will do automatically).
	  + some internal function stylistic renaming, which does not
	affect any
	    code outside of this file.

2003-11-08 14:34  castaglia

	* modules/mod_auth.c, src/main.c: 
	Using the new Event API, generate some events when key limits are
	exceeded.  Modules that register handlers for these events can now
	take appropriate action (such as blacklisting a client that has
	exceeded the MaxLoginAttempts).

2003-11-08 14:32  castaglia

	* src/event.c: 
	When unregistering an event handler, be sure to honor the module
	argument, if any.

2003-11-08 14:19  castaglia

	* Make.rules.in, NEWS, include/conf.h, include/event.h,
	modules/mod_core.c, src/event.c, src/main.c: 
	Adding Event API.

2003-11-08 12:40  castaglia

	* NEWS, contrib/mod_radius.c: 
	Bug#2255 - RADIUS Service-Type should reflect attribute
	expectations.

2003-11-08 12:30  castaglia

	* configure: 
	Updating configure.

2003-11-08 12:26  castaglia

	* NEWS, configure.in: 
	Bug#2271 - Improper autoconf check for getaddrinfo() on Tru64 UNIX
	5.1.

2003-11-08 11:40  castaglia

	* Make.rules.in: 
	Bug#2270 - Linkers can be quite picky about the order in which
	flags appear.

2003-11-05 20:43  castaglia

	* modules/mod_auth_file.c: 
	The new group membership debugging found a bug: mod_auth_file, when
	scanning an AuthGroupFile, would only add the group name if the ID
	for the group was different from the user's primary GID.  For GID
	stuff, this is fine; however, for group expressions in proftpd.conf
	that may rely on those group names, it's a bug.
	
	This allows for an interesting situation: assign a user to multiple
	groups with different names, but the same GID.	Thus you can
	workaround the NGROUPS_MAX system limit using a long list of group
	names; the operating system won't notice, and proftpd will happily
	check the names.  Nice.

2003-11-05 20:35  castaglia

	* src/auth.c: 
	Add debugging output for group name/ID retrieval.

2003-11-05 18:53  castaglia

	* src/auth.c: 
	Add debugging that shows the group IDs that end up being set via
	setgroups().

2003-11-05 16:13  castaglia

	* configure: 
	Updating configure.

2003-11-05 16:10  castaglia

	* config.h.in, configure.in, modules/mod_core.c: 
	Some platforms don't have setenv()/unsetenv().	Bummer.

2003-11-04 12:44  castaglia

	* src/scoreboard.c: 
	When deleting the scoreboard file (usu. when a standalone proftpd
	starts up), log a message if there is an existing scoreboard file
	that is being unlinked.

2003-11-02 16:42  jwm

	* contrib/dist/rpm/proftpd.spec: 
	- Bug 2265 - correct path to mysql headers   Submitted by:
	ncroiset@vdldiffusion.com (Nicolas Croiset) - note in the
	%changelog that it isn't updated often - use the CVS   revision
	history

2003-11-01 00:25  castaglia

	* contrib/mod_tls.html: 
	Update the mod_tls docs, now that Bug#2135's patch has been
	committed.

2003-11-01 00:14  castaglia

	* Makefile.in: 
	When preparing a distribution using the 'dist' target, be sure to
	clean up the .bak files generated by the 'clean' target.

2003-10-31 23:11  castaglia

	* include/pool.h, modules/mod_core.c, modules/mod_log.c,
	modules/mod_ls.c, src/auth.c, src/bindings.c, src/data.c,
	src/dirtree.c, src/feat.c, src/fsio.c, src/inet.c, src/log.c,
	src/main.c, src/modules.c, src/pool.c, src/regexp.c, src/support.c:
	
	Introduce a new function, pr_pool_tag().  This function is used to
	"tag" a given pool with an arbitrary label (given as a string
	constant).  The pool tags are shown in a pool dump (currently
	triggered using SIGUSR2).

2003-10-31 16:12  castaglia

	* include/log.h: 
	Add 10 as a debugging level.  I plan to use this level for
	debugging output about DNS resolution and supplemental group
	membership issues.

2003-10-31 15:57  castaglia

	* src/dirtree.c: 
	Add to proftpd's debugging verbosity by showing the
	dispatch/handling of configuration directives to the modules which
	handle that directive.

2003-10-31 11:50  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2098 - Add SetEnv, UnsetEnv directives.

2003-10-31 11:41  castaglia

	* NEWS, modules/mod_auth_unix.c: 
	Bug#2174 - mod_auth_unix should not act authoritatively.

2003-10-31 11:23  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2086 - Add <Limit> support for PORT, PASV, EPRT, EPSV.

2003-10-31 10:55  castaglia

	* NEWS, contrib/mod_tls.c: 
	Bug#2135 - Add ability to handle passphrase-protected server keys.

2003-10-31 10:46  castaglia

	* src/: data.c, dirtree.c, fsio.c, main.c, netio.c: 
	Silencing some valgrind complaints.  Style fixups.

2003-10-31 01:14  castaglia

	* include/version.h: 
	Woohoo! The start of a new release cycle...

2003-10-31 00:22  castaglia

	* ChangeLog: 
	Preparing for 1.2.9 release.

2003-10-31 00:10  castaglia

	* NEWS, include/version.h, contrib/dist/rpm/proftpd.spec: 
	Preparing for the release of 1.2.9.

2003-10-31 00:05  castaglia

	* NEWS: 
	Mention the memory leak fixes.

2003-10-31 00:02  castaglia

	* contrib/mod_sql.c: 
	Always expand %U to the USER name given, not just when session.user
	is NULL.

2003-10-30 23:22  castaglia

	* modules/mod_auth.c: 
	Undoing part of change made earlier: rather than removing a C_USER
	config_rec during both the LOG_CMD (success) and LOG_CMD_ERR
	(failure) command phases of the PASS command, only do the removal
	in LOG_CMD_ERR, which was the originally intended effect.  Doing
	the removal in the LOG_CMD handler causes trouble for modules that
	may want to use %U (e.g. mod_rewrite).

2003-10-30 12:38  flyhmstr

	* doc/: Configuration.html, Configuration.sgml, faq.html: 
	ML: New userguide (html & sgml) and faq built from current pdd
	sources     committed.

2003-10-28 10:41  castaglia

	* README.FreeBSD: 
	Adding FreeBSD package installation docs from Bug#2250.

2003-10-22 00:40  castaglia

	* src/main.c: 
	Removing duplicate sanity check.

2003-10-21 23:49  castaglia

	* src/fsio.c: 
	Fixing comments.  Have pr_insert_fs() set errno on error, for
	reporting purposes.

2003-10-20 18:44  castaglia

	* utils/utils.h: 
	It helps to make sure that the utils (ftpcount, ftpwho, ftptop)
	expect that the scoreboard entry has the same format as the core
	code (cf. size of the sce_client_addr field).

2003-10-20 15:20  castaglia

	* include/scoreboard.h: 
	Forgot to increase the size of the IP address buffer in the
	scoreboard if --enable-ipv6 is used.

2003-10-20 00:28  castaglia

	* modules/mod_log.c: 
	More paranoid checking of snprintf() usage.

2003-10-20 00:15  castaglia

	* contrib/: mod_radius.c, mod_sql.c, mod_tls.c: 
	Minor paranoia changes: make certain the buffer is NUL-terminated
	before calling strlen() on its contents.

2003-10-20 00:02  castaglia

	* NEWS, modules/mod_ls.c: 
	Check for excessive length of symlink directory listing entries,
	when ShowSymlinks is on.  This also requires that the platform
	_not_ provide MAXPATHLEN.  Added some style/spacing changes as
	well.

2003-10-19 14:45  jwm

	* NEWS, contrib/dist/rpm/proftpd.spec: 
	Bug 2197 - The RPM .spec has been updated for easy RPM builds from
	CVS snapshots.

2003-10-19 14:40  jwm

	* contrib/dist/rpm/proftpd.spec: rpm doesn't like empty
	BuildPreReqs, add a static dep on pam-devel

2003-10-18 16:48  castaglia

	* src/fsio.c: 
	Fixing a memory leak in the handling of structures used for
	tracking open directories.

2003-10-18 15:14  castaglia

	* src/dirtree.c: 
	Fixing a rather major memory pool leak.  A temporary pool was being
	allocated in dir_hide_file() (which is called rather often), but in
	the case where no HideFiles directive was configured (very common),
	that pool was not being destroyed.  Oops.

2003-10-17 08:39  castaglia

	* NEWS, include/netaddr.h, modules/mod_core.c, modules/mod_log.c,
	src/netaddr.c: 
	Bug#2204 - More reverse DNS resolutions problems.  A previous fix
	for systems that use gethostbyname2() (e.g. the BSDs, some Linux
	distributions) was not properly checking the return value from
	pr_netaddr_is_v4mapped(), and thus IPv4 addresses were not being
	resolved to their names.
	
	Bug#2242 - Parsing during rehashing was failing with an EPERM.	The
	problem was that configuration directive handlers (specifically,
	SyslogFacility and SystemLog) were using PRIVS_RELINQUISH, which
	caused later Includes to fail.	Configuration handlers should not
	use the PRIVS macros.

2003-10-17 06:19  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2181: fixing this bug (again) to work correctly in all cases.

2003-10-16 23:15  castaglia

	* include/fsio.h, include/inet.h, include/netio.h, src/fsio.c,
	src/inet.c, src/main.c, src/netio.c: 
	Removing the pr_ prefix from some API initialization functions;
	they are not really appropriate for module use.

2003-10-15 17:58  castaglia

	* include/version.h: 
	Updating the version for CVS status.

2003-10-15 12:54  castaglia

	* ChangeLog: 
	Updating ChangeLog.

2003-10-15 12:53  castaglia

	* NEWS, contrib/dist/rpm/proftpd.spec, include/version.h: 
	Preparing for release of 1.2.9rc3.

2003-10-15 07:15  jwm

	* contrib/dist/rpm/proftpd.spec: 
	only include xinetd support in the -xinetd RPM

2003-10-14 11:22  castaglia

	* src/netaddr.c: 
	Fixed pr_netaddr_get_dnsstr() to use the right family value when
	calling gethostbyname2().

2003-10-14 11:17  castaglia

	* src/main.c: 
	The free_proc_title() function is currently only used when
	--enable-devel has been configured.

2003-10-14 06:41  jwm

	* contrib/dist/rpm/proftpd.spec: 
	we're "The ProFTPD Project"

2003-10-13 00:27  castaglia

	* configure: 
	Updating configure.

2003-10-13 00:25  castaglia

	* configure.in, include/libsupp.h, lib/glibc-hstrerror.c: 
	Adding bundled glibc implementation of hsterror(), for those
	systems that don't have it already.

2003-10-13 00:15  castaglia

	* configure: 
	Updating configure.

2003-10-13 00:12  castaglia

	* config.h.in, configure.in: 
	Not all systems have the hsterror() function, for converting
	resolver error codes (h_errno) to strings.  Thus, we need to check
	for it, and provide a bundled replacement if it is not present. 
	I'll be adding the glibc implementation of hstrerror() soon.

2003-10-12 22:02  castaglia

	* src/netaddr.c: 
	This get_v4inaddr() function is only called from one place (at
	present), and all the necessary sanity checks have already been
	performed, so there is no need to do them again.

2003-10-11 12:32  castaglia

	* src/netaddr.c: 
	Typo.

2003-10-11 12:29  castaglia

	* src/netaddr.c: 
	The retrieval of the IPv4 portion of an IPv4-mapped IPv6 address is
	only necessary when gethostbyname2() is being used, rather than
	gethostbyname() (I think...this may need to change in the future).

2003-10-11 12:27  castaglia

	* src/netaddr.c: 
	When performing reverse DNS lookups on IPv4-mapped IPv6 addresses,
	we need to be a little more careful about which checks are
	performed.  This change alters the call to gethostbyname2() (when
	it is present) to be AF_INET if the netaddr is an IPv4-mapped IPv6
	address, rather than using AF_INET6 as was done previously.  The
	subsequent memcmps need to be adjusted accordingly.  This should
	hopefully resolve Bug#2204.

2003-10-11 10:01  castaglia

	* src/netaddr.c: 
	The BSDs are not the only systems that might provide
	gethostbyname2().  It seems that some Linux kernels have been
	patched to have that function as well.

2003-10-11 09:57  castaglia

	* include/netaddr.h, modules/mod_core.c, src/netaddr.c: 
	Since pr_netaddr_v4mappedv6() returns TRUE or FALSE (or -1 on
	error), I've renamed it to be pr_netaddr_is_v4mappedv6().

2003-10-10 11:11  castaglia

	* src/main.c: 
	Report the cause of error if configuration parsing fails.

2003-10-10 09:07  castaglia

	* modules/mod_core.c: 
	If processing an Included file fails, log the reason.

2003-10-09 23:36  castaglia

	* src/netaddr.c: 
	Adding note about a use of gethostbyname() that may need to be
	gethostbyname2() in the future.

2003-10-09 22:49  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2222 - Overlapping vhosts should warn instead of die.

2003-10-09 22:45  castaglia

	* src/dirtree.c: 
	No need to keep the server_recs of vhosts that cannot be resolved.

2003-10-09 22:37  castaglia

	* include/netaddr.h, src/dirtree.c, src/netaddr.c: 
	Removing the pr_netaddr_get_fqdn() function.  It was only being
	used in one place: to set the main_server->ServerFQDN member. 
	ServerFQDN is used in the logging prefix, and for vhosts, was
	usually the IP address.  With this change, the log prefix for
	entries generated by vhosts will be their DNS names (if possible). 
	It also removes a call to gethostbyname() which on *BSDs might not
	have performed as expected for IPv6 strings.

2003-10-09 18:30  castaglia

	* src/netaddr.c: 
	Make the logging of badly configured DNS name/IP address mappings a
	little less noisy.

2003-10-09 12:44  castaglia

	* configure: 
	Updating configure.

2003-10-09 12:40  castaglia

	* NEWS, config.h.in, configure.in, src/netaddr.c: 
	Bug#2204 - Reverse DNS lookups not happening properly on connected
	clients on FreeBSD.  We need to use gethostbyname2() on FreeBSD
	(and possibly the other BSDs).

2003-10-09 12:34  castaglia

	* NEWS, configure.in, src/netaddr.c: 
	Bug#2188 - Wildcard sockets not properly handled on FreeBSD.  Need
	to set sin_len/sin6_len struct sockaddr members, if present, for
	wildcard sockets.

2003-10-08 11:13  castaglia

	* NEWS, src/log.c: 
	Bug#2202 - AllowLogSymlinks check is flawed.

2003-10-07 22:38  castaglia

	* modules/mod_core.c: 
	Style cleanup (whitespace).

2003-10-07 21:48  castaglia

	* src/inet.c: 
	Adding note to pr_inet_set_proto_opts() about setsockopt() problems
	on IPv6 sockets.

2003-10-07 20:28  castaglia

	* configure: 
	Updating configure.

2003-10-07 20:25  castaglia

	* configure.in: 
	autoconf on FreeBSD was not properly reporting the headers it
	detected (or didn't): specifically, <netinet/in_systm.h> and
	<netinet/ip.h> were not being reported as found and useable in
	config.h.  The fix is to include a few more header dependencies in
	autoconf, so that autoconf's tests pass and the headers are
	properly reported as found.

2003-10-06 00:16  castaglia

	* contrib/mod_tls.c: 
	Be a little more careful in tls_blinding_on(): it's possible that
	SSL_get_privatekey() returns NULL, which I didn't check for.  This,
	I think, is causing segfaults on some systems (depending on the
	certificates used).

2003-10-05 20:53  castaglia

	* include/netaddr.h, src/data.c, src/main.c, src/netaddr.c: 
	Change pr_netaddr_reverse_dns() to be pr_netaddr_set_reverse_dns(),
	so that it has a verb in the function name (style nit, I know). 
	Also includes some capitalization and spacing cleanup in data.c.

2003-10-05 20:14  castaglia

	* NEWS: 
	Updating NEWS so that people can see that Bug#2183 (and all its
	friends) has been fixed.

2003-10-03 10:44  castaglia

	* Makefile.in: 
	Remove the generated 'stamp-h' file as well for the distclean
	target.

2003-10-01 07:21  castaglia

	* NEWS, contrib/mod_sql_mysql.c: 
	Bug#2191 - Segfault in mod_sql_mysql when using 'Backend'
	SQLAuthType.  This only happens for MySQL 4.1.	The MySQL
	make_scrambled_password() function changed in 4.1, and the wrong
	variable value was being used.

2003-10-01 06:16  castaglia

	* configure: 
	Updating configure.

2003-10-01 06:09  castaglia

	* config.h.in, configure.in: 
	Style cleanup in config.h.  Add check for <sys/mman.h> header file
	(will be needed if/when something wants to use the mmap(2) system
	call).

2003-09-30 23:35  castaglia

	* src/main.c: 
	Style cleanup, comment correction.  Also removed a double
	signal(SIGIO) call; first one set a handler for the signal, the
	second one caused the signal to be ignored.  Weird.

2003-09-30 23:25  castaglia

	* src/main.c: 
	Style cleanup.	Add a comment about needing PRIVS (or not) when
	disconnecting sessions.

2003-09-29 10:25  castaglia

	* src/bindings.c: 
	Fixed thinko highlighted by Bug#2188.

2003-09-28 21:48  castaglia

	* contrib/mod_tls.html: 
	Don't know what I was thinking.

2003-09-28 21:41  castaglia

	* contrib/mod_tls.html: 
	Grammar fix, adding description.

2003-09-28 17:00  castaglia

	* include/bindings.h, src/bindings.c, src/main.c: 
	The init_bindings() and free_bindings() functions are not suitable
	for use in modules, and so should not be in the pr_ namespace.

2003-09-28 16:56  castaglia

	* modules/mod_auth_unix.c: 
	It's possible for UID/GID lookups to occur outside of a session. 
	When this happens, session.pool is not valid.  Check for and handle
	this situation.  (This was causing segfaults when I attempt to use
	mod_ctrls.)

2003-09-28 15:43  castaglia

	* include/regexp.h, src/main.c, src/regexp.c: 
	The regexp init function shouldn't be in the pr_ namespace, as it
	is not suitable for use in module code.

2003-09-28 13:31  castaglia

	* modules/: mod_auth.c, mod_auth_unix.c: 
	Style cleanup.

2003-09-28 10:04  castaglia

	* src/dirtree.c: 
	One of the changes I made to quell a valgrind warning (something
	about reading possibly uninitialized memory, probably due to a
	zero-length path variable in this case) had disastrous side effects
	on directive lookups.  This highlights that the build_dyn_config()
	function needs comments and/or to be rewritten entirely.
	
	Also includes some style cleanup.

2003-09-27 15:16  castaglia

	* configure: 
	Updating configure.

2003-09-27 15:13  castaglia

	* configure.in, src/main.c: 
	Some of the pedantic memory cleanups added in 1.2.9rc2, after some
	time spent under valgrind, turn out to affect performance, when a
	session exits, particularly on busy machines.  So I've made these
	checks enabled only when proftpd is compiled using the
	--enable-devel flag.

2003-09-27 13:48  castaglia

	* NEWS, src/bindings.c: 
	Bug#2024 - DefaultServer not functioning properly.  The addition of
	the Bindings API in 1.2.8rc1 broke the DefaultServer directive in
	many configurations.  For inetd-run proftpds, all configured
	<VirtualHost> servers were being treated like they had
	"DefaultServer on", which meant that the last such configured
	server would be used, instead of the true DefaultServer.  For both
	inetd- and standalone-run proftpds, if no exactly matching vhost
	was found for a client, the localhost server (i.e. the "server
	config" vhost) would be used before the DefaultServer vhost.  Both
	problems are fixed by this change.

2003-09-27 11:40  castaglia

	* NEWS, src/data.c: 
	Bug#2200 - Correct segfaults with xlate_ascii_write() on IRIX. 
	Some of the last of the remaining code (whose I understood only
	partially, such as the session.xfer.buf++ increment) is now
	removed, as well as a potentially dangerous NUL-termination
	statement.

2003-09-26 12:02  jwm

	* contrib/dist/rpm/proftpd.spec: Bug 2197 - Spec file enhancements
	and fixes Submitted by: pb@bieringer.de (Dr. Peter Bieringer)

2003-09-25 23:53  castaglia

	* modules/mod_core.c: 
	Correcting a misleading/outdated comment.

2003-09-23 12:10  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2181 - Active IPv4 ftp doesn't work when using --enable-ipv6. 
	The fix was to build up an IPv6 netaddr from the PORT argument,
	rather than an IPv4 netaddr, in the case of --enable-ipv6.

2003-09-23 08:19  castaglia

	* NEWS: 
	Mention fixing of ASCII handling exploit.

2003-09-23 08:13  castaglia

	* src/data.c: 
	Fixing remote exploit in ASCII handling, discovered by X-Force at
	ISS:
	
	  http://xforce.iss.net/xforce/alerts/id/154

2003-09-23 07:45  jwm

	* contrib/dist/rpm/proftpd.spec: * Tue Sep 23 2003 Daniel Roesen
	<dr@proftpd.org> - Added "--with ipv6" to enable IPv6 support while
	building the RPM

2003-09-22 16:36  castaglia

	* README.IPv6: 
	Daniel has confirmed that IPv6 and FTP over SSL/TLS works just
	fine, for both active and passive transfers.

2003-09-19 13:21  castaglia

	* NEWS, include/privs.h: 
	Bug#2179 - ROOT_UID instead of ROOT_GID used in setegid() call. 
	This affects Cygwin installations.

2003-09-18 12:21  castaglia

	* src/netaddr.c: 
	Using EPERM makes more sense, I think, than EACCES in most of the
	pr_netaddr* cases.

2003-09-18 12:08  castaglia

	* NEWS, src/netaddr.c: 
	Bug#2176 - getnameinfo() error on Cygwin during startup.  The
	sa_family member of some addresses was not being properly
	initialized in some instances.

2003-09-14 13:49  castaglia

	* contrib/mod_wrap.html: 
	Typo.

2003-09-14 11:27  castaglia

	* src/scoreboard.c: 
	Actually check for error return values when locking the scoreboard.
	 A recently reported issue with the scoreboard on Solaris, under
	high load, may be related to this: fcntl() on Solaris is known to
	return ENOLCK under high load, if the requested lock hits the
	system lock limit.  By checking for the return values, proftpd can
	at least log if this ENOLCK is indeed the case.

2003-09-13 16:34  castaglia

	* configure: 
	Updating configure.

2003-09-13 16:29  castaglia

	* NEWS, README.IPv6, config.h.in, configure.in, src/netaddr.c: 
	Bug#2167 - getnameinfo() on FreeBSD doesn't support IP address
	lookups.
	
	FreeBSD's struct sockaddr_in and struct sockaddr_in6 have the
	sin_len and sin6_len members.  The code in pr_netaddr_get_addr()
	was not properly initializing these members, and so when those
	structs were given to getnameinfo(), getnameinfo() didn't handle
	them well.  Solaris and Linux don't have these _len members, so the
	problem didn't crop up there.
	
	IPv6 systems whose structs have these _len members are supposed to
	define the SIN6_LEN symbol, by RFC design.  However, it's possible
	that a system not support IPv6 and yet have the sin_len member and
	the getnameinfo() function.  So rather than just rely on SIN6_LEN
	being present, I added an autoconf check for the sin_len member,
	and an IPv4 SIN_LEN symbol.

2003-09-12 00:56  castaglia

	* README: 
	Just some pointers/notes about user questions.

2003-09-11 20:01  castaglia

	* README.IPv6: 
	Seems that perhaps FreeBSD's getnameinfo(3) doesn't like IP
	addresses, but it does handle DNS names correctly.  Interesting.

2003-09-11 13:11  castaglia

	* configure: 
	Updating configure.

2003-09-11 12:58  castaglia

	* configure.in: 
	Add another --enable-devel option: 'profile'.  When this option is
	used, compiler and linker flags for generating profile output (as
	for gprof(1)) are generated.  For this to work properly, one also
	needs to use the 'nodaemon' and 'nofork' options as well, e.g.:
	
	  ./configure --enable-devel=nodaemon:nofork:profile ...

2003-09-11 12:56  castaglia

	* include/version.h: 
	Updating version for CVS snapshots.

2003-09-11 06:39  castaglia

	* ChangeLog: 
	Updating ChangeLog.

2003-09-11 06:33  castaglia

	* NEWS, contrib/dist/rpm/proftpd.spec, include/version.h: 
	Let's get this rc2 show on the road.

2003-09-10 23:36  castaglia

	* include/conf.h: 
	Add note about possibly using sockaddr_storage in the future.

2003-09-10 07:02  castaglia

	* src/main.c: 
	Fixing PR_DEVEL_NO_DAEMON.

2003-09-09 14:15  castaglia

	* src/log.c: 
	Log the client's IP address in the brackets, not the DNS name.

2003-09-09 14:14  castaglia

	* src/netaddr.c: 
	When doing reverse DNS lookups, actually use the looked up name. 
	Oops.

2003-09-09 07:58  castaglia

	* utils/ftpshut.c: 
	Fix grammar in comment.

2003-09-09 07:57  castaglia

	* NEWS: 
	ftpshut's option -R (for remove), not -D (for delete).

2003-09-09 07:16  castaglia

	* NEWS, src/netio.c: 
	Bug#2122 - EAGAIN on Solaris can cause an infinite loop.

2003-09-08 22:37  castaglia

	* include/netaddr.h, modules/mod_core.c, src/inet.c, src/netaddr.c:
	
	Rename pr_netaddr_initialize() to be pr_netaddr_clear(), as that is
	what is really happening.

2003-09-08 19:49  castaglia

	* src/inet.c: 
	Remove duplicate comment.

2003-09-08 18:07  castaglia

	* src/inet.c: 
	Use the netaddr allocator where appropriate.

2003-09-08 18:04  castaglia

	* src/dirtree.c: 
	Remove cruft.  The multiple addresses for a server are handled
	elsewhere.

2003-09-08 17:55  castaglia

	* include/netaddr.h, src/netaddr.c: 
	Provide a netaddr allocator.

2003-09-08 17:32  castaglia

	* include/netaddr.h, modules/mod_core.c, src/inet.c, src/netaddr.c:
	
	Forgot to properly initialize pr_netaddr_t structs declared on the
	stack.	Provide a wrapper function for this, in case any of the
	default settings for a pr_netaddr_t need to change (in which case,
	providing an allocator as well, for pr_netaddr_t * declarations,
	will be necessary).
	
	Also fixed some tabs that crept into inet.c.

2003-09-07 19:58  castaglia

	* configure: 
	Updating configure.

2003-09-07 19:55  castaglia

	* include/inet.h, modules/mod_core.c, src/inet.c, src/netaddr.c: 
	Bug#2162 - Move pr_inet_ntop definition to include/inet.h.  Code
	cleanup.

2003-09-07 19:48  castaglia

	* configure.in: 
	Clean up configure.in a little, and just use LIB_OBJS (rather than
	both pr_lib_objs and LIB_OBJS).

2003-09-07 19:39  castaglia

	* configure: 
	Updating configure.

2003-09-07 19:35  castaglia

	* NEWS, configure.in: 
	Bug#2161 - Duplicate autoconf check for sia.h.

2003-09-07 17:56  castaglia

	* src/main.c: 
	Add a function to free up the memory allocated when moving the
	environment "out of the way" for use by setproctitle() et al;
	valgrind was complaining about this lost memory.  Also free up the
	permanent pool, and the free block list, when the daemon shuts
	down.

2003-09-07 17:53  castaglia

	* modules/mod_auth_unix.c: 
	Changing permanent_pool to session.pool where appropriate.  Also
	add a session exit callback that will call endpwent()/endgrent(),
	freeing up any memory that may have been allocated via
	setpwent()/setgrent().	Symmetry is a Good Thing.

2003-09-07 17:51  castaglia

	* modules/mod_auth_pam.c: 
	Removed an unnecessary check for a NULL pointer that will be given
	to free(3): the POSIX standard says that free() can handle a NULL
	pointer without choking.  Also, since mod_auth_pam handles the
	password, when the buffer which holds the password is freed, it
	should be scrubbed, rather than just using memset().

2003-09-07 17:42  castaglia

	* src/main.c: 
	Removing cruft, updating calls to subsystem initializers.

2003-09-07 17:41  castaglia

	* include/dirtree.h, src/dirtree.c: 
	Cleanup.  Fixed some timing and usages of sub pools, particularly
	in get_dir_ctxt().  Changed permanent_pool to be session.pool where
	appropriate.  Changed !strcmp() to be strcmp() == 0, and added some
	checks for paths of zero length (spotted by valgrind).

2003-09-07 17:39  castaglia

	* src/auth.c: 
	Removing cruft.  Also added some comments on the difference between
	the static make_cmd() function in this file, and the public
	pr_cmd_alloc() function.

2003-09-07 17:37  castaglia

	* src/fsio.c: 
	Style cleanup, mostly.	Using strcmp() == 0 rather than !strcmp()
	is a little clearer to most people.  Also fixed a bug where a pool
	was not being destroyed at the proper time.

2003-09-07 17:36  castaglia

	* src/data.c: 
	Use memcpy() rather than memmove(), as memcpy() is a little more
	efficient (it doesn't have to check the overlapping buffers). 
	Also, allocate one space for one more character, to account for the
	possibility of a LF as the first character in the buffer being
	adjusted (it would then need to be prefaced by a CR).

2003-09-07 17:33  castaglia

	* modules/: mod_auth_file.c, mod_core.c, mod_log.c: 
	Changed uses of permanent_pool to session.pool, as is more
	appropriate in most module code.

2003-09-07 17:32  castaglia

	* modules/mod_auth.c: 
	Changed some uses of permanent_pool here to be session.pool, as is
	more appropriate in most module code.

2003-09-07 17:31  castaglia

	* include/modules.h, src/modules.c: 
	Removing cruft.  The call_module_auth() and call_module_cmd()
	functions were duplicates of call_module(), so there is no need to
	keep them around.  Also fixed some of the pools being used when
	adding symbols to the stash.  Fixed a bug where the stash pool was
	not being properly allocated from permanent_pool (valgrind found
	this).

2003-09-07 17:29  castaglia

	* include/pool.h, src/pool.c: 
	Cleaning up the pool interface.  The pr_ prefix for initializing
	the pool code, as many of the subsystem initializers are not meant
	to be called by module code; the pr_ suffix is meant to denote the
	API for use by module authors.	Also fixed a possible
	alarm-blocking bug in destroy_pool().

2003-09-07 17:26  castaglia

	* include/inet.h, src/inet.c: 
	Removing cruft.  The iplist/niplist members of the conn_t struct
	were not being used anymore.  Also removed some unnecessary
	complexities (a macro, a cleanup handler).

2003-09-07 17:25  castaglia

	* contrib/mod_ratio.c: 
	Removing some cruft from the source code, which involves removing
	mod_ratio's use of one of the crufty functions.

2003-09-07 16:55  castaglia

	* modules/mod_cap.c: 
	A weekend with valgrind proved very enlightening.  This patch
	corrects several small leaks that were occurring when handling
	POSIX capabilities.

2003-09-07 16:54  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#2154 - SQL query loses shell information.

2003-09-06 10:44  castaglia

	* modules/mod_ls.c: 
	Another leak fixed.  In this case, listdir() was (inappropriately)
	setting pointers in the array--allocated and returned by
	sreaddir()--to NULL.  Those pointers were allocated using calloc()
	in sreaddir(), which meant that later, when listdir() went to free
	the memory, it couldn't -- the address was lost.  All better now.

2003-09-06 09:56  castaglia

	* src/data.c: 
	Fixing subtle off-by-one bug (thank you valgrind!).

2003-09-05 13:00  castaglia

	* src/pool.c: 
	Rename xmalloc, xcalloc, and xrealloc to be smalloc, scalloc, and
	srealloc ("s" for "safe", just like sstrncpy and sstrcat).  This
	moves these functions out of the way of dmalloc's symbols (and
	doesn't hurt proftpd at all).

2003-09-05 12:42  castaglia

	* include/conf.h: 
	Add conditional include for <dmalloc.h>, for use when using dmalloc
	to track memory usage.

2003-09-05 11:38  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#2153 - Small error in handling PR_AUTH_RFC2228 authentication
	code.

2003-09-03 13:18  castaglia

	* configure: 
	Updating configure.

2003-09-03 13:14  castaglia

	* NEWS, configure.in: 
	Bug#2007 - autoconf header detection problem.

2003-08-30 09:11  castaglia

	* configure: 
	Updating configure.

2003-08-30 09:07  castaglia

	* configure.in, include/libsupp.h, lib/glibc-gai_strerror.c,
	src/netaddr.c: 
	Partial fix for issues mentioned in Bug#2143: bundling
	gai_strerror(3) implementation (from glibc) in libsupp.a, to be
	used if the system does not provide a gai_strerror(3) function
	itself.

2003-08-29 10:20  castaglia

	* include/bindings.h, include/dirtree.h, src/bindings.c: 
	Add comments about the duplicate
	ipbind->ib_server->listen/ipbind->ib_listener pointers.  Also,
	correct the patch for Bug#2146 so that ib_server->listen is still
	handled properly (as it prior to the patch) in the Bindings API.

2003-08-29 10:01  castaglia

	* NEWS, include/bindings.h, src/bindings.c: 
	Bug#2146 - DNS names not handled properly when --enable-ipv6 is
	used.  As mentioned in the report, this was caused by a design
	assumption revealed by the addition of IPv6 support: that of a
	one-to-one association between a server_rec and its listening
	connection.  For DNS names resolving to A and AAAA records, there
	can be two listening connections for a given server_rec.  The fix
	occurs in the Bindings API, where a server_rec's listeners are now
	associated with the bindings for the server_rec, rather than with
	the server_rec itself.	Multiple bindings can point to the same
	server_rec.

2003-08-28 23:33  castaglia

	* src/netaddr.c: 
	Using uninitialized memory can be bad.

2003-08-28 22:44  castaglia

	* src/inet.c: 
	Only one type of IPv4 service at time: either IPTOS_LOWDELAY or
	IPTOS_THROUGHPUT but not both.
	
	Some discussion on IPng mailing list archives mention that using
	IP_TOS may be a problem on IPv6 connections...

2003-08-27 20:17  castaglia

	* README.ports: 
	Adding FreeBSD 4.9-PRERELEASE to the list.  Apparently the source
	works out-of-the-box.

2003-08-27 17:43  jwm

	* NEWS: 
	- Bug 2108 - IgnoreHidden should not hide dotfiles   Dotfiles are
	now displayed when the -a argument is supplied, even when the  
	IgnoreHidden directive is enabled. To replicate the old behavior of
	hiding	 dotfiles no matter what, use either of the following
	directives:	ListOptions "" strict	  HideFiles ^\..*

2003-08-27 17:40  jwm

	* modules/mod_ls.c: 
	Bug 2108 - IgnoreHidden should not hide dotfiles

2003-08-27 17:37  jwm

	* NEWS: 
	- Bug 1804 - RPM spec file improvements   The spec file now has
	xinetd support, builds under newer version of RPM,   installs
	standalone support with the main proftpd RPM, and accepts --with  
	mod_modname arguments during the build process.  - Bug 2127 - Entry
	in the file section   The RPM spec's %files section now honors the
	install prefix.

2003-08-27 17:36  jwm

	* contrib/dist/rpm/proftpd.spec: 
	Bug 2127 - Entry in the file section

2003-08-27 17:33  jwm

	* contrib/dist/rpm/xinetd: 
	add xinetd configuration to go with new .spec

2003-08-27 17:32  jwm

	* contrib/dist/rpm/proftpd.spec: 
	- don't reset servertype on upgrade - don't explicitly install docs
	- %doc should include them
	
	submitted by: Ivan F. Martinez <ivanfm@os2brasil.com.br> Peter
	Bieringer <pb@bieringer.de>

2003-08-22 10:29  castaglia

	* README.ports: 
	Adding NetBSD 1.6.1 to the list.

2003-08-19 18:57  castaglia

	* README.IPv6: 
	Add note about FreeBSD 4.8 and getnameinfo(3).

2003-08-18 13:13  castaglia

	* NEWS, src/dirtree.c: 
	Bug#2141 - Glob Allow/Deny parameters cause extraneous log messages
	when comparing addresses.

2003-08-16 10:01  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#2148 - Enforce PR_TUNABLE_LOGIN_MAX.

2003-08-16 08:47  castaglia

	* sample-configurations/mod_sql.conf: 
	Add comment in mod_sql sample config about SQLAuthTypes being
	required.

2003-08-16 08:43  castaglia

	* contrib/mod_sql.c: 
	Add log messages to session init if no SQLAuthTypes configured.

2003-08-16 08:38  castaglia

	* contrib/mod_sql.c: 
	Using mod_sql for authentication, but not configuring a
	SQLAuthTypes directive, would result in a segfault in the session
	process.  This patch catches the segfault, and adds a log message
	concerning the problem.

2003-08-14 18:33  castaglia

	* NEWS, contrib/mod_ifsession.c: 
	Fixed mod_ifsession's handling of multiple configuration sets.	The
	problem was that mod_ifsession, after merging in the configuration
	from a config_rec, would call xaset_remove() and remove that
	config_rec from the main server's configuration sets.  This had the
	side effect of making other config_recs in the set, in the set
	after the removed config_rec, no longer visible by the iterating
	function.  As in Perl: don't change the items in a list while
	iterating over it.  Instead, queue up the changes you want to make
	while iterating, wait until finished iterating, and then change the
	list.

2003-08-14 11:34  castaglia

	* include/netaddr.h, src/netaddr.c: 
	Rather than using typecasts to silence the compiler warnings about
	loss of the 'const' modifier in pr_netaddr_fnmatch(), simply remove
	the 'const' from the function signature.

2003-08-13 18:02  castaglia

	* NEWS, src/data.c: 
	Bug#2147 - Segmentation fault processing file in ASCII mode.

2003-08-13 12:11  castaglia

	* src/netaddr.c: 
	Silence some compiler warnings.

2003-08-13 11:54  castaglia

	* configure: 
	Updating configure script.

2003-08-13 11:50  castaglia

	* NEWS, configure.in: 
	Bug#2144 - Rework autoconf handling of --enable-sia option.

2003-08-13 09:04  castaglia

	* configure: 
	Updating configure script.

2003-08-12 23:26  castaglia

	* config.h.in, configure.in: 
	Check for gai_strerror(3).  We'll also need to provide an
	implementation if gai_strerror() is not present.

2003-08-12 23:21  castaglia

	* configure: 
	Updating configure script.

2003-08-12 23:07  castaglia

	* NEWS, configure.in, include/libsupp.h, include/support.h,
	lib/sstrncpy.c, src/support.c: 
	Bug#2142 - sstrncpy() not available to lib/vsnprintf.c.

2003-08-12 22:28  castaglia

	* src/inet.c: 
	It seems the 'sa_family' symbol is a macro on IRIX.

2003-08-12 10:07  castaglia

	* include/: conf.h, inet.h: 
	Move the conditional definitions of INET(6)_ADDRSTRLEN to conf.h,
	so that the definition of pr_netaddr_t can use them.  Sigh.

2003-08-11 22:59  castaglia

	* include/conf.h: 
	Can't use INET6_ADDRSTRLEN until include/inet.h is included, but
	the pr_netaddr_t needs to be typedef'd before then.  So we do it
	manually.

2003-08-10 23:31  castaglia

	* contrib/mod_sql.c: 
	Removing use of get_param_int() from mod_sql.

2003-08-10 23:07  castaglia

	* NEWS, modules/mod_ls.c: 
	Bug#2137 - NLST and IgnoreHidden causes segfault.

2003-08-10 21:41  castaglia

	* src/main.c: 
	Oops.  Calling of the postparse callbacks should happen after all
	the servers have been fixed up, in order to make sure that the
	modules see the "correct" server configuration data.

2003-08-10 21:37  castaglia

	* src/main.c: 
	Postparse callbacks should be called after the configuration has
	been parsed during a rehash, too.  Modules that wish to have
	postparse callbacks invoked during a rehash will need to have
	rehash handlers that register the postparse callback.

2003-08-09 09:37  castaglia

	* modules/mod_auth.c: 
	Previous changes to auth_scan_scoreboard() removed some checks that
	really needed to be there, to prevent segfaults when using
	configurations that did not use Classes.

2003-08-09 09:08  castaglia

	* src/inet.c: 
	Fixed function signature to match declared prototype.  Fixed
	variable name.

2003-08-09 01:09  castaglia

	* contrib/mod_ifsession.c, include/dirtree.h, modules/mod_auth.c,
	src/dirtree.c: 
	Spelling correction.

2003-08-09 00:50  castaglia

	* src/bindings.c: 
	Removed debugging cruft.

2003-08-09 00:22  castaglia

	* include/proftpd.h, src/netaddr.c: 
	Comment clarification, style fixups, fixing compiler warnings.

2003-08-08 15:15  castaglia

	* modules/mod_auth_file.c: 
	Fixed position of use of pr_signals() handle, so as not to occur
	before variable declaration in the case where HAVE_FGETPWENT is
	false/undef.

2003-08-08 08:10  castaglia

	* NEWS: 
	Fixed wrong bug report number.

2003-08-07 19:50  castaglia

	* include/netaddr.h: 
	Complete the description of pr_netaddr_fnmatch().

2003-08-07 13:16  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#2130 - %y in DisplayLogin is not updated correctly.  The
	problem was that the auth_scan_scoreboard() function, which scanned
	the scoreboard and tallied up the variables used when filling in
	%y/%N, was only being called if the DisplayConnect directive was
	used.  Instead, auth_scan_scoreboard() should always be called, to
	handle any of the Display* directives.

2003-08-07 11:24  castaglia

	* src/netaddr.c: 
	Added implementation of pr_netaddr_fnmatch().

2003-08-07 11:05  castaglia

	* include/netaddr.h, src/netaddr.c: 
	Added implementation (untested) of pr_netaddr_ncmp().  Changed the
	pr_netaddr*() routines to return EACCES if for some reason the	
	netaddrs on which they operate do not have a recognizable family
	(AF_INET   or AF_INET6).

2003-08-07 08:49  castaglia

	* include/netaddr.h, src/bindings.c, src/netaddr.c: 
	Added a pr_netaddr_get_inaddr_len(), to provide sizes of struct
	in{6}_addr, matching the pr_netaddr_get_sockaddr_len() function.
	
	Added a stub for pr_netaddr_fnmatch(), to be implemented soon.

2003-08-07 00:09  castaglia

	* include/netaddr.h, src/inet.c, src/netaddr.c: 
	Changed pr_netaddr_get_addrlen() to pr_netaddr_get_sockaddr_len(),
	to more clearly reflect the length returned.
	
	Added stub for pr_netaddr_ncmp(), to be implemented shortly.

2003-08-06 18:59  castaglia

	* README.IPv6: 
	Clarifying that IPv6 sockets handling IPv4 packets only occurs when
	it is an wildcard IPv6 socket.

2003-08-06 17:55  castaglia

	* NEWS: 
	Mention the --enable-ipv6 configure option.

2003-08-06 17:42  castaglia

	* include/netaddr.h: 
	Adding descriptions of the netaddr API functions.

2003-08-06 16:05  castaglia

	* include/inet.h: 
	Add some comments about the handling of get{addr,name}info symbols.
	 I'm not quite sure I have all the preprocessor logic for these
	symbols done correctly yet.

2003-08-06 15:31  castaglia

	* src/netaddr.c: 
	Typos.

2003-08-06 15:08  castaglia

	* configure: 
	Updating configure.

2003-08-06 15:03  castaglia

	* ChangeLog, Make.rules.in, NEWS, README.IPv6, config.h.in,
	configure.in, contrib/mod_ifsession.c, contrib/mod_radius.c,
	contrib/mod_ratio.c, contrib/mod_rewrite.c, contrib/mod_sql.c,
	contrib/mod_tls.c, include/bindings.h, include/conf.h,
	include/dirtree.h, include/ftp.h, include/inet.h, include/log.h,
	include/netaddr.h, include/proftpd.h, modules/mod_auth.c,
	modules/mod_core.c, modules/mod_log.c, src/bindings.c, src/data.c,
	src/dirtree.c, src/ident.c, src/inet.c, src/log.c, src/main.c,
	src/netaddr.c, src/scoreboard.c, utils/misc.c: 
	Bug#1711 - IPv6 support.  Let the IPv6 fun begin.

2003-08-06 00:07  castaglia

	* modules/mod_auth_file.c: 
	Fix code in case where fgetgrent(3) is not present on the system.

2003-08-01 17:30  castaglia

	* contrib/mod_sql_mysql.c: 
	MySQL-4.1.0 changed the signature for the make_scrambled_password()
	function, so we handle it by checking the MySQL version.  This
	commit also includes some style changes.

2003-07-31 18:05  castaglia

	* modules/mod_log.c, modules/mod_ls.c, modules/mod_site.c,
	src/data.c, src/dirtree.c, src/main.c, src/pool.c, src/support.c: 
	Style.

2003-07-31 18:03  castaglia

	* contrib/mod_radius.c, contrib/mod_rewrite.c, modules/mod_auth.c,
	modules/mod_auth_file.c, src/netio.c: 
	Adding signal handling in while() loops.

2003-07-30 11:01  castaglia

	* NEWS, contrib/mod_sql.c: 
	Bug#2118 - %F doesn't work for DELE command; %f is inconsistent. 
	This is exactly the reason why we really need a unified
	cookie/variable handling interface.  Too much code duplicated
	around in modules leads to out-of-sync code bugs like this.

2003-07-29 18:52  castaglia

	* contrib/mod_tls.c: 
	Removing unused code.

2003-07-29 18:34  castaglia

	* NEWS, contrib/mod_tls.c: 
	Close files that have been fopen()'d always, not just when
	conditions mean that no errors are encountered.

2003-07-29 10:46  castaglia

	* contrib/mod_tls.html: 
	Adding description of the $SSL_CERT_DIR TLSLog message

2003-07-29 08:15  castaglia

	* NEWS, modules/mod_core.c: 
	Bug#2119 - FEAT response format does not conform to RFC2389.

2003-07-29 07:36  castaglia

	* doc/rfc/: rfc2228.txt, rfc2389.txt, rfc2428.txt: 
	Style.

2003-07-28 15:57  castaglia

	* NEWS: 
	Mention fix of mod_tls directives.

2003-07-28 15:50  castaglia

	* contrib/mod_tls.c: 
	TLSCACertificateFile and TLSCACertificatePath are documented to be
	allowed in all server contexts, not just "server config"; the code
	was wrong.

2003-07-24 22:36  castaglia

	* sample-configurations/: anonymous.conf, complex-virtual.conf,
	mod_sql.conf, virtual.conf: 
	Style.

2003-07-24 18:21  jwm

	* include/pr-syslog.h: silence warning

2003-07-24 08:22  castaglia

	* NEWS, Makefile.in: 
	Bug#2115 - ftptop depends on snprintf but doesn't link in
	lib/libsupp.a

2003-07-23 19:44  castaglia

	* doc/rfc/rfc2428.txt: 
	IPv6 support _is_ going to be added Real Soon Now(tm), so we might
	as well as the relevant RFC.

2003-07-21 15:03  castaglia

	* NEWS, README.mod_sql, contrib/mod_sql.c: 
	Bug#2113 - mod_sql default uses mysql keyword.

2003-07-18 12:18  castaglia

	* include/proftpd.h, src/main.c: 
	Add two new members to the session struct: curr_cmd and curr_phase.
	 These are for storing pointers to the current FTP command name and
	current command handler phase, respectively.  They are useful for
	places like the FSIO API, where callbacks may want to take
	conditional action depending on the FTP command/phase at the time.

2003-07-16 11:48  castaglia

	* NEWS, include/dirtree.h, src/dirtree.c, src/main.c: 
	Bug#2110 - Segfault if gethostname(2) returns NULL.  When code was
	added to simply remove a server_rec whose name could not be
	resolved from the list, rather than halting the process there
	(which allows a more Apache-like handling of badly configured
	vhosts by logging/skipping, rather than choking), an edge case
	became possible where, after looping through all the server_recs,
	_none_ remained in the list.  This case was not being handled, and
	lead to a segfault later in the processing.  This patch checks for
	the case where no valid server_recs remain in the list.

2003-07-15 23:16  castaglia

	* contrib/mod_sql_mysql.c: 
	Spacing nit.

2003-07-14 19:57  castaglia

	* modules/mod_xfer.c: 
	Cruft.

2003-07-10 18:51  castaglia

	* NEWS, modules/mod_auth.c: 
	Bug#2103 - AuthAliasOnly in server context causes hang.

2003-07-10 09:09  jwm

	* contrib/mod_ldap.c: 
	release 2.8.12

2003-07-07 15:59  castaglia

	* contrib/mod_sql_mysql.c: 
	Typo.

2003-07-07 13:42  castaglia

	* contrib/: mod_sql_mysql.c, mod_sql_postgres.c: 
	Updating module names in comments.

2003-07-07 13:15  castaglia

	* NEWS: 
	Correcting handling of mod_tls TLSCertificateChainFile directive.

2003-07-07 13:13  castaglia

	* contrib/mod_tls.c: 
	Change the semantics of TLSCertificateChainFile slightly.  Now,
	this directive can be used to explicitly configure the chain of
	certs given to a peer during the TLS handshake.  Any server certs,
	configured using either CertificateFile or CertificatePath, are
	added to the list of CAs allowed for clients, but not for servers.

2003-07-07 11:27  castaglia

	* NEWS, modules/mod_core.c: 
